      REAL*8 FUNCTION ee_4f(p1,p2,p3,p4,p5,p6)

* impulsi p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),p6(0:3)
* prima particelle uscenti di tipo down, poi di tipo up
* 1 e+, 2 e-, 3 s, 4 d~, 5 u, 6 c~
* impulso w+ pwp=p5+p4 impulso w- pwm=p3+p6
* 1 e+, 2 e-, 3 e, 4 e~, 5 v, 6 v~
* Se c'e' una sola coppia di elettroni deve andare in posizione 34
* Se c'e' una sola coppia di neutrini elet. deve andare in posizone 56
* 1 e+, 2 e-, 3 u, 4 d~, 5 e-, 6 ve~
* prendo per canale t tutti propagatori senza massa immaginaria
*
* flags:
*      common/iflag/icc,icc3,i3e,i4e,i3q,i5q,iqu,i34e,i56ve,iid,
*     &  imix,icoul,istrcor
* icc  =1 solo CC, 0 solo NC , -1 entrambi
*    se icc diverso da 0
* icc3 =1 solo CC3, 0 altrimenti
* i3e  =1 3 e' elettrone, 0 altrimenti
* i4e  =1 4 e' e+, 0 altrimenti
* i3q  =1 3 e' quark, 0 altrimenti
* i5q  =1 3 e' quark, 0 altrimenti
*    se icc diverso da 1
* iqu  =1 entrambi coppie di NC sono quark, 0 altrimenti
* i34e =1 coppia 3 e 4 sono elettroni, 0 altrimenti
* i56ve =1 coppia 56 sono neutrini elettrone , 0 altrimenti
* iid  =1 particelle identiche nello stato finale, 0 altrimenti
*
* imix= 2 somma cc +interferenza con nc, 1 solo cc, 0 solo interferenza tra
*  cc e nc, -1 solo nc, -2 nc + interferenza con cc
* ibbveve =1 se processo e' quello indicato, 0 altrimenti
*  serve per tener conto di massa del top a quadrato nel denominatore del
*  propagatore di cn28
*
*  struttura del programma:
****      vettori di polarizzazione ee gamma , eezeta
**** inizio CC
*      if (icc.ne.0) then
****        diagrammi  cc3
*        if (icc3.ne.1) then
****        altri diagrammi per completare cc11
*          if (i3e.eq.1) then
****         diagrammi con elettrone uscente di cc
*          endif
*          if (i4e.eq.1) then
****         diagrammi con positrone uscente di cc
*          endif
*        endif
*      endif
****  fine CC
****  inizio NC
*      if (icc.ne.1) then
*        definizione vettori vet.k0 etc.
*        do ide=0,iid
*          if (iid.eq.1) then
*            p3<->p5
*            per rifare tutti i diagrammi con questo scambio per particelle id.
*          endif
****         24 diagrammi base di corrente neutra (6 per gamma e Z insieme)
*          if (iqu.eq.1) then
****         8 diagrammi di qcd (4)
*          endif
*          if (i34e.eq.1) then
****          24 con coppia 34 elettrone (6)
*          endif
*          if (i56ve.eq.1) then
****         diagrammi per correnti neutre con scambi di w (6)
*            if (i56ve.eq.1.and.iid.eq.1) then
****          diagrammi per correnti neutre con scambi di w (6) ottenuti da
****          quelli precedenti scambiando 56 con 34, necessari per 4 ve finali
*            endif
*          endif
*          if (iid.eq.1.and.i34e.eq.1) !anche 56 sono elettroni
*          !anche 56 sono elettroni
****          24 con coppia 56 elet.(come a i34.eq.1 con scambio coppie 35<->56)
*          endif
*        enddo
*       endif
**** fine NC
*
*  Nomenclatura per anomalous couplings
* e0 corrisponde a vettore di polarizzazione di gamma + zeta con coeff
*    opportuni, em a vettore di polarizzaz W-, ep a quello di W+
* p0 e' impulso uscente di gamma + zeta, pm quello di W-, pp quello di W+.
* Corrispondentemente ce0em e' prodotto scalare tra e0 e em, ce0pp e' prodotto
* scalare tra e0 e pp etc



      IMPLICIT REAL*8 (a-b,d-h,o-z)
      IMPLICIT double COMPLEX (c)

      DIMENSION p1(0:3),p2(0:3),p3(0:3),p4(0:3),p5(0:3),p6(0:3)
      DIMENSION pau(0:3),p12(0:3),p14(0:3),p16(0:3),p23(0:3),p25(0:3),
     &  p34(0:3),p36(0:3),p45(0:3),p56(0:3),
     &  p123(0:3),p125(0:3),p134(0:3),p136(0:3),p145(0:3),p156(0:3),
     &  p235(0:3),p345(0:3),p356(0:3)
      DIMENSION vfz(0:3),vwm(0:3),vwp(0:3)
      DIMENSION cc1(2),cc2(2),cc3(2),cc4(2),cc5(2),cc6(2)
      DIMENSION cc7(2),cc8(2),cc9(2),cc10(2),cc11(2),cc12(2)
      DIMENSION cc13(2),cc14(2),cc15(2),cc16(2),cc17(2),cc18(2)
      DIMENSION cc_3e(2),cc_4e(2)
* anomalous
      DIMENSION cau(2),ce0ep(2),ce0em(2),ce0pp(2),ce0pm(2)
      DIMENSION cpau(0:3)
*
      STRUCTURE/res/
      double COMPLEX id(0:1)
      END STRUCTURE
      RECORD/res/cn1(2,2,2),cn2(2,2,2),cn3(2,2,2),cn4(2,2,2),cn5(2,2,2),
     &    cn6(2,2,2),cn7(2,2,2),cn8(2,2,2),cn9(2,2,2),cn10(2,2,2),
     &    cn11(2,2,2),cn12(2,2,2),cn13(2,2,2),cn14(2,2,2),cn15(2,2,2),
     &    cn16(2,2,2),cn17(2,2,2),cn18(2,2,2),cn19(2,2,2),cn20(2,2,2),
     &    cn21(2,2,2),cn22(2,2,2),
     &    cn23(2),cn24(2),cn25(2),cn26(2),cn27(2),cn28,
     &    cn29(2),cn30(2),cn31(2),cn32(2),cn33(2),cn34,
     &    cn_4f(2,2,2),cn_34e(2,2,2),cn_56e(2,2,2),cn_34v(2),cn_56v(2),
     &    cn_qcd(2,2,2)

      STRUCTURE/polcom/
      double COMPLEX e(0:3),ek0,v
      END STRUCTURE
      RECORD/polcom/c12f(2),c12z(2),c12fz(2),c12fz3(2),c12fz4(2),
     &  c12fz5(2),c12fz6(2),c14f(2),c14z(2),c14w,c16f(2),c16z(2),c16w,
     &  c23w,c23f(2),c23z(2),c23fz(2),c23fz1(2),c23fz4(2),c23fz5(2),
     &  c25w,c25f(2),c25z(2),c34f(2),c34z(2),c34fz(2),
     &  c36w,c41f(2),c41z(2),c41fz(2),c41fz2(2),c41fz3(2),c41fz6(2),
     &  c52w,c54w,c56f(2),c56z(2),c56fz(2)

      STRUCTURE/tu/
      double COMPLEX a(2),c(2)
      END STRUCTURE
      RECORD/tu/l1_23w,l1_23(2),l1_23fz(2),l1_25w,l1_25fz(2),l1_34fz(2),
     &  l1_54w,l1_56fz(2),l3_12(2),l3_12fz(2),l3_14w,l3_14(2),
     &  l3_14fz(2),
     &  l3_16w,l3_16fz(2),l3_25w,l3_25fz(2),l3_54w,l3_56f(2),
     &  l3_56fz(2),l5_12(2),l5_12fz(2),l5_14(2),l5_14w,l5_14fz(2),
     &  l5_16w,
     &  l5_16fz(2),l5_23w,l5_23(2),l5_23fz(2),l5_34f(2),l5_34fz(2),
     &  l5_36w

      STRUCTURE/td/
      double COMPLEX a(2),b(2)
      END STRUCTURE
      RECORD/td/ r2_14w,r2_14(2),r2_14fz(2),r2_16w,r2_16fz(2),
     &  r2_34fz(2),r2_36w,r2_56fz(2),r4_12(2),r4_12fz(2),r4_16w,
     &  r4_16fz(2),r4_23w,r4_23(2),r4_23fz(2),r4_25w,r4_25fz(2),
     &  r4_36w,r4_56f(2),r4_56fz(2),r6_12(2),r6_12fz(2),r6_14w,
     &  r6_14(2),r6_14fz(2),r6_23w,r6_23(2),r6_23fz(2),r6_25w,
     &  r6_25fz(2),r6_34f(2),r6_34fz(2),r6_54w

      COMMON/abparb/rmw2,gamw,rmz2,rmt2,rcotw,pi,alfa_me,qcdcoupl,
     &  qcdcor_cc,qcdcor_nc,qcdcor_h
      COMMON/abparc/czipr,ccz,cwipr,ccw,chipr,cch,caipr,cca
      COMMON/abcoup/fer,fel,zer,zel,f3l,f4l,f5l,f6l,z3l,z4l,z5l,z6l,
     &       f3r,f4r,f5r,f6r,z3r,z4r,z5r,z6r,wcl,delz,xf,xz,yf,yz,zz
      COMMON/abflag/icc,icc3,i3e,i4e,i3q,i5q,iqu,i34e,i56ve,ibbveve,iid,
     &  imix,icoul,istrcor,idownl,idownr,ianc
*el2
     &  ,izz,izg,izg34,izg56,inc08,igamgam,itch
*endel2

      PARAMETER (czero=(0.d0,0.d0),cuno=(1.d0,0.d0),cim=(0.d0,1.d0))



* pk0 -- p=p1
      p1k0=p1(0)-p1(1)
* pk0 -- p=p2
      p2k0=p2(0)-p2(1)
* pk0 -- p=p3
      p3k0=p3(0)-p3(1)
* pk0 -- p=p4
      p4k0=p4(0)-p4(1)
* pk0 -- p=p5
      p5k0=p5(0)-p5(1)
* pk0 -- p=p6
      p6k0=p6(0)-p6(1)

*   Impulsi dei propagatori
      DO m=0,3
        p12(m)=-p1(m)-p2(m)
        p14(m)=-p1(m)+p4(m)
        p16(m)=-p1(m)+p6(m)
        p23(m)=-p2(m)+p3(m)
        p25(m)=-p2(m)+p5(m)
        p34(m)=p3(m)+p4(m)
        p36(m)=p3(m)+p6(m)
        p45(m)=p5(m)+p4(m)
        p56(m)=p5(m)+p6(m)
        p123(m)=p12(m)+p3(m)
        p125(m)=-p1(m)+p25(m)
        p134(m)=-p1(m)+p34(m)
        p136(m)=p16(m)+p3(m)
        p145(m)=-p1(m)+p45(m)
        p156(m)=p5(m)+p16(m)
        p235(m)=p25(m)+p3(m)
        p345(m)=p34(m)+p5(m)
        p356(m)=p36(m)+p5(m)
      END DO

* pk0 -- p=p123
      p123k0=p123(0)-p123(1)
* p.q -- p.q=p123q,p=p123,q=p123
      p123q=p123(0)*p123(0)-p123(1)*p123(1)-p123(2)*p123(2)-p123
     &  (3)*p123(3)
* pk0 -- p=p125
      p125k0=p125(0)-p125(1)
* p.q -- p.q=p125q,p=p125,q=p125
      p125q=p125(0)*p125(0)-p125(1)*p125(1)-p125(2)*p125(2)-p125
     &  (3)*p125(3)
* pk0 -- p=p134
      p134k0=p134(0)-p134(1)
* p.q -- p.q=p134q,p=p134,q=p134
      p134q=p134(0)*p134(0)-p134(1)*p134(1)-p134(2)*p134(2)-p134
     &  (3)*p134(3)
* pk0 -- p=p145
      p145k0=p145(0)-p145(1)
* p.q -- p.q=p145q,p=p145,q=p145
      p145q=p145(0)*p145(0)-p145(1)*p145(1)-p145(2)*p145(2)-p145
     &  (3)*p145(3)
* pk0 -- p=p156
      p156k0=p156(0)-p156(1)
* p.q -- p.q=p156q,p=p156,q=p156
      p156q=p156(0)*p156(0)-p156(1)*p156(1)-p156(2)*p156(2)-p156
     &  (3)*p156(3)
* pk0 -- p=p235
      p235k0=p235(0)-p235(1)
* p.q -- p.q=p235q,p=p235,q=p235
      p235q=p235(0)*p235(0)-p235(1)*p235(1)-p235(2)*p235(2)-p235
     &  (3)*p235(3)
* pk0 -- p=p136
      p136k0=p136(0)-p136(1)
* p.q -- p.q=p136q,p=p136,q=p136
      p136q=p136(0)*p136(0)-p136(1)*p136(1)-p136(2)*p136(2)-p136
     &  (3)*p136(3)
* pk0 -- p=p345
      p345k0=p345(0)-p345(1)
* p.q -- p.q=p345q,p=p345,q=p345
      p345q=p345(0)*p345(0)-p345(1)*p345(1)-p345(2)*p345(2)-p345
     &  (3)*p345(3)
* pk0 -- p=p356
      p356k0=p356(0)-p356(1)
* p.q -- p.q=p356q,p=p356,q=p356
      p356q=p356(0)*p356(0)-p356(1)*p356(1)-p356(2)*p356(2)-p356
     &  (3)*p356(3)


* p.q -- p.q=p1p2,p=p1,q=p2
      p1p2=p1(0)*p2(0)-p1(1)*p2(1)-p1(2)*p2(2)-p1(3)*p2(3)

      s=2.d0*p1p2
      ss=sqrt(s)
      E=ss/2.d0


* vettori di polarizzazione e+e-
      quqd=p1p2

* il - qui e in cdw e' perche' i propagatori bosonici portano un segno -
* rispetto a quelli fermionici
      cdz=-1.d0/(s*czipr-rmz2+ccz)
      df=-1.d0/s
      fac1=(df*fer)
      fac2=(df*fel)
      cfac1z=(cdz*zer)/fac1
      cfac2z=(cdz*zel)/fac2

* T10 -- qu=p1,qd=p2,v=0,a=c12f(&).e(0),cr=fac1,cl=fac2,nsum=0
      eps_0=-p1(2)*p2(3)+p2(2)*p1(3)
      ceps_0=eps_0*cim
      auxa=-quqd+p1k0*p2(0)+p2k0*p1(0)
      c12f(1).e(0)=fac1*(auxa+ceps_0)
      c12f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p2,v=1,a=c12f(&).e(1),cr=fac1,cl=fac2,nsum=0
      auxa=-quqd+p1k0*p2(1)+p2k0*p1(1)
      c12f(1).e(1)=fac1*(auxa+ceps_0)
      c12f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p2,v=2,a=c12f(&).e(2),cr=fac1,cl=fac2,nsum=0
      eps_0=-p1k0*p2(3)+p2k0*p1(3)
      ceps_0=eps_0*cim
      auxa=p1k0*p2(2)+p2k0*p1(2)
      c12f(1).e(2)=fac1*(auxa+ceps_0)
      c12f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p2,v=3,a=c12f(&).e(3),cr=fac1,cl=fac2,nsum=0
      eps_0=p1k0*p2(2)-p2k0*p1(2)
      ceps_0=eps_0*cim
      auxa=p1k0*p2(3)+p2k0*p1(3)
      c12f(1).e(3)=fac1*(auxa+ceps_0)
      c12f(2).e(3)=fac2*(auxa-ceps_0)

      DO mu=0,3
        c12z(1).e(mu)=cfac1z*c12f(1).e(mu)
        c12z(2).e(mu)=cfac2z*c12f(2).e(mu)
      END DO

      DO i=1,2
* pk0 -- p=c12f(i).e
        c12f(i).ek0=c12f(i).e(0)-c12f(i).e(1)
      END DO
      DO i=1,2
* pk0 -- p=c12z(i).e
        c12z(i).ek0=c12z(i).e(0)-c12z(i).e(1)
      END DO

**** inizio CC

      IF (icc.NE.0) THEN

* vettori di polarizzazione wp: w+ -> 5 4
* quqd -- p=p5,q=p4
        quqd=p5(0)*p4(0)-p5(1)*p4(1)-p5(2)*p4(2)-p5(3)*p4(3)
        s54=2.d0*quqd
        cdw=-1.d0/(s54*cwipr-rmw2+ccw)
        cfaw=(cdw*wcl)

* p5 non puo' che avere la polarizzazione 2, percio' non si somma sulle polariz
* zazioni dei quark
* TW10 -- qu=p5,qd=p4,v=0,a=c54w.e(0),cl=cfaw,nsum=0
        eps_0=-p5(2)*p4(3)+p4(2)*p5(3)
        ceps_0=eps_0*cim
        auxa=-quqd+p5k0*p4(0)+p4k0*p5(0)
        c54w.e(0)=cfaw*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p4,v=1,a=c54w.e(1),cl=cfaw,nsum=0
        auxa=-quqd+p5k0*p4(1)+p4k0*p5(1)
        c54w.e(1)=cfaw*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p4,v=2,a=c54w.e(2),cl=cfaw,nsum=0
        eps_0=-p5k0*p4(3)+p4k0*p5(3)
        ceps_0=eps_0*cim
        auxa=p5k0*p4(2)+p4k0*p5(2)
        c54w.e(2)=cfaw*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p4,v=3,a=c54w.e(3),cl=cfaw,nsum=0
        eps_0=p5k0*p4(2)-p4k0*p5(2)
        ceps_0=eps_0*cim
        auxa=p5k0*p4(3)+p4k0*p5(3)
        c54w.e(3)=cfaw*(auxa-ceps_0)
* pk0 -- p=c54w.e
        c54w.ek0=c54w.e(0)-c54w.e(1)

* vettori di polarizzazione ewm: w- -> 3 6
* quqd -- p=p3,q=p6
        quqd=p3(0)*p6(0)-p3(1)*p6(1)-p3(2)*p6(2)-p3(3)*p6(3)
        s36=2.d0*quqd
        cdw=-1.d0/(s36*cwipr-rmw2+ccw)
        cfaw=(cdw*wcl)

* p3 non puo' che avere la polarizzazione 2, percio' non si somma sulle polariz
* zazioni dei quark
* TW10 -- qu=p3,qd=p6,v=0,a=c36w.e(0),cl=cfaw,nsum=0
        eps_0=-p3(2)*p6(3)+p6(2)*p3(3)
        ceps_0=eps_0*cim
        auxa=-quqd+p3k0*p6(0)+p6k0*p3(0)
        c36w.e(0)=cfaw*(auxa-ceps_0)
* TW10 -- qu=p3,qd=p6,v=1,a=c36w.e(1),cl=cfaw,nsum=0
        auxa=-quqd+p3k0*p6(1)+p6k0*p3(1)
        c36w.e(1)=cfaw*(auxa-ceps_0)
* TW10 -- qu=p3,qd=p6,v=2,a=c36w.e(2),cl=cfaw,nsum=0
        eps_0=-p3k0*p6(3)+p6k0*p3(3)
        ceps_0=eps_0*cim
        auxa=p3k0*p6(2)+p6k0*p3(2)
        c36w.e(2)=cfaw*(auxa-ceps_0)
* TW10 -- qu=p3,qd=p6,v=3,a=c36w.e(3),cl=cfaw,nsum=0
        eps_0=p3k0*p6(2)-p6k0*p3(2)
        ceps_0=eps_0*cim
        auxa=p3k0*p6(3)+p6k0*p3(3)
        c36w.e(3)=cfaw*(auxa-ceps_0)
* pk0 -- p=c36w.e
        c36w.ek0=c36w.e(0)-c36w.e(1)

* diagrammi con triplo vertice
        IF (ianc.EQ.0) THEN
          DO i=1,2
            DO mu=0,3
              c12fz(i).e(mu)=c12f(i).e(mu)+rcotw*c12z(i).e(mu)
            END DO
          END DO
        ELSE
          DO i=1,2
            DO mu=0,3
              c12fz(i).e(mu)=c12f(i).e(mu)+(rcotw+delz)*c12z(i).e(mu)
            END DO
          END DO
        ENDIF
*** triple vertex -- pfz(mu)=p12(mu),pwm(mu)=p36(mu),pwp(mu)=p45(mu),efz=c1
* 2fz(i),ewm=c36w,ewp=c54w,res=cc1(i?)
        DO mu=0,3
          vfz(mu)=p36(mu)-p45(mu)
          vwm(mu)=p45(mu)-p12(mu)
          vwp(mu)=p12(mu)-p36(mu)
        END DO !mu
* vfz.efz
        DO i=1,2
* p.q -- p.q=c12fz(i).v,p=c12fz(i).e,q=vfz
          c12fz(i).v=c12fz(i).e(0)*vfz(0)-c12fz(i).e(1)*vfz(1)-c12fz
     &      (i).e(2)*vfz(2)-c12fz(i).e(3)*vfz(3)
        END DO
* vwm.ewm
* p.q -- p.q=c36w.v,p=c36w.e,q=vwm
        c36w.v=c36w.e(0)*vwm(0)-c36w.e(1)*vwm(1)-c36w.e(2)*vwm(2)-
     &    c36w.e(3)*vwm(3)
* vwp.ewp
* p.q -- p.q=c54w.v,p=c54w.e,q=vwp
        c54w.v=c54w.e(0)*vwp(0)-c54w.e(1)*vwp(1)-c54w.e(2)*vwp(2)-
     &    c54w.e(3)*vwp(3)
* efz.ewm
        DO i=1,2
* p.q -- p.q=caux,p=c12fz(i).e,q=c36w.e
          caux=c12fz(i).e(0)*c36w.e(0)-c12fz(i).e(1)*c36w.e(1)-c12fz
     &      (i).e(2)*c36w.e(2)-c12fz(i).e(3)*c36w.e(3)
          cc1(i)=c54w.v*caux
        END DO
* efz.ewp
        DO i=1,2
* p.q -- p.q=caux,p=c12fz(i).e,q=c54w.e
          caux=c12fz(i).e(0)*c54w.e(0)-c12fz(i).e(1)*c54w.e(1)-c12fz
     &      (i).e(2)*c54w.e(2)-c12fz(i).e(3)*c54w.e(3)
          cc1(i)=cc1(i)+c36w.v*caux
        END DO
* ewm.ewp
* p.q -- p.q=caux,p=c36w.e,q=c54w.e
        caux=c36w.e(0)*c54w.e(0)-c36w.e(1)*c54w.e(1)-c36w.e(2)*c54
     &    w.e(2)-c36w.e(3)*c54w.e(3)
        DO i=1,2
          cc1(i)=cc1(i)+c12fz(i).v*caux
        END DO

* anomalous couplings
        IF (ianc.NE.0) THEN
* p.q -- p.q=cemp0,p=c36w.e,q=p12
          cemp0=c36w.e(0)*p12(0)-c36w.e(1)*p12(1)-c36w.e(2)*p12(2)-c
     &      36w.e(3)*p12(3)
* p.q -- p.q=cepp0,p=c54w.e,q=p12
          cepp0=c54w.e(0)*p12(0)-c54w.e(1)*p12(1)-c54w.e(2)*p12(2)-c
     &      54w.e(3)*p12(3)

          IF (xf.NE.0.d0.OR.xz.NE.0.d0) THEN
            DO i=1,2
              DO mu=0,3
                c12fz(i).e(mu)=xf*c12f(i).e(mu)+xz*c12z(i).e(mu)
              END DO
            END DO
            DO i=1,2
* p.q -- p.q=ce0em(i),p=c12fz(i).e,q=c36w.e
              ce0em(i)=c12fz(i).e(0)*c36w.e(0)-c12fz(i).e(1)*c36w.e(1)-c
     &          12fz(i).e(2)*c36w.e(2)-c12fz(i).e(3)*c36w.e(3)
            END DO
            DO i=1,2
* p.q -- p.q=ce0ep(i),p=c12fz(i).e,q=c54w.e
              ce0ep(i)=c12fz(i).e(0)*c54w.e(0)-c12fz(i).e(1)*c54w.e(1)-c
     &          12fz(i).e(2)*c54w.e(2)-c12fz(i).e(3)*c54w.e(3)
            END DO
            DO i=1,2
              cc1(i)=cc1(i)+ce0em(i)*cepp0-ce0ep(i)*cemp0
            END DO
          ENDIF

          IF (yf.NE.0.d0.OR.yz.NE.0.d0) THEN
            DO i=1,2
              DO mu=0,3
                c12fz(i).e(mu)=yf*c12f(i).e(mu)+yz*c12z(i).e(mu)
              END DO
            END DO
            DO i=1,2
* p.q -- p.q=ce0em(i),p=c12fz(i).e,q=c36w.e
              ce0em(i)=c12fz(i).e(0)*c36w.e(0)-c12fz(i).e(1)*c36w.e(1)-c
     &          12fz(i).e(2)*c36w.e(2)-c12fz(i).e(3)*c36w.e(3)
            END DO
            DO i=1,2
* p.q -- p.q=ce0ep(i),p=c12fz(i).e,q=c54w.e
              ce0ep(i)=c12fz(i).e(0)*c54w.e(0)-c12fz(i).e(1)*c54w.e(1)-c
     &          12fz(i).e(2)*c54w.e(2)-c12fz(i).e(3)*c54w.e(3)
            END DO
            DO i=1,2
* p.q -- p.q=ce0pm(i),p=c12fz(i).e,q=p36
              ce0pm(i)=c12fz(i).e(0)*p36(0)-c12fz(i).e(1)*p36(1)-c12fz(i
     &          ).e(2)*p36(2)-c12fz(i).e(3)*p36(3)
            END DO
            DO i=1,2
* p.q -- p.q=ce0pp(i),p=c12fz(i).e,q=p45
              ce0pp(i)=c12fz(i).e(0)*p45(0)-c12fz(i).e(1)*p45(1)-c12fz(i
     &          ).e(2)*p45(2)-c12fz(i).e(3)*p45(3)
            END DO
* p.q -- p.q=cemep,p=c36w.e,q=c54w.e
            cemep=c36w.e(0)*c54w.e(0)-c36w.e(1)*c54w.e(1)-c36w.e(2)*c5
     &        4w.e(2)-c36w.e(3)*c54w.e(3)
* p.q -- p.q=cempp,p=c36w.e,q=p45
            cempp=c36w.e(0)*p45(0)-c36w.e(1)*p45(1)-c36w.e(2)*p45(2)-c
     &        36w.e(3)*p45(3)
* p.q -- p.q=ceppm,p=c54w.e,q=p36
            ceppm=c54w.e(0)*p36(0)-c54w.e(1)*p36(1)-c54w.e(2)*p36(2)-c
     &        54w.e(3)*p36(3)
* p.q -- p.q=p0pm,p=p12,q=p36
            p0pm=p12(0)*p36(0)-p12(1)*p36(1)-p12(2)*p36(2)-p12(3)*p36(
     &        3)
* p.q -- p.q=p0pp,p=p12,q=p45
            p0pp=p12(0)*p45(0)-p12(1)*p45(1)-p12(2)*p45(2)-p12(3)*p45(
     &        3)
* p.q -- p.q=pmpp,p=p36,q=p45
            pmpp=p36(0)*p45(0)-p36(1)*p45(1)-p36(2)*p45(2)-p36(3)*p45(
     &        3)
            DO i=1,2
              cc1(i)=cc1(i)+ce0pm(i)*cepp0*cempp-ce0pp(i)*ceppm*cemp0+
     &          p0pp*(ce0em(i)*ceppm-cemep*ce0pm(i))+
     &          p0pm*(cemep*ce0pp(i)-ce0ep(i)*cempp)+
     &          pmpp*(ce0ep(i)*cemp0-ce0em(i)*cepp0)
            END DO

          ENDIF
          IF (zz.NE.0.d0) THEN
            DO m=0,3
              cpau(m)=cepp0*c36w.e(m)-cemp0*c54w.e(m)
              pau(m)=p45(m)-p36(m)
            ENDDO
            DO i=1,2
* eps -- eps=cau(i),p=c12z(i).e,q=cpau,r=p12,s=pau
              cau(i)=c12z(i).e(0)*(cpau(1)*(p12(2)*pau(3)-p12(3)*pau(2))
     &          +cpau(2)*(p12(3)*pau(1)-p12(1)*pau(3))+cpau(3)*(p12(1)
     &          *pa
     &          u(2)-p12(2)*pau(1)))
              cau(i)=cau(i)-c12z(i).e(1)*(cpau(2)*(p12(3)*pau(0)-p12(0)*
     &          pau(3))+cpau(3)*(p12(0)*pau(2)-p12(2)*pau(0))+cpau(0)
     &          *(p1
     &          2(2)*pau(3)-p12(3)*pau(2)))
              cau(i)=cau(i)+c12z(i).e(2)*(cpau(3)*(p12(0)*pau(1)-p12(1)*
     &          pau(0))+cpau(0)*(p12(1)*pau(3)-p12(3)*pau(1))+cpau(1)
     &          *(p1
     &          2(3)*pau(0)-p12(0)*pau(3)))
              cau(i)=cau(i)-c12z(i).e(3)*(cpau(0)*(p12(1)*pau(2)-p12(2)*
     &          pau(1))+cpau(1)*(p12(2)*pau(0)-p12(0)*pau(2))+cpau(2)
     &          *(p1
     &          2(0)*pau(1)-p12(1)*pau(0)))
            END DO
            DO i=1,2
              cc1(i)=cc1(i)+cim*zz*cau(i)
            ENDDO
          ENDIF
        ENDIF
* end anomalous couplings

* diagramma con neutrino
* quqd -- p=p1,q=p145
        quqd=p1(0)*p145(0)-p1(1)*p145(1)-p1(2)*p145(2)-p1(3)*p145(
     &    3)
* TWL0 -- qu=p1,qd=p145,v=c54w.e,a=l1_54w.a,c=l1_54w.c,cl=wcl,nsum=0
        ceps_0=-c54w.ek0*(p1(2)*p145(3)-p145(2)*p1(3))+p1k0*(c54w.
     &    e(2)*p145(3)-p145(2)*c54w.e(3))-p145k0*(c54w.e(2)*p1(3)-p
     &    1(2)*c54w.e(3))
        ceps_0=ceps_0*cim
        ceps_1=-c54w.e(3)*p1k0+p1(3)*c54w.ek0
        ceps_1=ceps_1*cim
        cvqu=c54w.e(0)*p1(0)-c54w.e(1)*p1(1)-c54w.e(2)*p1(2)-c54w.
     &    e(3)*p1(3)
        cvqd=c54w.e(0)*p145(0)-c54w.e(1)*p145(1)-c54w.e(2)*p145(2)
     &    -c54w.e(3)*p145(3)
        cauxa=-c54w.ek0*quqd+p1k0*cvqd+p145k0*cvqu
        cauxc=+c54w.ek0*p1(2)-p1k0*c54w.e(2)
        l1_54w.a(2)=wcl*(cauxa-ceps_0)
        l1_54w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p145,q=p2
        quqd=p145(0)*p2(0)-p145(1)*p2(1)-p145(2)*p2(2)-p145(3)*p2(
     &    3)
* TWR0 -- qu=p145,qd=p2,v=c36w.e,a=r2_36w.a,b=r2_36w.b,cl=wcl,nsum=0
        ceps_0=-c36w.ek0*(p145(2)*p2(3)-p2(2)*p145(3))+p145k0*(c36
     &    w.e(2)*p2(3)-p2(2)*c36w.e(3))-p2k0*(c36w.e(2)*p145(3)-p14
     &    5(2)*c36w.e(3))
        ceps_0=ceps_0*cim
        ceps_2=-c36w.e(3)*p2k0+p2(3)*c36w.ek0
        ceps_2=ceps_2*cim
        cvqu=c36w.e(0)*p145(0)-c36w.e(1)*p145(1)-c36w.e(2)*p145(2)
     &    -c36w.e(3)*p145(3)
        cvqd=c36w.e(0)*p2(0)-c36w.e(1)*p2(1)-c36w.e(2)*p2(2)-c36w.
     &    e(3)*p2(3)
        cauxa=-c36w.ek0*quqd+p145k0*cvqd+p2k0*cvqu
        cauxb=-c36w.ek0*p2(2)+p2k0*c36w.e(2)
        r2_36w.a(2)=wcl*(cauxa-ceps_0)
        r2_36w.b(1)=wcl*(cauxb-ceps_2)
* TLTR0_W -- aa=cc2(&),a1=l1_54w.a,c1=l1_54w.c,a2=r2_36w.a,b2=r2_36w.b,prq=
* p145q,den=(p145q*p145k0),nsum=0
        cc2(2)=( l1_54w.c(2)*p145q*r2_36w.b(1)+l1_54w.a(2)*r2_36w.
     &    a(2) )/(p145q*p145k0)

        IF (icc3.NE.1) THEN
**** altri diagrammi per CC11
* polarizzazioni per attaccamenti solo left di f e Z a fermioni
          DO i=1,2
            DO mu=0,3
              c12fz5(i).e(mu)=c12f(i).e(mu)*f5l
     &          +c12z(i).e(mu)*z5l
            END DO
          END DO
          DO i=1,2
* pk0 -- p=c12fz5(i).e
            c12fz5(i).ek0=c12fz5(i).e(0)-c12fz5(i).e(1)
          END DO
          DO i=1,2
            DO mu=0,3
              c12fz3(i).e(mu)=c12f(i).e(mu)*f3l
     &          +c12z(i).e(mu)*z3l
            END DO
          END DO
          DO i=1,2
* pk0 -- p=c12fz3(i).e
            c12fz3(i).ek0=c12fz3(i).e(0)-c12fz3(i).e(1)
          END DO
          DO i=1,2
            DO mu=0,3
              c12fz6(i).e(mu)=c12f(i).e(mu)*f6l
     &          +c12z(i).e(mu)*z6l
            END DO
          END DO
          DO i=1,2
* pk0 -- p=c12fz6(i).e
            c12fz6(i).ek0=c12fz6(i).e(0)-c12fz6(i).e(1)
          END DO
          DO i=1,2
            DO mu=0,3
              c12fz4(i).e(mu)=c12f(i).e(mu)*f4l
     &          +c12z(i).e(mu)*z4l
            END DO
          END DO
          DO i=1,2
* pk0 -- p=c12fz4(i).e
            c12fz4(i).ek0=c12fz4(i).e(0)-c12fz4(i).e(1)
          END DO
*
*******diagrammi con solo  w- risonante*********
*
* vengono usate le routine twr0 e twl0 anche per fotone perche' quando
* c'e' una linea che si attacca con w non sono piu' necessari attaccamenti
* right handed
* quqd -- p=p5,q=p356
          quqd=p5(0)*p356(0)-p5(1)*p356(1)-p5(2)*p356(2)-p5(3)*p356(
     &      3)
* TWL0 -- qu=p5,qd=p356,v=c36w.e,a=l5_36w.a,c=l5_36w.c,cl=wcl,nsum=0
          ceps_0=-c36w.ek0*(p5(2)*p356(3)-p356(2)*p5(3))+p5k0*(c36w.
     &      e(2)*p356(3)-p356(2)*c36w.e(3))-p356k0*(c36w.e(2)*p5(3)-p
     &      5(2)*c36w.e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c36w.e(3)*p5k0+p5(3)*c36w.ek0
          ceps_1=ceps_1*cim
          cvqu=c36w.e(0)*p5(0)-c36w.e(1)*p5(1)-c36w.e(2)*p5(2)-c36w.
     &      e(3)*p5(3)
          cvqd=c36w.e(0)*p356(0)-c36w.e(1)*p356(1)-c36w.e(2)*p356(2)
     &      -c36w.e(3)*p356(3)
          cauxa=-c36w.ek0*quqd+p5k0*cvqd+p356k0*cvqu
          cauxc=+c36w.ek0*p5(2)-p5k0*c36w.e(2)
          l5_36w.a(2)=wcl*(cauxa-ceps_0)
          l5_36w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p356,q=p4
          quqd=p356(0)*p4(0)-p356(1)*p4(1)-p356(2)*p4(2)-p356(3)*p4(
     &      3)
          DO i=1,2
* TWR0 -- qu=p356,qd=p4,v=c12fz4(i).e,a=r4_12(i).a,b=r4_12(i).b,cl=1.d0,nsu
* m=0
            ceps_0=-c12fz4(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0
     &        *(c12fz4(i).e(2)*p4(3)-p4(2)*c12fz4(i).e(3))-p4k0*(c12fz4
     &        (i).e(2)*p356(3)-p356(2)*c12fz4(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c12fz4(i).e(3)*p4k0+p4(3)*c12fz4(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c12fz4(i).e(0)*p356(0)-c12fz4(i).e(1)*p356(1)-c12fz4(
     &        i).e(2)*p356(2)-c12fz4(i).e(3)*p356(3)
            cvqd=c12fz4(i).e(0)*p4(0)-c12fz4(i).e(1)*p4(1)-c12fz4(i).e
     &        (2)*p4(2)-c12fz4(i).e(3)*p4(3)
            cauxa=-c12fz4(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
            cauxb=-c12fz4(i).ek0*p4(2)+p4k0*c12fz4(i).e(2)
            r4_12(i).a(2)=1.d0*(cauxa-ceps_0)
            r4_12(i).b(1)=1.d0*(cauxb-ceps_2)
          END DO
          DO i=1,2
* TLTR0_W -- aa=cc3(i),a1=l5_36w.a,c1=l5_36w.c,a2=r4_12(i).a,b2=r4_12(i).b,
* prq=p356q,den=(p356q*p356k0),nsum=0
            cc3(i)=( l5_36w.c(2)*p356q*r4_12(i).b(1)+l5_36w.a(2)*r4_12
     &        (i).a(2) )/(p356q*p356k0)
          END DO
* quqd -- p=p5,q=p125
          quqd=p5(0)*p125(0)-p5(1)*p125(1)-p5(2)*p125(2)-p5(3)*p125(
     &      3)
          DO i=1,2
* TWL0 -- qu=p5,qd=p125,v=c12fz5(i).e,a=l5_12(i).a,c=l5_12(i).c,cl=1.d0,nsu
* m=0
            ceps_0=-c12fz5(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(
     &        c12fz5(i).e(2)*p125(3)-p125(2)*c12fz5(i).e(3))-p125k0*(c1
     &        2fz5(i).e(2)*p5(3)-p5(2)*c12fz5(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c12fz5(i).e(3)*p5k0+p5(3)*c12fz5(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c12fz5(i).e(0)*p5(0)-c12fz5(i).e(1)*p5(1)-c12fz5(i).e
     &        (2)*p5(2)-c12fz5(i).e(3)*p5(3)
            cvqd=c12fz5(i).e(0)*p125(0)-c12fz5(i).e(1)*p125(1)-c12fz5(
     &        i).e(2)*p125(2)-c12fz5(i).e(3)*p125(3)
            cauxa=-c12fz5(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
            cauxc=+c12fz5(i).ek0*p5(2)-p5k0*c12fz5(i).e(2)
            l5_12(i).a(2)=1.d0*(cauxa-ceps_0)
            l5_12(i).c(2)=1.d0*(-cauxc+ceps_1)
          END DO
* quqd -- p=p125,q=p4
          quqd=p125(0)*p4(0)-p125(1)*p4(1)-p125(2)*p4(2)-p125(3)*p4(
     &      3)
* TWR0 -- qu=p125,qd=p4,v=c36w.e,a=r4_36w.a,b=r4_36w.b,cl=wcl,nsum=0
          ceps_0=-c36w.ek0*(p125(2)*p4(3)-p4(2)*p125(3))+p125k0*(c36
     &      w.e(2)*p4(3)-p4(2)*c36w.e(3))-p4k0*(c36w.e(2)*p125(3)-p12
     &      5(2)*c36w.e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c36w.e(3)*p4k0+p4(3)*c36w.ek0
          ceps_2=ceps_2*cim
          cvqu=c36w.e(0)*p125(0)-c36w.e(1)*p125(1)-c36w.e(2)*p125(2)
     &      -c36w.e(3)*p125(3)
          cvqd=c36w.e(0)*p4(0)-c36w.e(1)*p4(1)-c36w.e(2)*p4(2)-c36w.
     &      e(3)*p4(3)
          cauxa=-c36w.ek0*quqd+p125k0*cvqd+p4k0*cvqu
          cauxb=-c36w.ek0*p4(2)+p4k0*c36w.e(2)
          r4_36w.a(2)=wcl*(cauxa-ceps_0)
          r4_36w.b(1)=wcl*(cauxb-ceps_2)
          DO i=1,2
* TLTR0_W -- aa=cc4(i),a1=l5_12(i).a,c1=l5_12(i).c,a2=r4_36w.a,b2=r4_36w.b,
* prq=p125q,den=(p125q*p125k0),nsum=0
            cc4(i)=( l5_12(i).c(2)*p125q*r4_36w.b(1)+l5_12(i).a(2)*r4_
     &        36w.a(2) )/(p125q*p125k0)
          END DO
*
*******diagrammi con solo  w+ risonante*********
*
* vengono usate le routine twr0 e twl0 anche per fotone perche' quando
* c'e' una linea che si attacca con w non sono piu' necessari attaccamenti
* right handed
* quqd -- p=p3,q=p345
          quqd=p3(0)*p345(0)-p3(1)*p345(1)-p3(2)*p345(2)-p3(3)*p345(
     &      3)
* TWL0 -- qu=p3,qd=p345,v=c54w.e,a=l3_54w.a,c=l3_54w.c,cl=wcl,nsum=0
          ceps_0=-c54w.ek0*(p3(2)*p345(3)-p345(2)*p3(3))+p3k0*(c54w.
     &      e(2)*p345(3)-p345(2)*c54w.e(3))-p345k0*(c54w.e(2)*p3(3)-p
     &      3(2)*c54w.e(3))
          ceps_0=ceps_0*cim
          ceps_1=-c54w.e(3)*p3k0+p3(3)*c54w.ek0
          ceps_1=ceps_1*cim
          cvqu=c54w.e(0)*p3(0)-c54w.e(1)*p3(1)-c54w.e(2)*p3(2)-c54w.
     &      e(3)*p3(3)
          cvqd=c54w.e(0)*p345(0)-c54w.e(1)*p345(1)-c54w.e(2)*p345(2)
     &      -c54w.e(3)*p345(3)
          cauxa=-c54w.ek0*quqd+p3k0*cvqd+p345k0*cvqu
          cauxc=+c54w.ek0*p3(2)-p3k0*c54w.e(2)
          l3_54w.a(2)=wcl*(cauxa-ceps_0)
          l3_54w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p345,q=p6
          quqd=p345(0)*p6(0)-p345(1)*p6(1)-p345(2)*p6(2)-p345(3)*p6(
     &      3)
          DO i=1,2
* TWR0 -- qu=p345,qd=p6,v=c12fz6(i).e,a=r6_12(i).a,b=r6_12(i).b,cl=1.d0,nsu
* m=0
            ceps_0=-c12fz6(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0
     &        *(c12fz6(i).e(2)*p6(3)-p6(2)*c12fz6(i).e(3))-p6k0*(c12fz6
     &        (i).e(2)*p345(3)-p345(2)*c12fz6(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c12fz6(i).e(3)*p6k0+p6(3)*c12fz6(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c12fz6(i).e(0)*p345(0)-c12fz6(i).e(1)*p345(1)-c12fz6(
     &        i).e(2)*p345(2)-c12fz6(i).e(3)*p345(3)
            cvqd=c12fz6(i).e(0)*p6(0)-c12fz6(i).e(1)*p6(1)-c12fz6(i).e
     &        (2)*p6(2)-c12fz6(i).e(3)*p6(3)
            cauxa=-c12fz6(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
            cauxb=-c12fz6(i).ek0*p6(2)+p6k0*c12fz6(i).e(2)
            r6_12(i).a(2)=1.d0*(cauxa-ceps_0)
            r6_12(i).b(1)=1.d0*(cauxb-ceps_2)
          END DO
          DO i=1,2
* TLTR0_W -- aa=cc5(i),a1=l3_54w.a,c1=l3_54w.c,a2=r6_12(i).a,b2=r6_12(i).b,
* prq=p345q,den=(p345q*p345k0),nsum=0
            cc5(i)=( l3_54w.c(2)*p345q*r6_12(i).b(1)+l3_54w.a(2)*r6_12
     &        (i).a(2) )/(p345q*p345k0)
          END DO
* quqd -- p=p3,q=p123
          quqd=p3(0)*p123(0)-p3(1)*p123(1)-p3(2)*p123(2)-p3(3)*p123(
     &      3)
          DO i=1,2
* TWL0 -- qu=p3,qd=p123,v=c12fz3(i).e,a=l3_12(i).a,c=l3_12(i).c,cl=1.d0,nsu
* m=0
            ceps_0=-c12fz3(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(
     &        c12fz3(i).e(2)*p123(3)-p123(2)*c12fz3(i).e(3))-p123k0*(c1
     &        2fz3(i).e(2)*p3(3)-p3(2)*c12fz3(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c12fz3(i).e(3)*p3k0+p3(3)*c12fz3(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c12fz3(i).e(0)*p3(0)-c12fz3(i).e(1)*p3(1)-c12fz3(i).e
     &        (2)*p3(2)-c12fz3(i).e(3)*p3(3)
            cvqd=c12fz3(i).e(0)*p123(0)-c12fz3(i).e(1)*p123(1)-c12fz3(
     &        i).e(2)*p123(2)-c12fz3(i).e(3)*p123(3)
            cauxa=-c12fz3(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
            cauxc=+c12fz3(i).ek0*p3(2)-p3k0*c12fz3(i).e(2)
            l3_12(i).a(2)=1.d0*(cauxa-ceps_0)
            l3_12(i).c(2)=1.d0*(-cauxc+ceps_1)
          END DO
* quqd -- p=p123,q=p6
          quqd=p123(0)*p6(0)-p123(1)*p6(1)-p123(2)*p6(2)-p123(3)*p6(
     &      3)
* TWR0 -- qu=p123,qd=p6,v=c54w.e,a=r6_54w.a,b=r6_54w.b,cl=wcl,nsum=0
          ceps_0=-c54w.ek0*(p123(2)*p6(3)-p6(2)*p123(3))+p123k0*(c54
     &      w.e(2)*p6(3)-p6(2)*c54w.e(3))-p6k0*(c54w.e(2)*p123(3)-p12
     &      3(2)*c54w.e(3))
          ceps_0=ceps_0*cim
          ceps_2=-c54w.e(3)*p6k0+p6(3)*c54w.ek0
          ceps_2=ceps_2*cim
          cvqu=c54w.e(0)*p123(0)-c54w.e(1)*p123(1)-c54w.e(2)*p123(2)
     &      -c54w.e(3)*p123(3)
          cvqd=c54w.e(0)*p6(0)-c54w.e(1)*p6(1)-c54w.e(2)*p6(2)-c54w.
     &      e(3)*p6(3)
          cauxa=-c54w.ek0*quqd+p123k0*cvqd+p6k0*cvqu
          cauxb=-c54w.ek0*p6(2)+p6k0*c54w.e(2)
          r6_54w.a(2)=wcl*(cauxa-ceps_0)
          r6_54w.b(1)=wcl*(cauxb-ceps_2)
          DO i=1,2
* TLTR0_W -- aa=cc6(i),a1=l3_12(i).a,c1=l3_12(i).c,a2=r6_54w.a,b2=r6_54w.b,
* prq=p123q,den=(p123q*p123k0),nsum=0
            cc6(i)=( l3_12(i).c(2)*p123q*r6_54w.b(1)+l3_12(i).a(2)*r6_
     &        54w.a(2) )/(p123q*p123k0)
          END DO

          IF (i3e.EQ.1) THEN

* quqd -- p=p2,q=p3
            quqd=p2(0)*p3(0)-p2(1)*p3(1)-p2(2)*p3(2)-p2(3)*p3(3)
* il - qui e in cdw e' perche' i propagatori bosonici portano un segno
* - rispetto a quelli fermionici
            cdz=-1.d0/(-2.d0*quqd-rmz2+ccz)
            df=-1.d0/(-2.d0*quqd)
c            df=-1.d0/(2.d0*(0.0005d0**2)-2.d0*quqd+2.d0*p2(0)*p3(0)*
c     &         (0.0005d0)**2*(1/(2.d0*p3(0)**2)+2.d0/s))
            fac1=(df*fer)
            fac2=(df*fel)
            cfac1z=(cdz*zer)/fac1
            cfac2z=(cdz*zel)/fac2
* T10 -- qu=p3,qd=p2,v=0,a=c23f(&).e(0),cr=fac1,cl=fac2,nsum=0
            eps_0=-p3(2)*p2(3)+p2(2)*p3(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p3k0*p2(0)+p2k0*p3(0)
            c23f(1).e(0)=fac1*(auxa+ceps_0)
            c23f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=1,a=c23f(&).e(1),cr=fac1,cl=fac2,nsum=0
            auxa=-quqd+p3k0*p2(1)+p2k0*p3(1)
            c23f(1).e(1)=fac1*(auxa+ceps_0)
            c23f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=2,a=c23f(&).e(2),cr=fac1,cl=fac2,nsum=0
            eps_0=-p3k0*p2(3)+p2k0*p3(3)
            ceps_0=eps_0*cim
            auxa=p3k0*p2(2)+p2k0*p3(2)
            c23f(1).e(2)=fac1*(auxa+ceps_0)
            c23f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=3,a=c23f(&).e(3),cr=fac1,cl=fac2,nsum=0
            eps_0=p3k0*p2(2)-p2k0*p3(2)
            ceps_0=eps_0*cim
            auxa=p3k0*p2(3)+p2k0*p3(3)
            c23f(1).e(3)=fac1*(auxa+ceps_0)
            c23f(2).e(3)=fac2*(auxa-ceps_0)
            DO m=0,3
              c23z(1).e(m)=cfac1z*c23f(1).e(m)
              c23z(2).e(m)=cfac2z*c23f(2).e(m)
            END DO
            IF (ianc.EQ.0) THEN
              DO i=1,2
                DO mu=0,3
                  c23fz(i).e(mu)=c23f(i).e(mu)+rcotw*c23z(i).e(mu)
                END DO
              END DO
            ELSE
              DO i=1,2
                DO mu=0,3
                  c23fz(i).e(mu)=c23f(i).e(mu)+(rcotw+delz)*c23z(i).
     &              e(mu)
                END DO
              END DO
            ENDIF
            DO i=1,2
              DO mu=0,3
                c23fz5(i).e(mu)=c23f(i).e(mu)*f5l
     &            +c23z(i).e(mu)*z5l
                c23fz4(i).e(mu)=c23f(i).e(mu)*f4l
     &            +c23z(i).e(mu)*z4l
                c23fz1(i).e(mu)=c23f(i).e(mu)*fel
     &            +c23z(i).e(mu)*zel
              END DO
            END DO
            DO i=1,2
* pk0 -- p=c23z(i).e
              c23z(i).ek0=c23z(i).e(0)-c23z(i).e(1)
            END DO
            DO i=1,2
* pk0 -- p=c23fz5(i).e
              c23fz5(i).ek0=c23fz5(i).e(0)-c23fz5(i).e(1)
            END DO
            DO i=1,2
* pk0 -- p=c23fz4(i).e
              c23fz4(i).ek0=c23fz4(i).e(0)-c23fz4(i).e(1)
            END DO
            DO i=1,2
* pk0 -- p=c23fz1(i).e
              c23fz1(i).ek0=c23fz1(i).e(0)-c23fz1(i).e(1)
            END DO
* quqd -- p=p1,q=p6
            quqd=p1(0)*p6(0)-p1(1)*p6(1)-p1(2)*p6(2)-p1(3)*p6(3)
            ccl=wcl/(2.d0*quqd+rmw2-ccw)
* TW10 -- qu=p1,qd=p6,v=0,a=c16w.e(0),cl=ccl,nsum=0
            eps_0=-p1(2)*p6(3)+p6(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p6(0)+p6k0*p1(0)
            c16w.e(0)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p6,v=1,a=c16w.e(1),cl=ccl,nsum=0
            auxa=-quqd+p1k0*p6(1)+p6k0*p1(1)
            c16w.e(1)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p6,v=2,a=c16w.e(2),cl=ccl,nsum=0
            eps_0=-p1k0*p6(3)+p6k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(2)+p6k0*p1(2)
            c16w.e(2)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p6,v=3,a=c16w.e(3),cl=ccl,nsum=0
            eps_0=p1k0*p6(2)-p6k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(3)+p6k0*p1(3)
            c16w.e(3)=ccl*(auxa-ceps_0)
* pk0 -- p=c16w.e
            c16w.ek0=c16w.e(0)-c16w.e(1)
*
* diagramma triplo 20 cc7
*
*** triple vertex -- pfz(mu)=p23(mu),pwm(mu)=p16(mu),pwp(mu)=p45(mu),efz=c2
* 3fz(i),ewm=c16w,ewp=c54w,res=cc7(i?)
            DO mu=0,3
              vfz(mu)=p16(mu)-p45(mu)
              vwm(mu)=p45(mu)-p23(mu)
              vwp(mu)=p23(mu)-p16(mu)
            END DO !mu
* vfz.efz
            DO i=1,2
* p.q -- p.q=c23fz(i).v,p=c23fz(i).e,q=vfz
              c23fz(i).v=c23fz(i).e(0)*vfz(0)-c23fz(i).e(1)*vfz(1)-c23fz
     &          (i).e(2)*vfz(2)-c23fz(i).e(3)*vfz(3)
            END DO
* vwm.ewm
* p.q -- p.q=c16w.v,p=c16w.e,q=vwm
            c16w.v=c16w.e(0)*vwm(0)-c16w.e(1)*vwm(1)-c16w.e(2)*vwm(2)-
     &        c16w.e(3)*vwm(3)
* vwp.ewp
* p.q -- p.q=c54w.v,p=c54w.e,q=vwp
            c54w.v=c54w.e(0)*vwp(0)-c54w.e(1)*vwp(1)-c54w.e(2)*vwp(2)-
     &        c54w.e(3)*vwp(3)
* efz.ewm
            DO i=1,2
* p.q -- p.q=caux,p=c23fz(i).e,q=c16w.e
              caux=c23fz(i).e(0)*c16w.e(0)-c23fz(i).e(1)*c16w.e(1)-c23fz
     &          (i).e(2)*c16w.e(2)-c23fz(i).e(3)*c16w.e(3)
              cc7(i)=c54w.v*caux
            END DO
* efz.ewp
            DO i=1,2
* p.q -- p.q=caux,p=c23fz(i).e,q=c54w.e
              caux=c23fz(i).e(0)*c54w.e(0)-c23fz(i).e(1)*c54w.e(1)-c23fz
     &          (i).e(2)*c54w.e(2)-c23fz(i).e(3)*c54w.e(3)
              cc7(i)=cc7(i)+c16w.v*caux
            END DO
* ewm.ewp
* p.q -- p.q=caux,p=c16w.e,q=c54w.e
            caux=c16w.e(0)*c54w.e(0)-c16w.e(1)*c54w.e(1)-c16w.e(2)*c54
     &        w.e(2)-c16w.e(3)*c54w.e(3)
            DO i=1,2
              cc7(i)=cc7(i)+c23fz(i).v*caux
            END DO
* anomalous couplings
            IF (ianc.NE.0) THEN
* p.q -- p.q=cemp0,p=c16w.e,q=p23
              cemp0=c16w.e(0)*p23(0)-c16w.e(1)*p23(1)-c16w.e(2)*p23(2)-c
     &          16w.e(3)*p23(3)
* p.q -- p.q=cepp0,p=c54w.e,q=p23
              cepp0=c54w.e(0)*p23(0)-c54w.e(1)*p23(1)-c54w.e(2)*p23(2)-c
     &          54w.e(3)*p23(3)

              IF (xf.NE.0.d0.OR.xz.NE.0.d0) THEN
                DO i=1,2
                  DO mu=0,3
                    c23fz(i).e(mu)=xf*c23f(i).e(mu)+xz*c23z(i).e(mu)
                  END DO
                END DO
                DO i=1,2
* p.q -- p.q=ce0em(i),p=c23fz(i).e,q=c16w.e
                  ce0em(i)=c23fz(i).e(0)*c16w.e(0)-c23fz(i).e(1)*c16w.
     &              e(1)-c
     &              23fz(i).e(2)*c16w.e(2)-c23fz(i).e(3)*c16w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0ep(i),p=c23fz(i).e,q=c54w.e
                  ce0ep(i)=c23fz(i).e(0)*c54w.e(0)-c23fz(i).e(1)*c54w.
     &              e(1)-c
     &              23fz(i).e(2)*c54w.e(2)-c23fz(i).e(3)*c54w.e(3)
                END DO
                DO i=1,2
                  cc7(i)=cc7(i)+ce0em(i)*cepp0-ce0ep(i)*cemp0
                END DO
              ENDIF

              IF (yf.NE.0.d0.OR.yz.NE.0.d0) THEN
                DO i=1,2
                  DO mu=0,3
                    c23fz(i).e(mu)=yf*c23f(i).e(mu)+yz*c23z(i).e(mu)
                  END DO
                END DO
                DO i=1,2
* p.q -- p.q=ce0em(i),p=c23fz(i).e,q=c16w.e
                  ce0em(i)=c23fz(i).e(0)*c16w.e(0)-c23fz(i).e(1)*c16w.
     &              e(1)-c
     &              23fz(i).e(2)*c16w.e(2)-c23fz(i).e(3)*c16w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0ep(i),p=c23fz(i).e,q=c54w.e
                  ce0ep(i)=c23fz(i).e(0)*c54w.e(0)-c23fz(i).e(1)*c54w.
     &              e(1)-c
     &              23fz(i).e(2)*c54w.e(2)-c23fz(i).e(3)*c54w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0pm(i),p=c23fz(i).e,q=p16
                  ce0pm(i)=c23fz(i).e(0)*p16(0)-c23fz(i).e(1)*p16(1)
     &              -c23fz(i
     &              ).e(2)*p16(2)-c23fz(i).e(3)*p16(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0pp(i),p=c23fz(i).e,q=p45
                  ce0pp(i)=c23fz(i).e(0)*p45(0)-c23fz(i).e(1)*p45(1)
     &              -c23fz(i
     &              ).e(2)*p45(2)-c23fz(i).e(3)*p45(3)
                END DO
* p.q -- p.q=cemep,p=c16w.e,q=c54w.e
                cemep=c16w.e(0)*c54w.e(0)-c16w.e(1)*c54w.e(1)-c16w.e(2)
     &            *c5
     &            4w.e(2)-c16w.e(3)*c54w.e(3)
* p.q -- p.q=cempp,p=c16w.e,q=p45
                cempp=c16w.e(0)*p45(0)-c16w.e(1)*p45(1)-c16w.e(2)*p45(2)
     &            -c
     &            16w.e(3)*p45(3)
* p.q -- p.q=ceppm,p=c54w.e,q=p16
                ceppm=c54w.e(0)*p16(0)-c54w.e(1)*p16(1)-c54w.e(2)*p16(2)
     &            -c
     &            54w.e(3)*p16(3)
* p.q -- p.q=p0pm,p=p23,q=p16
                p0pm=p23(0)*p16(0)-p23(1)*p16(1)-p23(2)*p16(2)-p23(3)
     &            *p16(
     &            3)
* p.q -- p.q=p0pp,p=p23,q=p45
                p0pp=p23(0)*p45(0)-p23(1)*p45(1)-p23(2)*p45(2)-p23(3)
     &            *p45(
     &            3)
* p.q -- p.q=pmpp,p=p16,q=p45
                pmpp=p16(0)*p45(0)-p16(1)*p45(1)-p16(2)*p45(2)-p16(3)
     &            *p45(
     &            3)
                DO i=1,2
                  cc7(i)=cc7(i)+ce0pm(i)*cepp0*cempp-ce0pp(i)
     &              *ceppm*cemp0+
     &              p0pp*(ce0em(i)*ceppm-cemep*ce0pm(i))+
     &              p0pm*(cemep*ce0pp(i)-ce0ep(i)*cempp)+
     &              pmpp*(ce0ep(i)*cemp0-ce0em(i)*cepp0)
                END DO

              ENDIF
              IF (zz.NE.0.d0) THEN
                DO m=0,3
                  cpau(m)=cepp0*c16w.e(m)-cemp0*c54w.e(m)
                  pau(m)=p45(m)-p16(m)
                ENDDO
                DO i=1,2
* eps -- eps=cau(i),p=c23z(i).e,q=cpau,r=p23,s=pau
                  cau(i)=c23z(i).e(0)*(cpau(1)*(p23(2)*pau(3)-p23(3)
     &              *pau(2))
     &              +cpau(2)*(p23(3)*pau(1)-p23(1)*pau(3))+cpau(3)
     &              *(p23(1)*pa
     &              u(2)-p23(2)*pau(1)))
                  cau(i)=cau(i)-c23z(i).e(1)*(cpau(2)*(p23(3)*pau(0)
     &              -p23(0)*
     &              pau(3))+cpau(3)*(p23(0)*pau(2)-p23(2)*pau(0))
     &              +cpau(0)*(p2
     &              3(2)*pau(3)-p23(3)*pau(2)))
                  cau(i)=cau(i)+c23z(i).e(2)*(cpau(3)*(p23(0)*pau(1)
     &              -p23(1)*
     &              pau(0))+cpau(0)*(p23(1)*pau(3)-p23(3)*pau(1))
     &              +cpau(1)*(p2
     &              3(3)*pau(0)-p23(0)*pau(3)))
                  cau(i)=cau(i)-c23z(i).e(3)*(cpau(0)*(p23(1)*pau(2)
     &              -p23(2)*
     &              pau(1))+cpau(1)*(p23(2)*pau(0)-p23(0)*pau(2))
     &              +cpau(2)*(p2
     &              3(0)*pau(1)-p23(1)*pau(0)))
                END DO
                DO i=1,2
                  cc7(i)=cc7(i)+cim*zz*cau(i)
                ENDDO
              ENDIF
            ENDIF
* end anomalous couplings

*
* diagramma cc8
*
* quqd -- p=p145,q=p6
            quqd=p145(0)*p6(0)-p145(1)*p6(1)-p145(2)*p6(2)-p145(3)*p6(
     &        3)
            DO i=1,2
* TWR0 -- qu=p145,qd=p6,v=c23z(i).e,a=r6_23(i).a,b=r6_23(i).b,cl=z6l,nsum=0
              ceps_0=-c23z(i).ek0*(p145(2)*p6(3)-p6(2)*p145(3))+p145k0*(
     &          c23z(i).e(2)*p6(3)-p6(2)*c23z(i).e(3))-p6k0*(c23z(i).
     &          e(2)
     &          *p145(3)-p145(2)*c23z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23z(i).e(3)*p6k0+p6(3)*c23z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c23z(i).e(0)*p145(0)-c23z(i).e(1)*p145(1)-c23z(i).e(2
     &          )*p145(2)-c23z(i).e(3)*p145(3)
              cvqd=c23z(i).e(0)*p6(0)-c23z(i).e(1)*p6(1)-c23z(i).e(2)*p6
     &          (2)-c23z(i).e(3)*p6(3)
              cauxa=-c23z(i).ek0*quqd+p145k0*cvqd+p6k0*cvqu
              cauxb=-c23z(i).ek0*p6(2)+p6k0*c23z(i).e(2)
              r6_23(i).a(2)=z6l*(cauxa-ceps_0)
              r6_23(i).b(1)=z6l*(cauxb-ceps_2)
            END DO
            DO i=1,2
* TLTR0_W -- aa=cc8(i),a1=l1_54w.a,c1=l1_54w.c,a2=r6_23(i).a,b2=r6_23(i).b,
* prq=p145q,den=(p145q*p145k0),nsum=0
              cc8(i)=( l1_54w.c(2)*p145q*r6_23(i).b(1)+l1_54w.a(2)*r6_23
     &          (i).a(2) )/(p145q*p145k0)
            END DO
*
* diagramma cc9
*
* quqd -- p=p1,q=p123
            quqd=p1(0)*p123(0)-p1(1)*p123(1)-p1(2)*p123(2)-p1(3)*p123(
     &        3)
            DO i=1,2
* TWL0 -- qu=p1,qd=p123,v=c23fz1(i).e,a=l1_23(i).a,c=l1_23(i).c,cl=1.d0,nsu
* m=0
              ceps_0=-c23fz1(i).ek0*(p1(2)*p123(3)-p123(2)*p1(3))+p1k0*(
     &          c23fz1(i).e(2)*p123(3)-p123(2)*c23fz1(i).e(3))
     &          -p123k0*(c2
     &          3fz1(i).e(2)*p1(3)-p1(2)*c23fz1(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23fz1(i).e(3)*p1k0+p1(3)*c23fz1(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c23fz1(i).e(0)*p1(0)-c23fz1(i).e(1)*p1(1)-c23fz1(i).e
     &          (2)*p1(2)-c23fz1(i).e(3)*p1(3)
              cvqd=c23fz1(i).e(0)*p123(0)-c23fz1(i).e(1)*p123(1)-c23fz1(
     &          i).e(2)*p123(2)-c23fz1(i).e(3)*p123(3)
              cauxa=-c23fz1(i).ek0*quqd+p1k0*cvqd+p123k0*cvqu
              cauxc=+c23fz1(i).ek0*p1(2)-p1k0*c23fz1(i).e(2)
              l1_23(i).a(2)=1.d0*(cauxa-ceps_0)
              l1_23(i).c(2)=1.d0*(-cauxc+ceps_1)
            END DO
            DO i=1,2
* TLTR0_W -- aa=cc9(i),a1=l1_23(i).a,c1=l1_23(i).c,a2=r6_54w.a,b2=r6_54w.b,
* prq=p123q,den=(p123q*p123k0),nsum=0
              cc9(i)=( l1_23(i).c(2)*p123q*r6_54w.b(1)+l1_23(i).a(2)*r6_
     &          54w.a(2) )/(p123q*p123k0)
            END DO
*
* diagramma cc10
*
* quqd -- p=p345,q=p2
            quqd=p345(0)*p2(0)-p345(1)*p2(1)-p345(2)*p2(2)-p345(3)*p2(
     &        3)
* TWR0 -- qu=p345,qd=p2,v=c16w.e,a=r2_16w.a,b=r2_16w.b,cl=wcl,nsum=0
            ceps_0=-c16w.ek0*(p345(2)*p2(3)-p2(2)*p345(3))+p345k0*(c16
     &        w.e(2)*p2(3)-p2(2)*c16w.e(3))-p2k0*(c16w.e(2)*p345(3)-p34
     &        5(2)*c16w.e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c16w.e(3)*p2k0+p2(3)*c16w.ek0
            ceps_2=ceps_2*cim
            cvqu=c16w.e(0)*p345(0)-c16w.e(1)*p345(1)-c16w.e(2)*p345(2)
     &        -c16w.e(3)*p345(3)
            cvqd=c16w.e(0)*p2(0)-c16w.e(1)*p2(1)-c16w.e(2)*p2(2)-c16w.
     &        e(3)*p2(3)
            cauxa=-c16w.ek0*quqd+p345k0*cvqd+p2k0*cvqu
            cauxb=-c16w.ek0*p2(2)+p2k0*c16w.e(2)
            r2_16w.a(2)=wcl*(cauxa-ceps_0)
            r2_16w.b(1)=wcl*(cauxb-ceps_2)
* TLTR0_W -- aa=cc10(&),a1=l3_54w.a,c1=l3_54w.c,a2=r2_16w.a,b2=r2_16w.b,prq
* =p345q,den=(p345q*p345k0),nsum=0
            cc10(2)=( l3_54w.c(2)*p345q*r2_16w.b(1)+l3_54w.a(2)*r2_16w
     &        .a(2) )/(p345q*p345k0)
*
* diagramma cc11
*
* quqd -- p=p5,q=p156
            quqd=p5(0)*p156(0)-p5(1)*p156(1)-p5(2)*p156(2)-p5(3)*p156(
     &        3)
* TWL0 -- qu=p5,qd=p156,v=c16w.e,a=l5_16w.a,c=l5_16w.c,cl=wcl,nsum=0
            ceps_0=-c16w.ek0*(p5(2)*p156(3)-p156(2)*p5(3))+p5k0*(c16w.
     &        e(2)*p156(3)-p156(2)*c16w.e(3))-p156k0*(c16w.e(2)*p5(3)-p
     &        5(2)*c16w.e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c16w.e(3)*p5k0+p5(3)*c16w.ek0
            ceps_1=ceps_1*cim
            cvqu=c16w.e(0)*p5(0)-c16w.e(1)*p5(1)-c16w.e(2)*p5(2)-c16w.
     &        e(3)*p5(3)
            cvqd=c16w.e(0)*p156(0)-c16w.e(1)*p156(1)-c16w.e(2)*p156(2)
     &        -c16w.e(3)*p156(3)
            cauxa=-c16w.ek0*quqd+p5k0*cvqd+p156k0*cvqu
            cauxc=+c16w.ek0*p5(2)-p5k0*c16w.e(2)
            l5_16w.a(2)=wcl*(cauxa-ceps_0)
            l5_16w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p156,q=p4
            quqd=p156(0)*p4(0)-p156(1)*p4(1)-p156(2)*p4(2)-p156(3)*p4(
     &        3)
            DO i=1,2
* TWR0 -- qu=p156,qd=p4,v=c23fz4(i).e,a=r4_23(i).a,b=r4_23(i).b,cl=1.d0,nsu
* m=0
              ceps_0=-c23fz4(i).ek0*(p156(2)*p4(3)-p4(2)*p156(3))+p156k0
     &          *(c23fz4(i).e(2)*p4(3)-p4(2)*c23fz4(i).e(3))
     &          -p4k0*(c23fz4
     &          (i).e(2)*p156(3)-p156(2)*c23fz4(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23fz4(i).e(3)*p4k0+p4(3)*c23fz4(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c23fz4(i).e(0)*p156(0)-c23fz4(i).e(1)*p156(1)-c23fz4(
     &          i).e(2)*p156(2)-c23fz4(i).e(3)*p156(3)
              cvqd=c23fz4(i).e(0)*p4(0)-c23fz4(i).e(1)*p4(1)-c23fz4(i).e
     &          (2)*p4(2)-c23fz4(i).e(3)*p4(3)
              cauxa=-c23fz4(i).ek0*quqd+p156k0*cvqd+p4k0*cvqu
              cauxb=-c23fz4(i).ek0*p4(2)+p4k0*c23fz4(i).e(2)
              r4_23(i).a(2)=1.d0*(cauxa-ceps_0)
              r4_23(i).b(1)=1.d0*(cauxb-ceps_2)
            END DO
            DO i=1,2
* TLTR0_W -- aa=cc11(i),a1=l5_16w.a,c1=l5_16w.c,a2=r4_23(i).a,b2=r4_23(i).b
* ,prq=p156q,den=(p156q*p156k0),nsum=0
              cc11(i)=( l5_16w.c(2)*p156q*r4_23(i).b(1)+l5_16w.a(2)*r4_2
     &          3(i).a(2) )/(p156q*p156k0)
            END DO
*
* diagramma cc12
*
* quqd -- p=p5,q=p235
            quqd=p5(0)*p235(0)-p5(1)*p235(1)-p5(2)*p235(2)-p5(3)*p235(
     &        3)
            DO i=1,2
* TWL0 -- qu=p5,qd=p235,v=c23fz5(i).e,a=l5_23(i).a,c=l5_23(i).c,cl=1.d0,nsu
* m=0
              ceps_0=-c23fz5(i).ek0*(p5(2)*p235(3)-p235(2)*p5(3))+p5k0*(
     &          c23fz5(i).e(2)*p235(3)-p235(2)*c23fz5(i).e(3))
     &          -p235k0*(c2
     &          3fz5(i).e(2)*p5(3)-p5(2)*c23fz5(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23fz5(i).e(3)*p5k0+p5(3)*c23fz5(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c23fz5(i).e(0)*p5(0)-c23fz5(i).e(1)*p5(1)-c23fz5(i).e
     &          (2)*p5(2)-c23fz5(i).e(3)*p5(3)
              cvqd=c23fz5(i).e(0)*p235(0)-c23fz5(i).e(1)*p235(1)-c23fz5(
     &          i).e(2)*p235(2)-c23fz5(i).e(3)*p235(3)
              cauxa=-c23fz5(i).ek0*quqd+p5k0*cvqd+p235k0*cvqu
              cauxc=+c23fz5(i).ek0*p5(2)-p5k0*c23fz5(i).e(2)
              l5_23(i).a(2)=1.d0*(cauxa-ceps_0)
              l5_23(i).c(2)=1.d0*(-cauxc+ceps_1)
            END DO
* quqd -- p=p235,q=p4
            quqd=p235(0)*p4(0)-p235(1)*p4(1)-p235(2)*p4(2)-p235(3)*p4(
     &        3)
* TWR0 -- qu=p235,qd=p4,v=c16w.e,a=r4_16w.a,b=r4_16w.b,cl=wcl,nsum=0
            ceps_0=-c16w.ek0*(p235(2)*p4(3)-p4(2)*p235(3))+p235k0*(c16
     &        w.e(2)*p4(3)-p4(2)*c16w.e(3))-p4k0*(c16w.e(2)*p235(3)-p23
     &        5(2)*c16w.e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c16w.e(3)*p4k0+p4(3)*c16w.ek0
            ceps_2=ceps_2*cim
            cvqu=c16w.e(0)*p235(0)-c16w.e(1)*p235(1)-c16w.e(2)*p235(2)
     &        -c16w.e(3)*p235(3)
            cvqd=c16w.e(0)*p4(0)-c16w.e(1)*p4(1)-c16w.e(2)*p4(2)-c16w.
     &        e(3)*p4(3)
            cauxa=-c16w.ek0*quqd+p235k0*cvqd+p4k0*cvqu
            cauxb=-c16w.ek0*p4(2)+p4k0*c16w.e(2)
            r4_16w.a(2)=wcl*(cauxa-ceps_0)
            r4_16w.b(1)=wcl*(cauxb-ceps_2)
            DO i=1,2
* TLTR0_W -- aa=cc12(i),a1=l5_23(i).a,c1=l5_23(i).c,a2=r4_16w.a,b2=r4_16w.b
* ,prq=p235q,den=(p235q*p235k0),nsum=0
              cc12(i)=( l5_23(i).c(2)*p235q*r4_16w.b(1)+l5_23(i).a(2)*r4
     &          _16w.a(2) )/(p235q*p235k0)
            END DO

**** fine i3e
          ENDIF

          IF (i4e.EQ.1) THEN

* quqd -- p=p4,q=p1
            quqd=p4(0)*p1(0)-p4(1)*p1(1)-p4(2)*p1(2)-p4(3)*p1(3)
* il - qui e in cdw e' perche' i propagatori bosonici portano un segno
* - rispetto a quelli fermionici
            cdz=-1.d0/(-2.d0*quqd-rmz2+ccz)
            df=-1.d0/(-2.d0*quqd)
            fac1=(df*fer)
            fac2=(df*fel)
            cfac1z=(cdz*zer)/fac1
            cfac2z=(cdz*zel)/fac2
* T10 -- qu=p1,qd=p4,v=0,a=c41f(&).e(0),cr=fac1,cl=fac2,nsum=0
            eps_0=-p1(2)*p4(3)+p4(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p4(0)+p4k0*p1(0)
            c41f(1).e(0)=fac1*(auxa+ceps_0)
            c41f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=1,a=c41f(&).e(1),cr=fac1,cl=fac2,nsum=0
            auxa=-quqd+p1k0*p4(1)+p4k0*p1(1)
            c41f(1).e(1)=fac1*(auxa+ceps_0)
            c41f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=2,a=c41f(&).e(2),cr=fac1,cl=fac2,nsum=0
            eps_0=-p1k0*p4(3)+p4k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p4(2)+p4k0*p1(2)
            c41f(1).e(2)=fac1*(auxa+ceps_0)
            c41f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=3,a=c41f(&).e(3),cr=fac1,cl=fac2,nsum=0
            eps_0=p1k0*p4(2)-p4k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p4(3)+p4k0*p1(3)
            c41f(1).e(3)=fac1*(auxa+ceps_0)
            c41f(2).e(3)=fac2*(auxa-ceps_0)
            DO m=0,3
              c41z(1).e(m)=cfac1z*c41f(1).e(m)
              c41z(2).e(m)=cfac2z*c41f(2).e(m)
            END DO
            IF (ianc.EQ.0) THEN
              DO i=1,2
                DO mu=0,3
                  c41fz(i).e(mu)=c41f(i).e(mu)+rcotw*c41z(i).e(mu)
                END DO
              END DO
            ELSE
              DO i=1,2
                DO mu=0,3
                  c41fz(i).e(mu)=c41f(i).e(mu)+(rcotw+delz)*c41z(i).
     &              e(mu)
                END DO
              END DO
            ENDIF
            DO i=1,2
              DO mu=0,3
                c41fz3(i).e(mu)=c41f(i).e(mu)*f3l
     &            +c41z(i).e(mu)*z3l
                c41fz6(i).e(mu)=c41f(i).e(mu)*f6l
     &            +c41z(i).e(mu)*z6l
                c41fz2(i).e(mu)=c41f(i).e(mu)*fel
     &            +c41z(i).e(mu)*zel
              END DO
            END DO
            DO i=1,2
* pk0 -- p=c41z(i).e
              c41z(i).ek0=c41z(i).e(0)-c41z(i).e(1)
            END DO
            DO i=1,2
* pk0 -- p=c41fz3(i).e
              c41fz3(i).ek0=c41fz3(i).e(0)-c41fz3(i).e(1)
            END DO
            DO i=1,2
* pk0 -- p=c41fz6(i).e
              c41fz6(i).ek0=c41fz6(i).e(0)-c41fz6(i).e(1)
            END DO
            DO i=1,2
* pk0 -- p=c41fz2(i).e
              c41fz2(i).ek0=c41fz2(i).e(0)-c41fz2(i).e(1)
            END DO
* quqd -- p=p5,q=p2
            quqd=p5(0)*p2(0)-p5(1)*p2(1)-p5(2)*p2(2)-p5(3)*p2(3)
            ccl=wcl/(2.d0*quqd+rmw2-ccw)
* TW10 -- qu=p5,qd=p2,v=0,a=c52w.e(0),cl=ccl,nsum=0
            eps_0=-p5(2)*p2(3)+p2(2)*p5(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p5k0*p2(0)+p2k0*p5(0)
            c52w.e(0)=ccl*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p2,v=1,a=c52w.e(1),cl=ccl,nsum=0
            auxa=-quqd+p5k0*p2(1)+p2k0*p5(1)
            c52w.e(1)=ccl*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p2,v=2,a=c52w.e(2),cl=ccl,nsum=0
            eps_0=-p5k0*p2(3)+p2k0*p5(3)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(2)+p2k0*p5(2)
            c52w.e(2)=ccl*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p2,v=3,a=c52w.e(3),cl=ccl,nsum=0
            eps_0=p5k0*p2(2)-p2k0*p5(2)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(3)+p2k0*p5(3)
            c52w.e(3)=ccl*(auxa-ceps_0)
* pk0 -- p=c52w.e
            c52w.ek0=c52w.e(0)-c52w.e(1)
*
* diagramma triplo 20 cc13
*
*** triple vertex -- pfz(mu)=p14(mu),pwm(mu)=p36(mu),pwp(mu)=p25(mu),efz=c4
* 1fz(i),ewm=c36w,ewp=c52w,res=cc13(i?)
            DO mu=0,3
              vfz(mu)=p36(mu)-p25(mu)
              vwm(mu)=p25(mu)-p14(mu)
              vwp(mu)=p14(mu)-p36(mu)
            END DO !mu
* vfz.efz
            DO i=1,2
* p.q -- p.q=c41fz(i).v,p=c41fz(i).e,q=vfz
              c41fz(i).v=c41fz(i).e(0)*vfz(0)-c41fz(i).e(1)*vfz(1)-c41fz
     &          (i).e(2)*vfz(2)-c41fz(i).e(3)*vfz(3)
            END DO
* vwm.ewm
* p.q -- p.q=c36w.v,p=c36w.e,q=vwm
            c36w.v=c36w.e(0)*vwm(0)-c36w.e(1)*vwm(1)-c36w.e(2)*vwm(2)-
     &        c36w.e(3)*vwm(3)
* vwp.ewp
* p.q -- p.q=c52w.v,p=c52w.e,q=vwp
            c52w.v=c52w.e(0)*vwp(0)-c52w.e(1)*vwp(1)-c52w.e(2)*vwp(2)-
     &        c52w.e(3)*vwp(3)
* efz.ewm
            DO i=1,2
* p.q -- p.q=caux,p=c41fz(i).e,q=c36w.e
              caux=c41fz(i).e(0)*c36w.e(0)-c41fz(i).e(1)*c36w.e(1)-c41fz
     &          (i).e(2)*c36w.e(2)-c41fz(i).e(3)*c36w.e(3)
              cc13(i)=c52w.v*caux
            END DO
* efz.ewp
            DO i=1,2
* p.q -- p.q=caux,p=c41fz(i).e,q=c52w.e
              caux=c41fz(i).e(0)*c52w.e(0)-c41fz(i).e(1)*c52w.e(1)-c41fz
     &          (i).e(2)*c52w.e(2)-c41fz(i).e(3)*c52w.e(3)
              cc13(i)=cc13(i)+c36w.v*caux
            END DO
* ewm.ewp
* p.q -- p.q=caux,p=c36w.e,q=c52w.e
            caux=c36w.e(0)*c52w.e(0)-c36w.e(1)*c52w.e(1)-c36w.e(2)*c52
     &        w.e(2)-c36w.e(3)*c52w.e(3)
            DO i=1,2
              cc13(i)=cc13(i)+c41fz(i).v*caux
            END DO
* anomalous couplings
            IF (ianc.NE.0) THEN
* p.q -- p.q=cemp0,p=c36w.e,q=p14
              cemp0=c36w.e(0)*p14(0)-c36w.e(1)*p14(1)-c36w.e(2)*p14(2)-c
     &          36w.e(3)*p14(3)
* p.q -- p.q=cepp0,p=c52w.e,q=p14
              cepp0=c52w.e(0)*p14(0)-c52w.e(1)*p14(1)-c52w.e(2)*p14(2)-c
     &          52w.e(3)*p14(3)

              IF (xf.NE.0.d0.OR.xz.NE.0.d0) THEN
                DO i=1,2
                  DO mu=0,3
                    c41fz(i).e(mu)=xf*c41f(i).e(mu)+xz*c41z(i).e(mu)
                  END DO
                END DO
                DO i=1,2
* p.q -- p.q=ce0em(i),p=c41fz(i).e,q=c36w.e
                  ce0em(i)=c41fz(i).e(0)*c36w.e(0)-c41fz(i).e(1)*c36w.
     &              e(1)-c
     &              41fz(i).e(2)*c36w.e(2)-c41fz(i).e(3)*c36w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0ep(i),p=c41fz(i).e,q=c52w.e
                  ce0ep(i)=c41fz(i).e(0)*c52w.e(0)-c41fz(i).e(1)*c52w.
     &              e(1)-c
     &              41fz(i).e(2)*c52w.e(2)-c41fz(i).e(3)*c52w.e(3)
                END DO
                DO i=1,2
                  cc13(i)=cc13(i)+ce0em(i)*cepp0-ce0ep(i)*cemp0
                END DO
              ENDIF

              IF (yf.NE.0.d0.OR.yz.NE.0.d0) THEN
                DO i=1,2
                  DO mu=0,3
                    c41fz(i).e(mu)=yf*c41f(i).e(mu)+yz*c41z(i).e(mu)
                  END DO
                END DO
                DO i=1,2
* p.q -- p.q=ce0em(i),p=c41fz(i).e,q=c36w.e
                  ce0em(i)=c41fz(i).e(0)*c36w.e(0)-c41fz(i).e(1)*c36w.
     &              e(1)-c
     &              41fz(i).e(2)*c36w.e(2)-c41fz(i).e(3)*c36w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0ep(i),p=c41fz(i).e,q=c52w.e
                  ce0ep(i)=c41fz(i).e(0)*c52w.e(0)-c41fz(i).e(1)*c52w.
     &              e(1)-c
     &              41fz(i).e(2)*c52w.e(2)-c41fz(i).e(3)*c52w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0pm(i),p=c41fz(i).e,q=p36
                  ce0pm(i)=c41fz(i).e(0)*p36(0)-c41fz(i).e(1)*p36(1)
     &              -c41fz(i
     &              ).e(2)*p36(2)-c41fz(i).e(3)*p36(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0pp(i),p=c41fz(i).e,q=p25
                  ce0pp(i)=c41fz(i).e(0)*p25(0)-c41fz(i).e(1)*p25(1)
     &              -c41fz(i
     &              ).e(2)*p25(2)-c41fz(i).e(3)*p25(3)
                END DO
* p.q -- p.q=cemep,p=c36w.e,q=c52w.e
                cemep=c36w.e(0)*c52w.e(0)-c36w.e(1)*c52w.e(1)-c36w.e(2)
     &            *c5
     &            2w.e(2)-c36w.e(3)*c52w.e(3)
* p.q -- p.q=cempp,p=c36w.e,q=p25
                cempp=c36w.e(0)*p25(0)-c36w.e(1)*p25(1)-c36w.e(2)*p25(2)
     &            -c
     &            36w.e(3)*p25(3)
* p.q -- p.q=ceppm,p=c52w.e,q=p36
                ceppm=c52w.e(0)*p36(0)-c52w.e(1)*p36(1)-c52w.e(2)*p36(2)
     &            -c
     &            52w.e(3)*p36(3)
* p.q -- p.q=p0pm,p=p14,q=p36
                p0pm=p14(0)*p36(0)-p14(1)*p36(1)-p14(2)*p36(2)-p14(3)
     &            *p36(
     &            3)
* p.q -- p.q=p0pp,p=p14,q=p25
                p0pp=p14(0)*p25(0)-p14(1)*p25(1)-p14(2)*p25(2)-p14(3)
     &            *p25(
     &            3)
* p.q -- p.q=pmpp,p=p36,q=p25
                pmpp=p36(0)*p25(0)-p36(1)*p25(1)-p36(2)*p25(2)-p36(3)
     &            *p25(
     &            3)
                DO i=1,2
                  cc13(i)=cc13(i)+ce0pm(i)*cepp0*cempp-ce0pp(i)
     &              *ceppm*cemp0+
     &              p0pp*(ce0em(i)*ceppm-cemep*ce0pm(i))+
     &              p0pm*(cemep*ce0pp(i)-ce0ep(i)*cempp)+
     &              pmpp*(ce0ep(i)*cemp0-ce0em(i)*cepp0)
                END DO

              ENDIF
              IF (zz.NE.0.d0) THEN
                DO m=0,3
                  cpau(m)=cepp0*c36w.e(m)-cemp0*c52w.e(m)
                  pau(m)=p25(m)-p36(m)
                ENDDO
                DO i=1,2
* eps -- eps=cau(i),p=c41z(i).e,q=cpau,r=p14,s=pau
                  cau(i)=c41z(i).e(0)*(cpau(1)*(p14(2)*pau(3)-p14(3)
     &              *pau(2))
     &              +cpau(2)*(p14(3)*pau(1)-p14(1)*pau(3))+cpau(3)
     &              *(p14(1)*pa
     &              u(2)-p14(2)*pau(1)))
                  cau(i)=cau(i)-c41z(i).e(1)*(cpau(2)*(p14(3)*pau(0)
     &              -p14(0)*
     &              pau(3))+cpau(3)*(p14(0)*pau(2)-p14(2)*pau(0))
     &              +cpau(0)*(p1
     &              4(2)*pau(3)-p14(3)*pau(2)))
                  cau(i)=cau(i)+c41z(i).e(2)*(cpau(3)*(p14(0)*pau(1)
     &              -p14(1)*
     &              pau(0))+cpau(0)*(p14(1)*pau(3)-p14(3)*pau(1))
     &              +cpau(1)*(p1
     &              4(3)*pau(0)-p14(0)*pau(3)))
                  cau(i)=cau(i)-c41z(i).e(3)*(cpau(0)*(p14(1)*pau(2)
     &              -p14(2)*
     &              pau(1))+cpau(1)*(p14(2)*pau(0)-p14(0)*pau(2))
     &              +cpau(2)*(p1
     &              4(0)*pau(1)-p14(1)*pau(0)))
                END DO
                DO i=1,2
                  cc13(i)=cc13(i)+cim*zz*cau(i)
                ENDDO
              ENDIF
            ENDIF
* end anomalous couplings
*
* diagramma cc14
*
* quqd -- p=p356,q=p2
            quqd=p356(0)*p2(0)-p356(1)*p2(1)-p356(2)*p2(2)-p356(3)*p2(
     &        3)
            DO i=1,2
* TWR0 -- qu=p356,qd=p2,v=c41fz2(i).e,a=r2_14(i).a,b=r2_14(i).b,cl=1.d0,nsu
* m=0
              ceps_0=-c41fz2(i).ek0*(p356(2)*p2(3)-p2(2)*p356(3))+p356k0
     &          *(c41fz2(i).e(2)*p2(3)-p2(2)*c41fz2(i).e(3))
     &          -p2k0*(c41fz2
     &          (i).e(2)*p356(3)-p356(2)*c41fz2(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c41fz2(i).e(3)*p2k0+p2(3)*c41fz2(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c41fz2(i).e(0)*p356(0)-c41fz2(i).e(1)*p356(1)-c41fz2(
     &          i).e(2)*p356(2)-c41fz2(i).e(3)*p356(3)
              cvqd=c41fz2(i).e(0)*p2(0)-c41fz2(i).e(1)*p2(1)-c41fz2(i).e
     &          (2)*p2(2)-c41fz2(i).e(3)*p2(3)
              cauxa=-c41fz2(i).ek0*quqd+p356k0*cvqd+p2k0*cvqu
              cauxb=-c41fz2(i).ek0*p2(2)+p2k0*c41fz2(i).e(2)
              r2_14(i).a(2)=1.d0*(cauxa-ceps_0)
              r2_14(i).b(1)=1.d0*(cauxb-ceps_2)
            END DO
            DO i=1,2
* TLTR0_W -- aa=cc14(i),a1=l5_36w.a,c1=l5_36w.c,a2=r2_14(i).a,b2=r2_14(i).b
* ,prq=p356q,den=(p356q*p356k0),nsum=0
              cc14(i)=( l5_36w.c(2)*p356q*r2_14(i).b(1)+l5_36w.a(2)*r2_1
     &          4(i).a(2) )/(p356q*p356k0)
            END DO
*
* diagramma cc15
*
* quqd -- p=p5,q=p145
            quqd=p5(0)*p145(0)-p5(1)*p145(1)-p5(2)*p145(2)-p5(3)*p145(
     &        3)
            DO i=1,2
* TWL0 -- qu=p5,qd=p145,v=c41z(i).e,a=l5_14(i).a,c=l5_14(i).c,cl=z5l,nsum=0
              ceps_0=-c41z(i).ek0*(p5(2)*p145(3)-p145(2)*p5(3))+p5k0*(c4
     &          1z(i).e(2)*p145(3)-p145(2)*c41z(i).e(3))
     &          -p145k0*(c41z(i).
     &          e(2)*p5(3)-p5(2)*c41z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c41z(i).e(3)*p5k0+p5(3)*c41z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c41z(i).e(0)*p5(0)-c41z(i).e(1)*p5(1)-c41z(i).e(2)*p5
     &          (2)-c41z(i).e(3)*p5(3)
              cvqd=c41z(i).e(0)*p145(0)-c41z(i).e(1)*p145(1)-c41z(i).e(2
     &          )*p145(2)-c41z(i).e(3)*p145(3)
              cauxa=-c41z(i).ek0*quqd+p5k0*cvqd+p145k0*cvqu
              cauxc=+c41z(i).ek0*p5(2)-p5k0*c41z(i).e(2)
              l5_14(i).a(2)=z5l*(cauxa-ceps_0)
              l5_14(i).c(2)=z5l*(-cauxc+ceps_1)
            END DO
            DO i=1,2
* TLTR0_W -- aa=cc15(i),a1=l5_14(i).a,c1=l5_14(i).c,a2=r2_36w.a,b2=r2_36w.b
* ,prq=p145q,den=(p145q*p145k0),nsum=0
              cc15(i)=( l5_14(i).c(2)*p145q*r2_36w.b(1)+l5_14(i).a(2)*r2
     &          _36w.a(2) )/(p145q*p145k0)
            END DO
*
* diagramma cc16
*
* quqd -- p=p1,q=p125
            quqd=p1(0)*p125(0)-p1(1)*p125(1)-p1(2)*p125(2)-p1(3)*p125(
     &        3)
* TWL0 -- qu=p1,qd=p125,v=c52w.e,a=l1_25w.a,c=l1_25w.c,cl=wcl,nsum=0
            ceps_0=-c52w.ek0*(p1(2)*p125(3)-p125(2)*p1(3))+p1k0*(c52w.
     &        e(2)*p125(3)-p125(2)*c52w.e(3))-p125k0*(c52w.e(2)*p1(3)-p
     &        1(2)*c52w.e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c52w.e(3)*p1k0+p1(3)*c52w.ek0
            ceps_1=ceps_1*cim
            cvqu=c52w.e(0)*p1(0)-c52w.e(1)*p1(1)-c52w.e(2)*p1(2)-c52w.
     &        e(3)*p1(3)
            cvqd=c52w.e(0)*p125(0)-c52w.e(1)*p125(1)-c52w.e(2)*p125(2)
     &        -c52w.e(3)*p125(3)
            cauxa=-c52w.ek0*quqd+p1k0*cvqd+p125k0*cvqu
            cauxc=+c52w.ek0*p1(2)-p1k0*c52w.e(2)
            l1_25w.a(2)=wcl*(cauxa-ceps_0)
            l1_25w.c(2)=wcl*(-cauxc+ceps_1)
* TLTR0_W -- aa=cc16(&),a1=l1_25w.a,c1=l1_25w.c,a2=r4_36w.a,b2=r4_36w.b,prq
* =p125q,den=(p125q*p125k0),nsum=0
            cc16(2)=( l1_25w.c(2)*p125q*r4_36w.b(1)+l1_25w.a(2)*r4_36w
     &        .a(2) )/(p125q*p125k0)
*
* diagramma cc17
*
* quqd -- p=p3,q=p235
            quqd=p3(0)*p235(0)-p3(1)*p235(1)-p3(2)*p235(2)-p3(3)*p235(
     &        3)
* TWL0 -- qu=p3,qd=p235,v=c52w.e,a=l3_25w.a,c=l3_25w.c,cl=wcl,nsum=0
            ceps_0=-c52w.ek0*(p3(2)*p235(3)-p235(2)*p3(3))+p3k0*(c52w.
     &        e(2)*p235(3)-p235(2)*c52w.e(3))-p235k0*(c52w.e(2)*p3(3)-p
     &        3(2)*c52w.e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c52w.e(3)*p3k0+p3(3)*c52w.ek0
            ceps_1=ceps_1*cim
            cvqu=c52w.e(0)*p3(0)-c52w.e(1)*p3(1)-c52w.e(2)*p3(2)-c52w.
     &        e(3)*p3(3)
            cvqd=c52w.e(0)*p235(0)-c52w.e(1)*p235(1)-c52w.e(2)*p235(2)
     &        -c52w.e(3)*p235(3)
            cauxa=-c52w.ek0*quqd+p3k0*cvqd+p235k0*cvqu
            cauxc=+c52w.ek0*p3(2)-p3k0*c52w.e(2)
            l3_25w.a(2)=wcl*(cauxa-ceps_0)
            l3_25w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p235,q=p6
            quqd=p235(0)*p6(0)-p235(1)*p6(1)-p235(2)*p6(2)-p235(3)*p6(
     &        3)
            DO i=1,2
* TWR0 -- qu=p235,qd=p6,v=c41fz6(i).e,a=r6_14(i).a,b=r6_14(i).b,cl=1.d0,nsu
* m=0
              ceps_0=-c41fz6(i).ek0*(p235(2)*p6(3)-p6(2)*p235(3))+p235k0
     &          *(c41fz6(i).e(2)*p6(3)-p6(2)*c41fz6(i).e(3))
     &          -p6k0*(c41fz6
     &          (i).e(2)*p235(3)-p235(2)*c41fz6(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c41fz6(i).e(3)*p6k0+p6(3)*c41fz6(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c41fz6(i).e(0)*p235(0)-c41fz6(i).e(1)*p235(1)-c41fz6(
     &          i).e(2)*p235(2)-c41fz6(i).e(3)*p235(3)
              cvqd=c41fz6(i).e(0)*p6(0)-c41fz6(i).e(1)*p6(1)-c41fz6(i).e
     &          (2)*p6(2)-c41fz6(i).e(3)*p6(3)
              cauxa=-c41fz6(i).ek0*quqd+p235k0*cvqd+p6k0*cvqu
              cauxb=-c41fz6(i).ek0*p6(2)+p6k0*c41fz6(i).e(2)
              r6_14(i).a(2)=1.d0*(cauxa-ceps_0)
              r6_14(i).b(1)=1.d0*(cauxb-ceps_2)
            END DO
            DO i=1,2
* TLTR0_W -- aa=cc17(i),a1=l3_25w.a,c1=l3_25w.c,a2=r6_14(i).a,b2=r6_14(i).b
* ,prq=p235q,den=(p235q*p235k0),nsum=0
              cc17(i)=( l3_25w.c(2)*p235q*r6_14(i).b(1)+l3_25w.a(2)*r6_1
     &          4(i).a(2) )/(p235q*p235k0)
            END DO
*
* diagramma cc18
*
* quqd -- p=p3,q=p134
            quqd=p3(0)*p134(0)-p3(1)*p134(1)-p3(2)*p134(2)-p3(3)*p134(
     &        3)
            DO i=1,2
* TWL0 -- qu=p3,qd=p134,v=c41fz3(i).e,a=l3_14(i).a,c=l3_14(i).c,cl=1.d0,nsu
* m=0
              ceps_0=-c41fz3(i).ek0*(p3(2)*p134(3)-p134(2)*p3(3))+p3k0*(
     &          c41fz3(i).e(2)*p134(3)-p134(2)*c41fz3(i).e(3))
     &          -p134k0*(c4
     &          1fz3(i).e(2)*p3(3)-p3(2)*c41fz3(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c41fz3(i).e(3)*p3k0+p3(3)*c41fz3(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c41fz3(i).e(0)*p3(0)-c41fz3(i).e(1)*p3(1)-c41fz3(i).e
     &          (2)*p3(2)-c41fz3(i).e(3)*p3(3)
              cvqd=c41fz3(i).e(0)*p134(0)-c41fz3(i).e(1)*p134(1)-c41fz3(
     &          i).e(2)*p134(2)-c41fz3(i).e(3)*p134(3)
              cauxa=-c41fz3(i).ek0*quqd+p3k0*cvqd+p134k0*cvqu
              cauxc=+c41fz3(i).ek0*p3(2)-p3k0*c41fz3(i).e(2)
              l3_14(i).a(2)=1.d0*(cauxa-ceps_0)
              l3_14(i).c(2)=1.d0*(-cauxc+ceps_1)
            END DO
* quqd -- p=p134,q=p6
            quqd=p134(0)*p6(0)-p134(1)*p6(1)-p134(2)*p6(2)-p134(3)*p6(
     &        3)
* TWR0 -- qu=p134,qd=p6,v=c52w.e,a=r6_25w.a,b=r6_25w.b,cl=wcl,nsum=0
            ceps_0=-c52w.ek0*(p134(2)*p6(3)-p6(2)*p134(3))+p134k0*(c52
     &        w.e(2)*p6(3)-p6(2)*c52w.e(3))-p6k0*(c52w.e(2)*p134(3)-p13
     &        4(2)*c52w.e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c52w.e(3)*p6k0+p6(3)*c52w.ek0
            ceps_2=ceps_2*cim
            cvqu=c52w.e(0)*p134(0)-c52w.e(1)*p134(1)-c52w.e(2)*p134(2)
     &        -c52w.e(3)*p134(3)
            cvqd=c52w.e(0)*p6(0)-c52w.e(1)*p6(1)-c52w.e(2)*p6(2)-c52w.
     &        e(3)*p6(3)
            cauxa=-c52w.ek0*quqd+p134k0*cvqd+p6k0*cvqu
            cauxb=-c52w.ek0*p6(2)+p6k0*c52w.e(2)
            r6_25w.a(2)=wcl*(cauxa-ceps_0)
            r6_25w.b(1)=wcl*(cauxb-ceps_2)
            DO i=1,2
* TLTR0_W -- aa=cc18(i),a1=l3_14(i).a,c1=l3_14(i).c,a2=r6_25w.a,b2=r6_25w.b
* ,prq=p134q,den=(p134q*p134k0),nsum=0
              cc18(i)=( l3_14(i).c(2)*p134q*r6_25w.b(1)+l3_14(i).a(2)*r6
     &          _25w.a(2) )/(p134q*p134k0)
            END DO

**** fine i4e
          ENDIF
**** fine icc3=/ 1
        ENDIF
**** fine CC
      ENDIF

****  inizio NC
      IF (icc.NE.1) THEN

        DO ide=0,iid
          IF (ide.EQ.1) THEN
*  p3<->p5 per rifare tutti i diagrammi con questo scambio per particelle id.
            DO mu=0,3
              pau(mu)=p3(mu)
              p3(mu)=p5(mu)
              p5(mu)=pau(mu)
              pau(mu)=p25(mu)
              p25(mu)=p23(mu)
              p23(mu)=pau(mu)
              pau(mu)=p34(mu)
              p34(mu)=p45(mu)
              p45(mu)=pau(mu)
              pau(mu)=p36(mu)
              p36(mu)=p56(mu)
              p56(mu)=pau(mu)
              pau(mu)=p123(mu)
              p123(mu)=p125(mu)
              p125(mu)=pau(mu)
              pau(mu)=p134(mu)
              p134(mu)=p145(mu)
              p145(mu)=pau(mu)
              pau(mu)=p156(mu)
              p156(mu)=p136(mu)
              p136(mu)=pau(mu)
            END DO
            pkau=p3k0
            p3k0=p5k0
            p5k0=pkau
            pkau=p3q
            p3q=p5q
            p5q=pkau
            pkau=p123k0
            p123k0=p125k0
            p125k0=pkau
            pkau=p123q
            p123q=p125q
            p125q=pkau
            pkau=p134k0
            p134k0=p145k0
            p145k0=pkau
            pkau=p134q
            p134q=p145q
            p145q=pkau
            pkau=p156k0
            p156k0=p136k0
            p136k0=pkau
            pkau=p156q
            p156q=p136q
            p136q=pkau
          ENDIF
* quqd -- p=p5,q=p6
          quqd=p5(0)*p6(0)-p5(1)*p6(1)-p5(2)*p6(2)-p5(3)*p6(3)
          df=-1.d0/(2.d0*quqd)
          cdz=-1.d0/(2.d0*quqd*czipr-rmz2+ccz)
          fac1=(df*f5r)
          fac2=(df*f5l)
          cfac1z=(cdz*z5r)
          cfac2z=(cdz*z5l)
* T10 -- qu=p5,qd=p6,v=0,a=c56f(&).e(0),cr=fac1,cl=fac2,nsum=0
          eps_0=-p5(2)*p6(3)+p6(2)*p5(3)
          ceps_0=eps_0*cim
          auxa=-quqd+p5k0*p6(0)+p6k0*p5(0)
          c56f(1).e(0)=fac1*(auxa+ceps_0)
          c56f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=1,a=c56f(&).e(1),cr=fac1,cl=fac2,nsum=0
          auxa=-quqd+p5k0*p6(1)+p6k0*p5(1)
          c56f(1).e(1)=fac1*(auxa+ceps_0)
          c56f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=2,a=c56f(&).e(2),cr=fac1,cl=fac2,nsum=0
          eps_0=-p5k0*p6(3)+p6k0*p5(3)
          ceps_0=eps_0*cim
          auxa=p5k0*p6(2)+p6k0*p5(2)
          c56f(1).e(2)=fac1*(auxa+ceps_0)
          c56f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=3,a=c56f(&).e(3),cr=fac1,cl=fac2,nsum=0
          eps_0=p5k0*p6(2)-p6k0*p5(2)
          ceps_0=eps_0*cim
          auxa=p5k0*p6(3)+p6k0*p5(3)
          c56f(1).e(3)=fac1*(auxa+ceps_0)
          c56f(2).e(3)=fac2*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=0,a=c56z(&).e(0),cr=cfac1z,cl=cfac2z,nsum=0
          eps_0=-p5(2)*p6(3)+p6(2)*p5(3)
          ceps_0=eps_0*cim
          auxa=-quqd+p5k0*p6(0)+p6k0*p5(0)
          c56z(1).e(0)=cfac1z*(auxa+ceps_0)
          c56z(2).e(0)=cfac2z*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=1,a=c56z(&).e(1),cr=cfac1z,cl=cfac2z,nsum=0
          auxa=-quqd+p5k0*p6(1)+p6k0*p5(1)
          c56z(1).e(1)=cfac1z*(auxa+ceps_0)
          c56z(2).e(1)=cfac2z*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=2,a=c56z(&).e(2),cr=cfac1z,cl=cfac2z,nsum=0
          eps_0=-p5k0*p6(3)+p6k0*p5(3)
          ceps_0=eps_0*cim
          auxa=p5k0*p6(2)+p6k0*p5(2)
          c56z(1).e(2)=cfac1z*(auxa+ceps_0)
          c56z(2).e(2)=cfac2z*(auxa-ceps_0)
* T10 -- qu=p5,qd=p6,v=3,a=c56z(&).e(3),cr=cfac1z,cl=cfac2z,nsum=0
          eps_0=p5k0*p6(2)-p6k0*p5(2)
          ceps_0=eps_0*cim
          auxa=p5k0*p6(3)+p6k0*p5(3)
          c56z(1).e(3)=cfac1z*(auxa+ceps_0)
          c56z(2).e(3)=cfac2z*(auxa-ceps_0)
          DO i=1,2
* pk0 -- p=c56f(i).e
            c56f(i).ek0=c56f(i).e(0)-c56f(i).e(1)
          END DO
          DO i=1,2
* pk0 -- p=c56z(i).e
            c56z(i).ek0=c56z(i).e(0)-c56z(i).e(1)
          END DO
* quqd -- p=p3,q=p4
          quqd=p3(0)*p4(0)-p3(1)*p4(1)-p3(2)*p4(2)-p3(3)*p4(3)
          df=-1.d0/(2.d0*quqd)
          cdz=-1.d0/(2.d0*quqd*czipr-rmz2+ccz)
          fac1=(df*f3r)
          fac2=(df*f3l)
          cfac1z=(cdz*z3r)
          cfac2z=(cdz*z3l)
* T10 -- qu=p3,qd=p4,v=0,a=c34f(&).e(0),cr=fac1,cl=fac2,nsum=0
          eps_0=-p3(2)*p4(3)+p4(2)*p3(3)
          ceps_0=eps_0*cim
          auxa=-quqd+p3k0*p4(0)+p4k0*p3(0)
          c34f(1).e(0)=fac1*(auxa+ceps_0)
          c34f(2).e(0)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=1,a=c34f(&).e(1),cr=fac1,cl=fac2,nsum=0
          auxa=-quqd+p3k0*p4(1)+p4k0*p3(1)
          c34f(1).e(1)=fac1*(auxa+ceps_0)
          c34f(2).e(1)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=2,a=c34f(&).e(2),cr=fac1,cl=fac2,nsum=0
          eps_0=-p3k0*p4(3)+p4k0*p3(3)
          ceps_0=eps_0*cim
          auxa=p3k0*p4(2)+p4k0*p3(2)
          c34f(1).e(2)=fac1*(auxa+ceps_0)
          c34f(2).e(2)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=3,a=c34f(&).e(3),cr=fac1,cl=fac2,nsum=0
          eps_0=p3k0*p4(2)-p4k0*p3(2)
          ceps_0=eps_0*cim
          auxa=p3k0*p4(3)+p4k0*p3(3)
          c34f(1).e(3)=fac1*(auxa+ceps_0)
          c34f(2).e(3)=fac2*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=0,a=c34z(&).e(0),cr=cfac1z,cl=cfac2z,nsum=0
          eps_0=-p3(2)*p4(3)+p4(2)*p3(3)
          ceps_0=eps_0*cim
          auxa=-quqd+p3k0*p4(0)+p4k0*p3(0)
          c34z(1).e(0)=cfac1z*(auxa+ceps_0)
          c34z(2).e(0)=cfac2z*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=1,a=c34z(&).e(1),cr=cfac1z,cl=cfac2z,nsum=0
          auxa=-quqd+p3k0*p4(1)+p4k0*p3(1)
          c34z(1).e(1)=cfac1z*(auxa+ceps_0)
          c34z(2).e(1)=cfac2z*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=2,a=c34z(&).e(2),cr=cfac1z,cl=cfac2z,nsum=0
          eps_0=-p3k0*p4(3)+p4k0*p3(3)
          ceps_0=eps_0*cim
          auxa=p3k0*p4(2)+p4k0*p3(2)
          c34z(1).e(2)=cfac1z*(auxa+ceps_0)
          c34z(2).e(2)=cfac2z*(auxa-ceps_0)
* T10 -- qu=p3,qd=p4,v=3,a=c34z(&).e(3),cr=cfac1z,cl=cfac2z,nsum=0
          eps_0=p3k0*p4(2)-p4k0*p3(2)
          ceps_0=eps_0*cim
          auxa=p3k0*p4(3)+p4k0*p3(3)
          c34z(1).e(3)=cfac1z*(auxa+ceps_0)
          c34z(2).e(3)=cfac2z*(auxa-ceps_0)
          DO i=1,2
* pk0 -- p=c34f(i).e
            c34f(i).ek0=c34f(i).e(0)-c34f(i).e(1)
          END DO
          DO i=1,2
* pk0 -- p=c34z(i).e
            c34z(i).ek0=c34z(i).e(0)-c34z(i).e(1)
          END DO
*****attaccamento di  c12f(2) a 3
* quqd -- p=p3,q=p123
          quqd=p3(0)*p123(0)-p3(1)*p123(1)-p3(2)*p123(2)-p3(3)*p123(
     &      3)
          DO i=1,2
* TL0 -- qu=p3,qd=p123,v=c12f(i).e,a=l3_12fz(i).a,c=l3_12fz(i).c,cr=f3r,cl=
* f3l,nsum=0
            ceps_0=-c12f(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(c1
     &        2f(i).e(2)*p123(3)-p123(2)*c12f(i).e(3))-p123k0*(c12f(i).
     &        e(2)*p3(3)-p3(2)*c12f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c12f(i).e(3)*p3k0+p3(3)*c12f(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c12f(i).e(0)*p3(0)-c12f(i).e(1)*p3(1)-c12f(i).e(2)*p3
     &        (2)-c12f(i).e(3)*p3(3)
            cvqd=c12f(i).e(0)*p123(0)-c12f(i).e(1)*p123(1)-c12f(i).e(2
     &        )*p123(2)-c12f(i).e(3)*p123(3)
            cauxa=-c12f(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
            cauxc=+c12f(i).ek0*p3(2)-p3k0*c12f(i).e(2)
            l3_12fz(i).a(1)=f3r*(cauxa+ceps_0)
            l3_12fz(i).a(2)=f3l*(cauxa-ceps_0)
            l3_12fz(i).c(1)=f3r*(cauxc+ceps_1)
            l3_12fz(i).c(2)=f3l*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c12z(2) a 3
          DO i=1,2
* TL0 -- qu=p3,qd=p123,v=c12z(i).e,a=l3_12fz(i).a,c=l3_12fz(i).c,cr=z3r,cl=
* z3l,nsum=1
            ceps_0=-c12z(i).ek0*(p3(2)*p123(3)-p123(2)*p3(3))+p3k0*(c1
     &        2z(i).e(2)*p123(3)-p123(2)*c12z(i).e(3))-p123k0*(c12z(i).
     &        e(2)*p3(3)-p3(2)*c12z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c12z(i).e(3)*p3k0+p3(3)*c12z(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c12z(i).e(0)*p3(0)-c12z(i).e(1)*p3(1)-c12z(i).e(2)*p3
     &        (2)-c12z(i).e(3)*p3(3)
            cvqd=c12z(i).e(0)*p123(0)-c12z(i).e(1)*p123(1)-c12z(i).e(2
     &        )*p123(2)-c12z(i).e(3)*p123(3)
            cauxa=-c12z(i).ek0*quqd+p3k0*cvqd+p123k0*cvqu
            cauxc=+c12z(i).ek0*p3(2)-p3k0*c12z(i).e(2)
            l3_12fz(i).a(1)=l3_12fz(i).a(1)+z3r*(cauxa+ceps_0)
            l3_12fz(i).a(2)=l3_12fz(i).a(2)+z3l*(cauxa-ceps_0)
            l3_12fz(i).c(1)=l3_12fz(i).c(1)+z3r*(cauxc+ceps_1)
            l3_12fz(i).c(2)=l3_12fz(i).c(2)+z3l*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c12f(2) a 4
* quqd -- p=p356,q=p4
          quqd=p356(0)*p4(0)-p356(1)*p4(1)-p356(2)*p4(2)-p356(3)*p4(
     &      3)
          DO i=1,2
* TR0 -- qu=p356,qd=p4,v=c12f(i).e,a=r4_12fz(i).a,b=r4_12fz(i).b,cr=f4r,cl=
* f4l,nsum=0
            ceps_0=-c12f(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0*(
     &        c12f(i).e(2)*p4(3)-p4(2)*c12f(i).e(3))-p4k0*(c12f(i).e(2)
     &        *p356(3)-p356(2)*c12f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c12f(i).e(3)*p4k0+p4(3)*c12f(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c12f(i).e(0)*p356(0)-c12f(i).e(1)*p356(1)-c12f(i).e(2
     &        )*p356(2)-c12f(i).e(3)*p356(3)
            cvqd=c12f(i).e(0)*p4(0)-c12f(i).e(1)*p4(1)-c12f(i).e(2)*p4
     &        (2)-c12f(i).e(3)*p4(3)
            cauxa=-c12f(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
            cauxb=-c12f(i).ek0*p4(2)+p4k0*c12f(i).e(2)
            r4_12fz(i).a(1)=f4r*(cauxa+ceps_0)
            r4_12fz(i).a(2)=f4l*(cauxa-ceps_0)
            r4_12fz(i).b(1)=f4l*(cauxb-ceps_2)
            r4_12fz(i).b(2)=f4r*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c12z(2) a 4
          DO i=1,2
* TR0 -- qu=p356,qd=p4,v=c12z(i).e,a=r4_12fz(i).a,b=r4_12fz(i).b,cr=z4r,cl=
* z4l,nsum=1
            ceps_0=-c12z(i).ek0*(p356(2)*p4(3)-p4(2)*p356(3))+p356k0*(
     &        c12z(i).e(2)*p4(3)-p4(2)*c12z(i).e(3))-p4k0*(c12z(i).e(2)
     &        *p356(3)-p356(2)*c12z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c12z(i).e(3)*p4k0+p4(3)*c12z(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c12z(i).e(0)*p356(0)-c12z(i).e(1)*p356(1)-c12z(i).e(2
     &        )*p356(2)-c12z(i).e(3)*p356(3)
            cvqd=c12z(i).e(0)*p4(0)-c12z(i).e(1)*p4(1)-c12z(i).e(2)*p4
     &        (2)-c12z(i).e(3)*p4(3)
            cauxa=-c12z(i).ek0*quqd+p356k0*cvqd+p4k0*cvqu
            cauxb=-c12z(i).ek0*p4(2)+p4k0*c12z(i).e(2)
            r4_12fz(i).a(1)=r4_12fz(i).a(1)+z4r*(cauxa+ceps_0)
            r4_12fz(i).a(2)=r4_12fz(i).a(2)+z4l*(cauxa-ceps_0)
            r4_12fz(i).b(1)=r4_12fz(i).b(1)+z4l*(cauxb-ceps_2)
            r4_12fz(i).b(2)=r4_12fz(i).b(2)+z4r*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c34f(2) a 1 (e+)
* quqd -- p=p1,q=p134
          quqd=p1(0)*p134(0)-p1(1)*p134(1)-p1(2)*p134(2)-p1(3)*p134(
     &      3)
          DO i1=1,2
* TL0 -- qu=p1,qd=p134,v=c34f(i1).e,a=l1_34fz(i1).a,c=l1_34fz(i1).c,cr=fer,
* cl=fel,nsum=0
            ceps_0=-c34f(i1).ek0*(p1(2)*p134(3)-p134(2)*p1(3))+p1k0*(c
     &        34f(i1).e(2)*p134(3)-p134(2)*c34f(i1).e(3))-p134k0*(c34f(
     &        i1).e(2)*p1(3)-p1(2)*c34f(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34f(i1).e(3)*p1k0+p1(3)*c34f(i1).ek0
            ceps_1=ceps_1*cim
            cvqu=c34f(i1).e(0)*p1(0)-c34f(i1).e(1)*p1(1)-c34f(i1).e(2)
     &        *p1(2)-c34f(i1).e(3)*p1(3)
            cvqd=c34f(i1).e(0)*p134(0)-c34f(i1).e(1)*p134(1)-c34f(i1).
     &        e(2)*p134(2)-c34f(i1).e(3)*p134(3)
            cauxa=-c34f(i1).ek0*quqd+p1k0*cvqd+p134k0*cvqu
            cauxc=+c34f(i1).ek0*p1(2)-p1k0*c34f(i1).e(2)
            l1_34fz(i1).a(1)=fer*(cauxa+ceps_0)
            l1_34fz(i1).a(2)=fel*(cauxa-ceps_0)
            l1_34fz(i1).c(1)=fer*(cauxc+ceps_1)
            l1_34fz(i1).c(2)=fel*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c34z(2) a 1 (e+)
          DO i1=1,2
* TL0 -- qu=p1,qd=p134,v=c34z(i1).e,a=l1_34fz(i1).a,c=l1_34fz(i1).c,cr=zer,
* cl=zel,nsum=1
            ceps_0=-c34z(i1).ek0*(p1(2)*p134(3)-p134(2)*p1(3))+p1k0*(c
     &        34z(i1).e(2)*p134(3)-p134(2)*c34z(i1).e(3))-p134k0*(c34z(
     &        i1).e(2)*p1(3)-p1(2)*c34z(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34z(i1).e(3)*p1k0+p1(3)*c34z(i1).ek0
            ceps_1=ceps_1*cim
            cvqu=c34z(i1).e(0)*p1(0)-c34z(i1).e(1)*p1(1)-c34z(i1).e(2)
     &        *p1(2)-c34z(i1).e(3)*p1(3)
            cvqd=c34z(i1).e(0)*p134(0)-c34z(i1).e(1)*p134(1)-c34z(i1).
     &        e(2)*p134(2)-c34z(i1).e(3)*p134(3)
            cauxa=-c34z(i1).ek0*quqd+p1k0*cvqd+p134k0*cvqu
            cauxc=+c34z(i1).ek0*p1(2)-p1k0*c34z(i1).e(2)
            l1_34fz(i1).a(1)=l1_34fz(i1).a(1)+zer*(cauxa+ceps_0)
            l1_34fz(i1).a(2)=l1_34fz(i1).a(2)+zel*(cauxa-ceps_0)
            l1_34fz(i1).c(1)=l1_34fz(i1).c(1)+zer*(cauxc+ceps_1)
            l1_34fz(i1).c(2)=l1_34fz(i1).c(2)+zel*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c34f(2) a 2 (e-)
* quqd -- p=p156,q=p2
          quqd=p156(0)*p2(0)-p156(1)*p2(1)-p156(2)*p2(2)-p156(3)*p2(
     &      3)
          DO i1=1,2
* TR0 -- qu=p156,qd=p2,v=c34f(i1).e,a=r2_34fz(i1).a,b=r2_34fz(i1).b,cr=fer,
* cl=fel,nsum=0
            ceps_0=-c34f(i1).ek0*(p156(2)*p2(3)-p2(2)*p156(3))+p156k0*
     &        (c34f(i1).e(2)*p2(3)-p2(2)*c34f(i1).e(3))-p2k0*(c34f(i1).
     &        e(2)*p156(3)-p156(2)*c34f(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34f(i1).e(3)*p2k0+p2(3)*c34f(i1).ek0
            ceps_2=ceps_2*cim
            cvqu=c34f(i1).e(0)*p156(0)-c34f(i1).e(1)*p156(1)-c34f(i1).
     &        e(2)*p156(2)-c34f(i1).e(3)*p156(3)
            cvqd=c34f(i1).e(0)*p2(0)-c34f(i1).e(1)*p2(1)-c34f(i1).e(2)
     &        *p2(2)-c34f(i1).e(3)*p2(3)
            cauxa=-c34f(i1).ek0*quqd+p156k0*cvqd+p2k0*cvqu
            cauxb=-c34f(i1).ek0*p2(2)+p2k0*c34f(i1).e(2)
            r2_34fz(i1).a(1)=fer*(cauxa+ceps_0)
            r2_34fz(i1).a(2)=fel*(cauxa-ceps_0)
            r2_34fz(i1).b(1)=fel*(cauxb-ceps_2)
            r2_34fz(i1).b(2)=fer*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c34z(2) a 2 (e-)
          DO i1=1,2
* TR0 -- qu=p156,qd=p2,v=c34z(i1).e,a=r2_34fz(i1).a,b=r2_34fz(i1).b,cr=zer,
* cl=zel,nsum=1
            ceps_0=-c34z(i1).ek0*(p156(2)*p2(3)-p2(2)*p156(3))+p156k0*
     &        (c34z(i1).e(2)*p2(3)-p2(2)*c34z(i1).e(3))-p2k0*(c34z(i1).
     &        e(2)*p156(3)-p156(2)*c34z(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34z(i1).e(3)*p2k0+p2(3)*c34z(i1).ek0
            ceps_2=ceps_2*cim
            cvqu=c34z(i1).e(0)*p156(0)-c34z(i1).e(1)*p156(1)-c34z(i1).
     &        e(2)*p156(2)-c34z(i1).e(3)*p156(3)
            cvqd=c34z(i1).e(0)*p2(0)-c34z(i1).e(1)*p2(1)-c34z(i1).e(2)
     &        *p2(2)-c34z(i1).e(3)*p2(3)
            cauxa=-c34z(i1).ek0*quqd+p156k0*cvqd+p2k0*cvqu
            cauxb=-c34z(i1).ek0*p2(2)+p2k0*c34z(i1).e(2)
            r2_34fz(i1).a(1)=r2_34fz(i1).a(1)+zer*(cauxa+ceps_0)
            r2_34fz(i1).a(2)=r2_34fz(i1).a(2)+zel*(cauxa-ceps_0)
            r2_34fz(i1).b(1)=r2_34fz(i1).b(1)+zel*(cauxb-ceps_2)
            r2_34fz(i1).b(2)=r2_34fz(i1).b(2)+zer*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c56f a 3
* quqd -- p=p3,q=p356
          quqd=p3(0)*p356(0)-p3(1)*p356(1)-p3(2)*p356(2)-p3(3)*p356(
     &      3)
          DO i=1,2
* TL0 -- qu=p3,qd=p356,v=c56f(i).e,a=l3_56f(i).a,c=l3_56f(i).c,cr=f3r,cl=f3
* l,nsum=0
            ceps_0=-c56f(i).ek0*(p3(2)*p356(3)-p356(2)*p3(3))+p3k0*(c5
     &        6f(i).e(2)*p356(3)-p356(2)*c56f(i).e(3))-p356k0*(c56f(i).
     &        e(2)*p3(3)-p3(2)*c56f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c56f(i).e(3)*p3k0+p3(3)*c56f(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c56f(i).e(0)*p3(0)-c56f(i).e(1)*p3(1)-c56f(i).e(2)*p3
     &        (2)-c56f(i).e(3)*p3(3)
            cvqd=c56f(i).e(0)*p356(0)-c56f(i).e(1)*p356(1)-c56f(i).e(2
     &        )*p356(2)-c56f(i).e(3)*p356(3)
            cauxa=-c56f(i).ek0*quqd+p3k0*cvqd+p356k0*cvqu
            cauxc=+c56f(i).ek0*p3(2)-p3k0*c56f(i).e(2)
            l3_56f(i).a(1)=f3r*(cauxa+ceps_0)
            l3_56f(i).a(2)=f3l*(cauxa-ceps_0)
            l3_56f(i).c(1)=f3r*(cauxc+ceps_1)
            l3_56f(i).c(2)=f3l*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c56z a 3
          DO i=1,2
* TL0 -- qu=p3,qd=p356,v=c56z(i).e,a=l3_56fz(i).a,c=l3_56fz(i).c,cr=z3r,cl=
* z3l,nsum=0
            ceps_0=-c56z(i).ek0*(p3(2)*p356(3)-p356(2)*p3(3))+p3k0*(c5
     &        6z(i).e(2)*p356(3)-p356(2)*c56z(i).e(3))-p356k0*(c56z(i).
     &        e(2)*p3(3)-p3(2)*c56z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c56z(i).e(3)*p3k0+p3(3)*c56z(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c56z(i).e(0)*p3(0)-c56z(i).e(1)*p3(1)-c56z(i).e(2)*p3
     &        (2)-c56z(i).e(3)*p3(3)
            cvqd=c56z(i).e(0)*p356(0)-c56z(i).e(1)*p356(1)-c56z(i).e(2
     &        )*p356(2)-c56z(i).e(3)*p356(3)
            cauxa=-c56z(i).ek0*quqd+p3k0*cvqd+p356k0*cvqu
            cauxc=+c56z(i).ek0*p3(2)-p3k0*c56z(i).e(2)
            l3_56fz(i).a(1)=z3r*(cauxa+ceps_0)
            l3_56fz(i).a(2)=z3l*(cauxa-ceps_0)
            l3_56fz(i).c(1)=z3r*(cauxc+ceps_1)
            l3_56fz(i).c(2)=z3l*(-cauxc+ceps_1)
          END DO
          DO i=1,2
            DO ii=1,2
              l3_56fz(i).a(ii)=l3_56fz(i).a(ii)+l3_56f(i).a(ii)
              l3_56fz(i).c(ii)=l3_56fz(i).c(ii)+l3_56f(i).c(ii)
            END DO
          END DO
*****attaccamento di  c56f a 4
* quqd -- p=p123,q=p4
          quqd=p123(0)*p4(0)-p123(1)*p4(1)-p123(2)*p4(2)-p123(3)*p4(
     &      3)
          DO i=1,2
* TR0 -- qu=p123,qd=p4,v=c56f(i).e,a=r4_56f(i).a,b=r4_56f(i).b,cr=f4r,cl=f4
* l,nsum=0
            ceps_0=-c56f(i).ek0*(p123(2)*p4(3)-p4(2)*p123(3))+p123k0*(
     &        c56f(i).e(2)*p4(3)-p4(2)*c56f(i).e(3))-p4k0*(c56f(i).e(2)
     &        *p123(3)-p123(2)*c56f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c56f(i).e(3)*p4k0+p4(3)*c56f(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c56f(i).e(0)*p123(0)-c56f(i).e(1)*p123(1)-c56f(i).e(2
     &        )*p123(2)-c56f(i).e(3)*p123(3)
            cvqd=c56f(i).e(0)*p4(0)-c56f(i).e(1)*p4(1)-c56f(i).e(2)*p4
     &        (2)-c56f(i).e(3)*p4(3)
            cauxa=-c56f(i).ek0*quqd+p123k0*cvqd+p4k0*cvqu
            cauxb=-c56f(i).ek0*p4(2)+p4k0*c56f(i).e(2)
            r4_56f(i).a(1)=f4r*(cauxa+ceps_0)
            r4_56f(i).a(2)=f4l*(cauxa-ceps_0)
            r4_56f(i).b(1)=f4l*(cauxb-ceps_2)
            r4_56f(i).b(2)=f4r*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c56z a 4
          DO i=1,2
* TR0 -- qu=p123,qd=p4,v=c56z(i).e,a=r4_56fz(i).a,b=r4_56fz(i).b,cr=z4r,cl=
* z4l,nsum=0
            ceps_0=-c56z(i).ek0*(p123(2)*p4(3)-p4(2)*p123(3))+p123k0*(
     &        c56z(i).e(2)*p4(3)-p4(2)*c56z(i).e(3))-p4k0*(c56z(i).e(2)
     &        *p123(3)-p123(2)*c56z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c56z(i).e(3)*p4k0+p4(3)*c56z(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c56z(i).e(0)*p123(0)-c56z(i).e(1)*p123(1)-c56z(i).e(2
     &        )*p123(2)-c56z(i).e(3)*p123(3)
            cvqd=c56z(i).e(0)*p4(0)-c56z(i).e(1)*p4(1)-c56z(i).e(2)*p4
     &        (2)-c56z(i).e(3)*p4(3)
            cauxa=-c56z(i).ek0*quqd+p123k0*cvqd+p4k0*cvqu
            cauxb=-c56z(i).ek0*p4(2)+p4k0*c56z(i).e(2)
            r4_56fz(i).a(1)=z4r*(cauxa+ceps_0)
            r4_56fz(i).a(2)=z4l*(cauxa-ceps_0)
            r4_56fz(i).b(1)=z4l*(cauxb-ceps_2)
            r4_56fz(i).b(2)=z4r*(-cauxb-ceps_2)
          END DO
          DO i=1,2
            DO ii=1,2
              r4_56fz(i).a(ii)=r4_56fz(i).a(ii)+r4_56f(i).a(ii)
              r4_56fz(i).b(ii)=r4_56fz(i).b(ii)+r4_56f(i).b(ii)
            END DO
          END DO
*****attaccamento di  c12f(2) a 5
* quqd -- p=p5,q=p125
          quqd=p5(0)*p125(0)-p5(1)*p125(1)-p5(2)*p125(2)-p5(3)*p125(
     &      3)
          DO i=1,2
* TL0 -- qu=p5,qd=p125,v=c12f(i).e,a=l5_12fz(i).a,c=l5_12fz(i).c,cr=f5r,cl=
* f5l,nsum=0
            ceps_0=-c12f(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(c1
     &        2f(i).e(2)*p125(3)-p125(2)*c12f(i).e(3))-p125k0*(c12f(i).
     &        e(2)*p5(3)-p5(2)*c12f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c12f(i).e(3)*p5k0+p5(3)*c12f(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c12f(i).e(0)*p5(0)-c12f(i).e(1)*p5(1)-c12f(i).e(2)*p5
     &        (2)-c12f(i).e(3)*p5(3)
            cvqd=c12f(i).e(0)*p125(0)-c12f(i).e(1)*p125(1)-c12f(i).e(2
     &        )*p125(2)-c12f(i).e(3)*p125(3)
            cauxa=-c12f(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
            cauxc=+c12f(i).ek0*p5(2)-p5k0*c12f(i).e(2)
            l5_12fz(i).a(1)=f5r*(cauxa+ceps_0)
            l5_12fz(i).a(2)=f5l*(cauxa-ceps_0)
            l5_12fz(i).c(1)=f5r*(cauxc+ceps_1)
            l5_12fz(i).c(2)=f5l*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c12z(2) a 5
          DO i=1,2
* TL0 -- qu=p5,qd=p125,v=c12z(i).e,a=l5_12fz(i).a,c=l5_12fz(i).c,cr=z5r,cl=
* z5l,nsum=1
            ceps_0=-c12z(i).ek0*(p5(2)*p125(3)-p125(2)*p5(3))+p5k0*(c1
     &        2z(i).e(2)*p125(3)-p125(2)*c12z(i).e(3))-p125k0*(c12z(i).
     &        e(2)*p5(3)-p5(2)*c12z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c12z(i).e(3)*p5k0+p5(3)*c12z(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c12z(i).e(0)*p5(0)-c12z(i).e(1)*p5(1)-c12z(i).e(2)*p5
     &        (2)-c12z(i).e(3)*p5(3)
            cvqd=c12z(i).e(0)*p125(0)-c12z(i).e(1)*p125(1)-c12z(i).e(2
     &        )*p125(2)-c12z(i).e(3)*p125(3)
            cauxa=-c12z(i).ek0*quqd+p5k0*cvqd+p125k0*cvqu
            cauxc=+c12z(i).ek0*p5(2)-p5k0*c12z(i).e(2)
            l5_12fz(i).a(1)=l5_12fz(i).a(1)+z5r*(cauxa+ceps_0)
            l5_12fz(i).a(2)=l5_12fz(i).a(2)+z5l*(cauxa-ceps_0)
            l5_12fz(i).c(1)=l5_12fz(i).c(1)+z5r*(cauxc+ceps_1)
            l5_12fz(i).c(2)=l5_12fz(i).c(2)+z5l*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c12f(2) a 6
* quqd -- p=p345,q=p6
          quqd=p345(0)*p6(0)-p345(1)*p6(1)-p345(2)*p6(2)-p345(3)*p6(
     &      3)
          DO i=1,2
* TR0 -- qu=p345,qd=p6,v=c12f(i).e,a=r6_12fz(i).a,b=r6_12fz(i).b,cr=f6r,cl=
* f6l,nsum=0
            ceps_0=-c12f(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0*(
     &        c12f(i).e(2)*p6(3)-p6(2)*c12f(i).e(3))-p6k0*(c12f(i).e(2)
     &        *p345(3)-p345(2)*c12f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c12f(i).e(3)*p6k0+p6(3)*c12f(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c12f(i).e(0)*p345(0)-c12f(i).e(1)*p345(1)-c12f(i).e(2
     &        )*p345(2)-c12f(i).e(3)*p345(3)
            cvqd=c12f(i).e(0)*p6(0)-c12f(i).e(1)*p6(1)-c12f(i).e(2)*p6
     &        (2)-c12f(i).e(3)*p6(3)
            cauxa=-c12f(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
            cauxb=-c12f(i).ek0*p6(2)+p6k0*c12f(i).e(2)
            r6_12fz(i).a(1)=f6r*(cauxa+ceps_0)
            r6_12fz(i).a(2)=f6l*(cauxa-ceps_0)
            r6_12fz(i).b(1)=f6l*(cauxb-ceps_2)
            r6_12fz(i).b(2)=f6r*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c12z(2) a 6
          DO i=1,2
* TR0 -- qu=p345,qd=p6,v=c12z(i).e,a=r6_12fz(i).a,b=r6_12fz(i).b,cr=z6r,cl=
* z6l,nsum=1
            ceps_0=-c12z(i).ek0*(p345(2)*p6(3)-p6(2)*p345(3))+p345k0*(
     &        c12z(i).e(2)*p6(3)-p6(2)*c12z(i).e(3))-p6k0*(c12z(i).e(2)
     &        *p345(3)-p345(2)*c12z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c12z(i).e(3)*p6k0+p6(3)*c12z(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c12z(i).e(0)*p345(0)-c12z(i).e(1)*p345(1)-c12z(i).e(2
     &        )*p345(2)-c12z(i).e(3)*p345(3)
            cvqd=c12z(i).e(0)*p6(0)-c12z(i).e(1)*p6(1)-c12z(i).e(2)*p6
     &        (2)-c12z(i).e(3)*p6(3)
            cauxa=-c12z(i).ek0*quqd+p345k0*cvqd+p6k0*cvqu
            cauxb=-c12z(i).ek0*p6(2)+p6k0*c12z(i).e(2)
            r6_12fz(i).a(1)=r6_12fz(i).a(1)+z6r*(cauxa+ceps_0)
            r6_12fz(i).a(2)=r6_12fz(i).a(2)+z6l*(cauxa-ceps_0)
            r6_12fz(i).b(1)=r6_12fz(i).b(1)+z6l*(cauxb-ceps_2)
            r6_12fz(i).b(2)=r6_12fz(i).b(2)+z6r*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c56f(2) a 1 (e+)
* quqd -- p=p1,q=p156
          quqd=p1(0)*p156(0)-p1(1)*p156(1)-p1(2)*p156(2)-p1(3)*p156(
     &      3)
          DO i1=1,2
* TL0 -- qu=p1,qd=p156,v=c56f(i1).e,a=l1_56fz(i1).a,c=l1_56fz(i1).c,cr=fer,
* cl=fel,nsum=0
            ceps_0=-c56f(i1).ek0*(p1(2)*p156(3)-p156(2)*p1(3))+p1k0*(c
     &        56f(i1).e(2)*p156(3)-p156(2)*c56f(i1).e(3))-p156k0*(c56f(
     &        i1).e(2)*p1(3)-p1(2)*c56f(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c56f(i1).e(3)*p1k0+p1(3)*c56f(i1).ek0
            ceps_1=ceps_1*cim
            cvqu=c56f(i1).e(0)*p1(0)-c56f(i1).e(1)*p1(1)-c56f(i1).e(2)
     &        *p1(2)-c56f(i1).e(3)*p1(3)
            cvqd=c56f(i1).e(0)*p156(0)-c56f(i1).e(1)*p156(1)-c56f(i1).
     &        e(2)*p156(2)-c56f(i1).e(3)*p156(3)
            cauxa=-c56f(i1).ek0*quqd+p1k0*cvqd+p156k0*cvqu
            cauxc=+c56f(i1).ek0*p1(2)-p1k0*c56f(i1).e(2)
            l1_56fz(i1).a(1)=fer*(cauxa+ceps_0)
            l1_56fz(i1).a(2)=fel*(cauxa-ceps_0)
            l1_56fz(i1).c(1)=fer*(cauxc+ceps_1)
            l1_56fz(i1).c(2)=fel*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c56z(2) a 1 (e+)
          DO i1=1,2
* TL0 -- qu=p1,qd=p156,v=c56z(i1).e,a=l1_56fz(i1).a,c=l1_56fz(i1).c,cr=zer,
* cl=zel,nsum=1
            ceps_0=-c56z(i1).ek0*(p1(2)*p156(3)-p156(2)*p1(3))+p1k0*(c
     &        56z(i1).e(2)*p156(3)-p156(2)*c56z(i1).e(3))-p156k0*(c56z(
     &        i1).e(2)*p1(3)-p1(2)*c56z(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c56z(i1).e(3)*p1k0+p1(3)*c56z(i1).ek0
            ceps_1=ceps_1*cim
            cvqu=c56z(i1).e(0)*p1(0)-c56z(i1).e(1)*p1(1)-c56z(i1).e(2)
     &        *p1(2)-c56z(i1).e(3)*p1(3)
            cvqd=c56z(i1).e(0)*p156(0)-c56z(i1).e(1)*p156(1)-c56z(i1).
     &        e(2)*p156(2)-c56z(i1).e(3)*p156(3)
            cauxa=-c56z(i1).ek0*quqd+p1k0*cvqd+p156k0*cvqu
            cauxc=+c56z(i1).ek0*p1(2)-p1k0*c56z(i1).e(2)
            l1_56fz(i1).a(1)=l1_56fz(i1).a(1)+zer*(cauxa+ceps_0)
            l1_56fz(i1).a(2)=l1_56fz(i1).a(2)+zel*(cauxa-ceps_0)
            l1_56fz(i1).c(1)=l1_56fz(i1).c(1)+zer*(cauxc+ceps_1)
            l1_56fz(i1).c(2)=l1_56fz(i1).c(2)+zel*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c56f(2) a 2 (e-)
* quqd -- p=p134,q=p2
          quqd=p134(0)*p2(0)-p134(1)*p2(1)-p134(2)*p2(2)-p134(3)*p2(
     &      3)
          DO i1=1,2
* TR0 -- qu=p134,qd=p2,v=c56f(i1).e,a=r2_56fz(i1).a,b=r2_56fz(i1).b,cr=fer,
* cl=fel,nsum=0
            ceps_0=-c56f(i1).ek0*(p134(2)*p2(3)-p2(2)*p134(3))+p134k0*
     &        (c56f(i1).e(2)*p2(3)-p2(2)*c56f(i1).e(3))-p2k0*(c56f(i1).
     &        e(2)*p134(3)-p134(2)*c56f(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c56f(i1).e(3)*p2k0+p2(3)*c56f(i1).ek0
            ceps_2=ceps_2*cim
            cvqu=c56f(i1).e(0)*p134(0)-c56f(i1).e(1)*p134(1)-c56f(i1).
     &        e(2)*p134(2)-c56f(i1).e(3)*p134(3)
            cvqd=c56f(i1).e(0)*p2(0)-c56f(i1).e(1)*p2(1)-c56f(i1).e(2)
     &        *p2(2)-c56f(i1).e(3)*p2(3)
            cauxa=-c56f(i1).ek0*quqd+p134k0*cvqd+p2k0*cvqu
            cauxb=-c56f(i1).ek0*p2(2)+p2k0*c56f(i1).e(2)
            r2_56fz(i1).a(1)=fer*(cauxa+ceps_0)
            r2_56fz(i1).a(2)=fel*(cauxa-ceps_0)
            r2_56fz(i1).b(1)=fel*(cauxb-ceps_2)
            r2_56fz(i1).b(2)=fer*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c56z(2) a 2 (e-)
          DO i1=1,2
* TR0 -- qu=p134,qd=p2,v=c56z(i1).e,a=r2_56fz(i1).a,b=r2_56fz(i1).b,cr=zer,
* cl=zel,nsum=1
            ceps_0=-c56z(i1).ek0*(p134(2)*p2(3)-p2(2)*p134(3))+p134k0*
     &        (c56z(i1).e(2)*p2(3)-p2(2)*c56z(i1).e(3))-p2k0*(c56z(i1).
     &        e(2)*p134(3)-p134(2)*c56z(i1).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c56z(i1).e(3)*p2k0+p2(3)*c56z(i1).ek0
            ceps_2=ceps_2*cim
            cvqu=c56z(i1).e(0)*p134(0)-c56z(i1).e(1)*p134(1)-c56z(i1).
     &        e(2)*p134(2)-c56z(i1).e(3)*p134(3)
            cvqd=c56z(i1).e(0)*p2(0)-c56z(i1).e(1)*p2(1)-c56z(i1).e(2)
     &        *p2(2)-c56z(i1).e(3)*p2(3)
            cauxa=-c56z(i1).ek0*quqd+p134k0*cvqd+p2k0*cvqu
            cauxb=-c56z(i1).ek0*p2(2)+p2k0*c56z(i1).e(2)
            r2_56fz(i1).a(1)=r2_56fz(i1).a(1)+zer*(cauxa+ceps_0)
            r2_56fz(i1).a(2)=r2_56fz(i1).a(2)+zel*(cauxa-ceps_0)
            r2_56fz(i1).b(1)=r2_56fz(i1).b(1)+zel*(cauxb-ceps_2)
            r2_56fz(i1).b(2)=r2_56fz(i1).b(2)+zer*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c34f a 5
* quqd -- p=p5,q=p345
          quqd=p5(0)*p345(0)-p5(1)*p345(1)-p5(2)*p345(2)-p5(3)*p345(
     &      3)
          DO i=1,2
* TL0 -- qu=p5,qd=p345,v=c34f(i).e,a=l5_34f(i).a,c=l5_34f(i).c,cr=f5r,cl=f5
* l,nsum=0
            ceps_0=-c34f(i).ek0*(p5(2)*p345(3)-p345(2)*p5(3))+p5k0*(c3
     &        4f(i).e(2)*p345(3)-p345(2)*c34f(i).e(3))-p345k0*(c34f(i).
     &        e(2)*p5(3)-p5(2)*c34f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34f(i).e(3)*p5k0+p5(3)*c34f(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c34f(i).e(0)*p5(0)-c34f(i).e(1)*p5(1)-c34f(i).e(2)*p5
     &        (2)-c34f(i).e(3)*p5(3)
            cvqd=c34f(i).e(0)*p345(0)-c34f(i).e(1)*p345(1)-c34f(i).e(2
     &        )*p345(2)-c34f(i).e(3)*p345(3)
            cauxa=-c34f(i).ek0*quqd+p5k0*cvqd+p345k0*cvqu
            cauxc=+c34f(i).ek0*p5(2)-p5k0*c34f(i).e(2)
            l5_34f(i).a(1)=f5r*(cauxa+ceps_0)
            l5_34f(i).a(2)=f5l*(cauxa-ceps_0)
            l5_34f(i).c(1)=f5r*(cauxc+ceps_1)
            l5_34f(i).c(2)=f5l*(-cauxc+ceps_1)
          END DO
*****attaccamento di  c34z a 5
          DO i=1,2
* TL0 -- qu=p5,qd=p345,v=c34z(i).e,a=l5_34fz(i).a,c=l5_34fz(i).c,cr=z5r,cl=
* z5l,nsum=0
            ceps_0=-c34z(i).ek0*(p5(2)*p345(3)-p345(2)*p5(3))+p5k0*(c3
     &        4z(i).e(2)*p345(3)-p345(2)*c34z(i).e(3))-p345k0*(c34z(i).
     &        e(2)*p5(3)-p5(2)*c34z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c34z(i).e(3)*p5k0+p5(3)*c34z(i).ek0
            ceps_1=ceps_1*cim
            cvqu=c34z(i).e(0)*p5(0)-c34z(i).e(1)*p5(1)-c34z(i).e(2)*p5
     &        (2)-c34z(i).e(3)*p5(3)
            cvqd=c34z(i).e(0)*p345(0)-c34z(i).e(1)*p345(1)-c34z(i).e(2
     &        )*p345(2)-c34z(i).e(3)*p345(3)
            cauxa=-c34z(i).ek0*quqd+p5k0*cvqd+p345k0*cvqu
            cauxc=+c34z(i).ek0*p5(2)-p5k0*c34z(i).e(2)
            l5_34fz(i).a(1)=z5r*(cauxa+ceps_0)
            l5_34fz(i).a(2)=z5l*(cauxa-ceps_0)
            l5_34fz(i).c(1)=z5r*(cauxc+ceps_1)
            l5_34fz(i).c(2)=z5l*(-cauxc+ceps_1)
          END DO
          DO i=1,2
            DO ii=1,2
              l5_34fz(i).a(ii)=l5_34fz(i).a(ii)+l5_34f(i).a(ii)
              l5_34fz(i).c(ii)=l5_34fz(i).c(ii)+l5_34f(i).c(ii)
            END DO
          END DO
*****attaccamento di  c34f a 6
* quqd -- p=p125,q=p6
          quqd=p125(0)*p6(0)-p125(1)*p6(1)-p125(2)*p6(2)-p125(3)*p6(
     &      3)
          DO i=1,2
* TR0 -- qu=p125,qd=p6,v=c34f(i).e,a=r6_34f(i).a,b=r6_34f(i).b,cr=f6r,cl=f6
* l,nsum=0
            ceps_0=-c34f(i).ek0*(p125(2)*p6(3)-p6(2)*p125(3))+p125k0*(
     &        c34f(i).e(2)*p6(3)-p6(2)*c34f(i).e(3))-p6k0*(c34f(i).e(2)
     &        *p125(3)-p125(2)*c34f(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34f(i).e(3)*p6k0+p6(3)*c34f(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c34f(i).e(0)*p125(0)-c34f(i).e(1)*p125(1)-c34f(i).e(2
     &        )*p125(2)-c34f(i).e(3)*p125(3)
            cvqd=c34f(i).e(0)*p6(0)-c34f(i).e(1)*p6(1)-c34f(i).e(2)*p6
     &        (2)-c34f(i).e(3)*p6(3)
            cauxa=-c34f(i).ek0*quqd+p125k0*cvqd+p6k0*cvqu
            cauxb=-c34f(i).ek0*p6(2)+p6k0*c34f(i).e(2)
            r6_34f(i).a(1)=f6r*(cauxa+ceps_0)
            r6_34f(i).a(2)=f6l*(cauxa-ceps_0)
            r6_34f(i).b(1)=f6l*(cauxb-ceps_2)
            r6_34f(i).b(2)=f6r*(-cauxb-ceps_2)
          END DO
*****attaccamento di  c34z a 6
          DO i=1,2
* TR0 -- qu=p125,qd=p6,v=c34z(i).e,a=r6_34fz(i).a,b=r6_34fz(i).b,cr=z6r,cl=
* z6l,nsum=0
            ceps_0=-c34z(i).ek0*(p125(2)*p6(3)-p6(2)*p125(3))+p125k0*(
     &        c34z(i).e(2)*p6(3)-p6(2)*c34z(i).e(3))-p6k0*(c34z(i).e(2)
     &        *p125(3)-p125(2)*c34z(i).e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c34z(i).e(3)*p6k0+p6(3)*c34z(i).ek0
            ceps_2=ceps_2*cim
            cvqu=c34z(i).e(0)*p125(0)-c34z(i).e(1)*p125(1)-c34z(i).e(2
     &        )*p125(2)-c34z(i).e(3)*p125(3)
            cvqd=c34z(i).e(0)*p6(0)-c34z(i).e(1)*p6(1)-c34z(i).e(2)*p6
     &        (2)-c34z(i).e(3)*p6(3)
            cauxa=-c34z(i).ek0*quqd+p125k0*cvqd+p6k0*cvqu
            cauxb=-c34z(i).ek0*p6(2)+p6k0*c34z(i).e(2)
            r6_34fz(i).a(1)=z6r*(cauxa+ceps_0)
            r6_34fz(i).a(2)=z6l*(cauxa-ceps_0)
            r6_34fz(i).b(1)=z6l*(cauxb-ceps_2)
            r6_34fz(i).b(2)=z6r*(-cauxb-ceps_2)
          END DO
          DO i=1,2
            DO ii=1,2
              r6_34fz(i).a(ii)=r6_34fz(i).a(ii)+r6_34f(i).a(ii)
              r6_34fz(i).b(ii)=r6_34fz(i).b(ii)+r6_34f(i).b(ii)
            END DO
          END DO
**** Diagramma CN1 ****
          DO i3=1,2
            DO i5=1,2
* TLTR0 -- aa=cn1(&,i3,i5).id(ide),a1=l1_34fz(i3).a,c1=l1_34fz(i3).c,a2=r2_
* 56fz(i5).a,b2=r2_56fz(i5).b,prq=p134q,den=(p134q*p134k0),nsum=0
              cn1(1,i3,i5).id(ide)=( l1_34fz(i3).a(1)*r2_56fz(i5).a(1)+l
     &          1_34fz(i3).c(1)*p134q*r2_56fz(i5).b(2) )/(p134q*p134k0)
              cn1(2,i3,i5).id(ide)=( l1_34fz(i3).c(2)*p134q*r2_56fz(i5).
     &          b(1)+l1_34fz(i3).a(2)*r2_56fz(i5).a(2) )/(p134q*p134k0)
            END DO
          END DO
**** Diagramma CN2 ****
          DO i3=1,2
            DO i5=1,2
* TLTR0 -- aa=cn2(&,i3,i5).id(ide),a1=l1_56fz(i5).a,c1=l1_56fz(i5).c,a2=r2_
* 34fz(i3).a,b2=r2_34fz(i3).b,prq=p156q,den=(p156q*p156k0),nsum=0
              cn2(1,i3,i5).id(ide)=( l1_56fz(i5).a(1)*r2_34fz(i3).a(1)+l
     &          1_56fz(i5).c(1)*p156q*r2_34fz(i3).b(2) )/(p156q*p156k0)
              cn2(2,i3,i5).id(ide)=( l1_56fz(i5).c(2)*p156q*r2_34fz(i3).
     &          b(1)+l1_56fz(i5).a(2)*r2_34fz(i3).a(2) )/(p156q*p156k0)
            END DO
          END DO
**** Diagramma CN3 ****
          DO i1=1,2
            DO i5=1,2
* TLTR0 -- aa=cn3(i1,&,i5).id(ide),a1=l3_56fz(i5).a,c1=l3_56fz(i5).c,a2=r4_
* 12fz(i1).a,b2=r4_12fz(i1).b,prq=p356q,den=(p356q*p356k0),nsum=0
              cn3(i1,1,i5).id(ide)=( l3_56fz(i5).a(1)*r4_12fz(i1).a(1)+l
     &          3_56fz(i5).c(1)*p356q*r4_12fz(i1).b(2) )/(p356q*p356k0)
              cn3(i1,2,i5).id(ide)=( l3_56fz(i5).c(2)*p356q*r4_12fz(i1).
     &          b(1)+l3_56fz(i5).a(2)*r4_12fz(i1).a(2) )/(p356q*p356k0)
            END DO
          END DO
**** Diagramma CN4 ****
          DO i1=1,2
            DO i5=1,2
* TLTR0 -- aa=cn4(i1,&,i5).id(ide),a1=l3_12fz(i1).a,c1=l3_12fz(i1).c,a2=r4_
* 56fz(i5).a,b2=r4_56fz(i5).b,prq=p123q,den=(p123q*p123k0),nsum=0
              cn4(i1,1,i5).id(ide)=( l3_12fz(i1).a(1)*r4_56fz(i5).a(1)+l
     &          3_12fz(i1).c(1)*p123q*r4_56fz(i5).b(2) )/(p123q*p123k0)
              cn4(i1,2,i5).id(ide)=( l3_12fz(i1).c(2)*p123q*r4_56fz(i5).
     &          b(1)+l3_12fz(i1).a(2)*r4_56fz(i5).a(2) )/(p123q*p123k0)
            END DO
          END DO
**** Diagramma CN5 ****
          DO i1=1,2
            DO i3=1,2
* TLTR0 -- aa=cn5(i1,i3,&).id(ide),a1=l5_34fz(i3).a,c1=l5_34fz(i3).c,a2=r6_
* 12fz(i1).a,b2=r6_12fz(i1).b,prq=p345q,den=(p345q*p345k0),nsum=0
              cn5(i1,i3,1).id(ide)=( l5_34fz(i3).a(1)*r6_12fz(i1).a(1)+l
     &          5_34fz(i3).c(1)*p345q*r6_12fz(i1).b(2) )/(p345q*p345k0)
              cn5(i1,i3,2).id(ide)=( l5_34fz(i3).c(2)*p345q*r6_12fz(i1).
     &          b(1)+l5_34fz(i3).a(2)*r6_12fz(i1).a(2) )/(p345q*p345k0)
            END DO
          END DO
**** Diagramma CN6 ****
          DO i1=1,2
            DO i3=1,2
* TLTR0 -- aa=cn6(i1,i3,&).id(ide),a1=l5_12fz(i1).a,c1=l5_12fz(i1).c,a2=r6_
* 34fz(i3).a,b2=r6_34fz(i3).b,prq=p125q,den=(p125q*p125k0),nsum=0
              cn6(i1,i3,1).id(ide)=( l5_12fz(i1).a(1)*r6_34fz(i3).a(1)+l
     &          5_12fz(i1).c(1)*p125q*r6_34fz(i3).b(2) )/(p125q*p125k0)
              cn6(i1,i3,2).id(ide)=( l5_12fz(i1).c(2)*p125q*r6_34fz(i3).
     &          b(1)+l5_12fz(i1).a(2)*r6_34fz(i3).a(2) )/(p125q*p125k0)
            END DO
          END DO
          IF (iqu.EQ.1) THEN
****         8 diagrammi di qcd (4)
* accoppiamenti right e left con fotone sono gli stessi
            r3r5=f3r*f5r
**** Diagramma CN7 ****
            DO i1=1,2
              DO i5=1,2
* TLTR0 -- aa=cn7(i1,&,i5).id(ide),a1=l3_56f(i5).a,c1=l3_56f(i5).c,a2=r4_12
* fz(i1).a,b2=r4_12fz(i1).b,prq=p356q,den=(p356q*p356k0*r3r5),nsum=0
                cn7(i1,1,i5).id(ide)=( l3_56f(i5).a(1)*r4_12fz(i1).a(1)
     &            +l3
     &            _56f(i5).c(1)*p356q*r4_12fz(i1).b(2) )
     &            /(p356q*p356k0*r3r5
     &            )
                cn7(i1,2,i5).id(ide)=( l3_56f(i5).c(2)
     &            *p356q*r4_12fz(i1).b
     &            (1)+l3_56f(i5).a(2)*r4_12fz(i1).a(2) )
     &            /(p356q*p356k0*r3r5
     &            )
              END DO
            END DO
**** Diagramma CN8 ****
            DO i1=1,2
              DO i5=1,2
* TLTR0 -- aa=cn8(i1,&,i5).id(ide),a1=l3_12fz(i1).a,c1=l3_12fz(i1).c,a2=r4_
* 56f(i5).a,b2=r4_56f(i5).b,prq=p123q,den=(p123q*p123k0*r3r5),nsum=0
                cn8(i1,1,i5).id(ide)=( l3_12fz(i1).a(1)*r4_56f(i5).a(1)
     &            +l3
     &            _12fz(i1).c(1)*p123q*r4_56f(i5).b(2) )
     &            /(p123q*p123k0*r3r5
     &            )
                cn8(i1,2,i5).id(ide)=( l3_12fz(i1).c(2)
     &            *p123q*r4_56f(i5).b
     &            (1)+l3_12fz(i1).a(2)*r4_56f(i5).a(2) )
     &            /(p123q*p123k0*r3r5
     &            )
              END DO
            END DO
**** Diagramma CN9 ****
            DO i1=1,2
              DO i3=1,2
* TLTR0 -- aa=cn9(i1,i3,&).id(ide),a1=l5_34f(i3).a,c1=l5_34f(i3).c,a2=r6_12
* fz(i1).a,b2=r6_12fz(i1).b,prq=p345q,den=(p345q*p345k0*r3r5),nsum=0
                cn9(i1,i3,1).id(ide)=( l5_34f(i3).a(1)*r6_12fz(i1).a(1)
     &            +l5
     &            _34f(i3).c(1)*p345q*r6_12fz(i1).b(2) )
     &            /(p345q*p345k0*r3r5
     &            )
                cn9(i1,i3,2).id(ide)=( l5_34f(i3).c(2)
     &            *p345q*r6_12fz(i1).b
     &            (1)+l5_34f(i3).a(2)*r6_12fz(i1).a(2) )
     &            /(p345q*p345k0*r3r5
     &            )
              END DO
            END DO
**** Diagramma CN10 ****
            DO i1=1,2
              DO i3=1,2
* TLTR0 -- aa=cn10(i1,i3,&).id(ide),a1=l5_12fz(i1).a,c1=l5_12fz(i1).c,a2=r6
* _34f(i3).a,b2=r6_34f(i3).b,prq=p125q,den=(p125q*p125k0*r3r5),nsum=0
                cn10(i1,i3,1).id(ide)=( l5_12fz(i1).a(1)*r6_34f(i3).a(1)
     &            +l
     &            5_12fz(i1).c(1)*p125q*r6_34f(i3).b(2) )
     &            /(p125q*p125k0*r3r
     &            5)
                cn10(i1,i3,2).id(ide)=( l5_12fz(i1).c(2)
     &            *p125q*r6_34f(i3).
     &            b(1)+l5_12fz(i1).a(2)*r6_34f(i3).a(2) )
     &            /(p125q*p125k0*r3r
     &            5)
              END DO
            END DO

          ENDIF !iqu
          IF (i34e.EQ.1) THEN
****          24 con coppia 34 elettrone (6)
*******il programma  entro il prossimo dotab e' ripetuto in
*              if (iid.eq.1.and.i34e.eq.1)
* quqd -- p=p3,q=p2
            quqd=p3(0)*p2(0)-p3(1)*p2(1)-p3(2)*p2(2)-p3(3)*p2(3)
            df=2.d0*quqd
            dz=2.d0*quqd+rmz2
            rcr=fer/df
            rcl=fel/df
* T10 -- qu=p3,qd=p2,v=0,a=c23f(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p3(2)*p2(3)+p2(2)*p3(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p3k0*p2(0)+p2k0*p3(0)
            c23f(1).e(0)=rcr*(auxa+ceps_0)
            c23f(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=1,a=c23f(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p3k0*p2(1)+p2k0*p3(1)
            c23f(1).e(1)=rcr*(auxa+ceps_0)
            c23f(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=2,a=c23f(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p3k0*p2(3)+p2k0*p3(3)
            ceps_0=eps_0*cim
            auxa=p3k0*p2(2)+p2k0*p3(2)
            c23f(1).e(2)=rcr*(auxa+ceps_0)
            c23f(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=3,a=c23f(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p3k0*p2(2)-p2k0*p3(2)
            ceps_0=eps_0*cim
            auxa=p3k0*p2(3)+p2k0*p3(3)
            c23f(1).e(3)=rcr*(auxa+ceps_0)
            c23f(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c23f(i).e
              c23f(i).ek0=c23f(i).e(0)-c23f(i).e(1)
            END DO
            rcr=zer/dz
            rcl=zel/dz
* T10 -- qu=p3,qd=p2,v=0,a=c23z(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p3(2)*p2(3)+p2(2)*p3(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p3k0*p2(0)+p2k0*p3(0)
            c23z(1).e(0)=rcr*(auxa+ceps_0)
            c23z(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=1,a=c23z(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p3k0*p2(1)+p2k0*p3(1)
            c23z(1).e(1)=rcr*(auxa+ceps_0)
            c23z(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=2,a=c23z(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p3k0*p2(3)+p2k0*p3(3)
            ceps_0=eps_0*cim
            auxa=p3k0*p2(2)+p2k0*p3(2)
            c23z(1).e(2)=rcr*(auxa+ceps_0)
            c23z(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p3,qd=p2,v=3,a=c23z(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p3k0*p2(2)-p2k0*p3(2)
            ceps_0=eps_0*cim
            auxa=p3k0*p2(3)+p2k0*p3(3)
            c23z(1).e(3)=rcr*(auxa+ceps_0)
            c23z(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c23z(i).e
              c23z(i).ek0=c23z(i).e(0)-c23z(i).e(1)
            END DO
* quqd -- p=p1,q=p4
            quqd=p1(0)*p4(0)-p1(1)*p4(1)-p1(2)*p4(2)-p1(3)*p4(3)
            df=2.d0*quqd
            dz=2.d0*quqd+rmz2
            rcr=fer/df
            rcl=fel/df
* T10 -- qu=p1,qd=p4,v=0,a=c14f(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1(2)*p4(3)+p4(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p4(0)+p4k0*p1(0)
            c14f(1).e(0)=rcr*(auxa+ceps_0)
            c14f(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=1,a=c14f(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p1k0*p4(1)+p4k0*p1(1)
            c14f(1).e(1)=rcr*(auxa+ceps_0)
            c14f(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=2,a=c14f(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1k0*p4(3)+p4k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p4(2)+p4k0*p1(2)
            c14f(1).e(2)=rcr*(auxa+ceps_0)
            c14f(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=3,a=c14f(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p1k0*p4(2)-p4k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p4(3)+p4k0*p1(3)
            c14f(1).e(3)=rcr*(auxa+ceps_0)
            c14f(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c14f(i).e
              c14f(i).ek0=c14f(i).e(0)-c14f(i).e(1)
            END DO
            rcr=zer/dz
            rcl=zel/dz
* T10 -- qu=p1,qd=p4,v=0,a=c14z(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1(2)*p4(3)+p4(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p4(0)+p4k0*p1(0)
            c14z(1).e(0)=rcr*(auxa+ceps_0)
            c14z(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=1,a=c14z(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p1k0*p4(1)+p4k0*p1(1)
            c14z(1).e(1)=rcr*(auxa+ceps_0)
            c14z(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=2,a=c14z(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1k0*p4(3)+p4k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p4(2)+p4k0*p1(2)
            c14z(1).e(2)=rcr*(auxa+ceps_0)
            c14z(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p4,v=3,a=c14z(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p1k0*p4(2)-p4k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p4(3)+p4k0*p1(3)
            c14z(1).e(3)=rcr*(auxa+ceps_0)
            c14z(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c14z(i).e
              c14z(i).ek0=c14z(i).e(0)-c14z(i).e(1)
            END DO
**** attaccamento di c23f(2) a 4
* quqd -- p=p156,q=p4
            quqd=p156(0)*p4(0)-p156(1)*p4(1)-p156(2)*p4(2)-p156(3)*p4(
     &        3)
            DO i=1,2
* TR0 -- qu=p156,qd=p4,v=c23f(i).e,a=r4_23fz(i).a,b=r4_23fz(i).b,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c23f(i).ek0*(p156(2)*p4(3)-p4(2)*p156(3))+p156k0*(
     &          c23f(i).e(2)*p4(3)-p4(2)*c23f(i).e(3))-p4k0*(c23f(i).
     &          e(2)
     &          *p156(3)-p156(2)*c23f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23f(i).e(3)*p4k0+p4(3)*c23f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c23f(i).e(0)*p156(0)-c23f(i).e(1)*p156(1)-c23f(i).e(2
     &          )*p156(2)-c23f(i).e(3)*p156(3)
              cvqd=c23f(i).e(0)*p4(0)-c23f(i).e(1)*p4(1)-c23f(i).e(2)*p4
     &          (2)-c23f(i).e(3)*p4(3)
              cauxa=-c23f(i).ek0*quqd+p156k0*cvqd+p4k0*cvqu
              cauxb=-c23f(i).ek0*p4(2)+p4k0*c23f(i).e(2)
              r4_23fz(i).a(1)=fer*(cauxa+ceps_0)
              r4_23fz(i).a(2)=fel*(cauxa-ceps_0)
              r4_23fz(i).b(1)=fel*(cauxb-ceps_2)
              r4_23fz(i).b(2)=fer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c23z(2) a 4
            DO i=1,2
* TR0 -- qu=p156,qd=p4,v=c23z(i).e,a=r4_23fz(i).a,b=r4_23fz(i).b,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c23z(i).ek0*(p156(2)*p4(3)-p4(2)*p156(3))+p156k0*(
     &          c23z(i).e(2)*p4(3)-p4(2)*c23z(i).e(3))-p4k0*(c23z(i).
     &          e(2)
     &          *p156(3)-p156(2)*c23z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23z(i).e(3)*p4k0+p4(3)*c23z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c23z(i).e(0)*p156(0)-c23z(i).e(1)*p156(1)-c23z(i).e(2
     &          )*p156(2)-c23z(i).e(3)*p156(3)
              cvqd=c23z(i).e(0)*p4(0)-c23z(i).e(1)*p4(1)-c23z(i).e(2)*p4
     &          (2)-c23z(i).e(3)*p4(3)
              cauxa=-c23z(i).ek0*quqd+p156k0*cvqd+p4k0*cvqu
              cauxb=-c23z(i).ek0*p4(2)+p4k0*c23z(i).e(2)
              r4_23fz(i).a(1)=r4_23fz(i).a(1)+zer*(cauxa+ceps_0)
              r4_23fz(i).a(2)=r4_23fz(i).a(2)+zel*(cauxa-ceps_0)
              r4_23fz(i).b(1)=r4_23fz(i).b(1)+zel*(cauxb-ceps_2)
              r4_23fz(i).b(2)=r4_23fz(i).b(2)+zer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c14f(2) a 2
* quqd -- p=p356,q=p2
            quqd=p356(0)*p2(0)-p356(1)*p2(1)-p356(2)*p2(2)-p356(3)*p2(
     &        3)
            DO i=1,2
* TR0 -- qu=p356,qd=p2,v=c14f(i).e,a=r2_14fz(i).a,b=r2_14fz(i).b,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c14f(i).ek0*(p356(2)*p2(3)-p2(2)*p356(3))+p356k0*(
     &          c14f(i).e(2)*p2(3)-p2(2)*c14f(i).e(3))-p2k0*(c14f(i).
     &          e(2)
     &          *p356(3)-p356(2)*c14f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c14f(i).e(3)*p2k0+p2(3)*c14f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c14f(i).e(0)*p356(0)-c14f(i).e(1)*p356(1)-c14f(i).e(2
     &          )*p356(2)-c14f(i).e(3)*p356(3)
              cvqd=c14f(i).e(0)*p2(0)-c14f(i).e(1)*p2(1)-c14f(i).e(2)*p2
     &          (2)-c14f(i).e(3)*p2(3)
              cauxa=-c14f(i).ek0*quqd+p356k0*cvqd+p2k0*cvqu
              cauxb=-c14f(i).ek0*p2(2)+p2k0*c14f(i).e(2)
              r2_14fz(i).a(1)=fer*(cauxa+ceps_0)
              r2_14fz(i).a(2)=fel*(cauxa-ceps_0)
              r2_14fz(i).b(1)=fel*(cauxb-ceps_2)
              r2_14fz(i).b(2)=fer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c14z(2) a 2
            DO i=1,2
* TR0 -- qu=p356,qd=p2,v=c14z(i).e,a=r2_14fz(i).a,b=r2_14fz(i).b,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c14z(i).ek0*(p356(2)*p2(3)-p2(2)*p356(3))+p356k0*(
     &          c14z(i).e(2)*p2(3)-p2(2)*c14z(i).e(3))-p2k0*(c14z(i).
     &          e(2)
     &          *p356(3)-p356(2)*c14z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c14z(i).e(3)*p2k0+p2(3)*c14z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c14z(i).e(0)*p356(0)-c14z(i).e(1)*p356(1)-c14z(i).e(2
     &          )*p356(2)-c14z(i).e(3)*p356(3)
              cvqd=c14z(i).e(0)*p2(0)-c14z(i).e(1)*p2(1)-c14z(i).e(2)*p2
     &          (2)-c14z(i).e(3)*p2(3)
              cauxa=-c14z(i).ek0*quqd+p356k0*cvqd+p2k0*cvqu
              cauxb=-c14z(i).ek0*p2(2)+p2k0*c14z(i).e(2)
              r2_14fz(i).a(1)=r2_14fz(i).a(1)+zer*(cauxa+ceps_0)
              r2_14fz(i).a(2)=r2_14fz(i).a(2)+zel*(cauxa-ceps_0)
              r2_14fz(i).b(1)=r2_14fz(i).b(1)+zel*(cauxb-ceps_2)
              r2_14fz(i).b(2)=r2_14fz(i).b(2)+zer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c23f(2) a 1
* quqd -- p=p1,q=p123
            quqd=p1(0)*p123(0)-p1(1)*p123(1)-p1(2)*p123(2)-p1(3)*p123(
     &        3)
            DO i=1,2
* TL0 -- qu=p1,qd=p123,v=c23f(i).e,a=l1_23fz(i).a,c=l1_23fz(i).c,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c23f(i).ek0*(p1(2)*p123(3)-p123(2)*p1(3))+p1k0*(c2
     &          3f(i).e(2)*p123(3)-p123(2)*c23f(i).e(3))
     &          -p123k0*(c23f(i).
     &          e(2)*p1(3)-p1(2)*c23f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23f(i).e(3)*p1k0+p1(3)*c23f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c23f(i).e(0)*p1(0)-c23f(i).e(1)*p1(1)-c23f(i).e(2)*p1
     &          (2)-c23f(i).e(3)*p1(3)
              cvqd=c23f(i).e(0)*p123(0)-c23f(i).e(1)*p123(1)-c23f(i).e(2
     &          )*p123(2)-c23f(i).e(3)*p123(3)
              cauxa=-c23f(i).ek0*quqd+p1k0*cvqd+p123k0*cvqu
              cauxc=+c23f(i).ek0*p1(2)-p1k0*c23f(i).e(2)
              l1_23fz(i).a(1)=fer*(cauxa+ceps_0)
              l1_23fz(i).a(2)=fel*(cauxa-ceps_0)
              l1_23fz(i).c(1)=fer*(cauxc+ceps_1)
              l1_23fz(i).c(2)=fel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c23z(2) a 1
            DO i=1,2
* TL0 -- qu=p1,qd=p123,v=c23z(i).e,a=l1_23fz(i).a,c=l1_23fz(i).c,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c23z(i).ek0*(p1(2)*p123(3)-p123(2)*p1(3))+p1k0*(c2
     &          3z(i).e(2)*p123(3)-p123(2)*c23z(i).e(3))
     &          -p123k0*(c23z(i).
     &          e(2)*p1(3)-p1(2)*c23z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23z(i).e(3)*p1k0+p1(3)*c23z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c23z(i).e(0)*p1(0)-c23z(i).e(1)*p1(1)-c23z(i).e(2)*p1
     &          (2)-c23z(i).e(3)*p1(3)
              cvqd=c23z(i).e(0)*p123(0)-c23z(i).e(1)*p123(1)-c23z(i).e(2
     &          )*p123(2)-c23z(i).e(3)*p123(3)
              cauxa=-c23z(i).ek0*quqd+p1k0*cvqd+p123k0*cvqu
              cauxc=+c23z(i).ek0*p1(2)-p1k0*c23z(i).e(2)
              l1_23fz(i).a(1)=l1_23fz(i).a(1)+zer*(cauxa+ceps_0)
              l1_23fz(i).a(2)=l1_23fz(i).a(2)+zel*(cauxa-ceps_0)
              l1_23fz(i).c(1)=l1_23fz(i).c(1)+zer*(cauxc+ceps_1)
              l1_23fz(i).c(2)=l1_23fz(i).c(2)+zel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c14f(2) a 3
* quqd -- p=p3,q=p134
            quqd=p3(0)*p134(0)-p3(1)*p134(1)-p3(2)*p134(2)-p3(3)*p134(
     &        3)
            DO i=1,2
* TL0 -- qu=p3,qd=p134,v=c14f(i).e,a=l3_14fz(i).a,c=l3_14fz(i).c,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c14f(i).ek0*(p3(2)*p134(3)-p134(2)*p3(3))+p3k0*(c1
     &          4f(i).e(2)*p134(3)-p134(2)*c14f(i).e(3))
     &          -p134k0*(c14f(i).
     &          e(2)*p3(3)-p3(2)*c14f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c14f(i).e(3)*p3k0+p3(3)*c14f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c14f(i).e(0)*p3(0)-c14f(i).e(1)*p3(1)-c14f(i).e(2)*p3
     &          (2)-c14f(i).e(3)*p3(3)
              cvqd=c14f(i).e(0)*p134(0)-c14f(i).e(1)*p134(1)-c14f(i).e(2
     &          )*p134(2)-c14f(i).e(3)*p134(3)
              cauxa=-c14f(i).ek0*quqd+p3k0*cvqd+p134k0*cvqu
              cauxc=+c14f(i).ek0*p3(2)-p3k0*c14f(i).e(2)
              l3_14fz(i).a(1)=fer*(cauxa+ceps_0)
              l3_14fz(i).a(2)=fel*(cauxa-ceps_0)
              l3_14fz(i).c(1)=fer*(cauxc+ceps_1)
              l3_14fz(i).c(2)=fel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c14z(2) a 3
            DO i=1,2
* TL0 -- qu=p3,qd=p134,v=c14z(i).e,a=l3_14fz(i).a,c=l3_14fz(i).c,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c14z(i).ek0*(p3(2)*p134(3)-p134(2)*p3(3))+p3k0*(c1
     &          4z(i).e(2)*p134(3)-p134(2)*c14z(i).e(3))
     &          -p134k0*(c14z(i).
     &          e(2)*p3(3)-p3(2)*c14z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c14z(i).e(3)*p3k0+p3(3)*c14z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c14z(i).e(0)*p3(0)-c14z(i).e(1)*p3(1)-c14z(i).e(2)*p3
     &          (2)-c14z(i).e(3)*p3(3)
              cvqd=c14z(i).e(0)*p134(0)-c14z(i).e(1)*p134(1)-c14z(i).e(2
     &          )*p134(2)-c14z(i).e(3)*p134(3)
              cauxa=-c14z(i).ek0*quqd+p3k0*cvqd+p134k0*cvqu
              cauxc=+c14z(i).ek0*p3(2)-p3k0*c14z(i).e(2)
              l3_14fz(i).a(1)=l3_14fz(i).a(1)+zer*(cauxa+ceps_0)
              l3_14fz(i).a(2)=l3_14fz(i).a(2)+zel*(cauxa-ceps_0)
              l3_14fz(i).c(1)=l3_14fz(i).c(1)+zer*(cauxc+ceps_1)
              l3_14fz(i).c(2)=l3_14fz(i).c(2)+zel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c14f(2) a 5
* quqd -- p=p5,q=p145
            quqd=p5(0)*p145(0)-p5(1)*p145(1)-p5(2)*p145(2)-p5(3)*p145(
     &        3)
            DO i=1,2
* TL0 -- qu=p5,qd=p145,v=c14f(i).e,a=l5_14fz(i).a,c=l5_14fz(i).c,cr=f5r,cl=
* f5l,nsum=0
              ceps_0=-c14f(i).ek0*(p5(2)*p145(3)-p145(2)*p5(3))+p5k0*(c1
     &          4f(i).e(2)*p145(3)-p145(2)*c14f(i).e(3))
     &          -p145k0*(c14f(i).
     &          e(2)*p5(3)-p5(2)*c14f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c14f(i).e(3)*p5k0+p5(3)*c14f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c14f(i).e(0)*p5(0)-c14f(i).e(1)*p5(1)-c14f(i).e(2)*p5
     &          (2)-c14f(i).e(3)*p5(3)
              cvqd=c14f(i).e(0)*p145(0)-c14f(i).e(1)*p145(1)-c14f(i).e(2
     &          )*p145(2)-c14f(i).e(3)*p145(3)
              cauxa=-c14f(i).ek0*quqd+p5k0*cvqd+p145k0*cvqu
              cauxc=+c14f(i).ek0*p5(2)-p5k0*c14f(i).e(2)
              l5_14fz(i).a(1)=f5r*(cauxa+ceps_0)
              l5_14fz(i).a(2)=f5l*(cauxa-ceps_0)
              l5_14fz(i).c(1)=f5r*(cauxc+ceps_1)
              l5_14fz(i).c(2)=f5l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c14z(2) a 5
            DO i=1,2
* TL0 -- qu=p5,qd=p145,v=c14z(i).e,a=l5_14fz(i).a,c=l5_14fz(i).c,cr=z5r,cl=
* z5l,nsum=1
              ceps_0=-c14z(i).ek0*(p5(2)*p145(3)-p145(2)*p5(3))+p5k0*(c1
     &          4z(i).e(2)*p145(3)-p145(2)*c14z(i).e(3))
     &          -p145k0*(c14z(i).
     &          e(2)*p5(3)-p5(2)*c14z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c14z(i).e(3)*p5k0+p5(3)*c14z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c14z(i).e(0)*p5(0)-c14z(i).e(1)*p5(1)-c14z(i).e(2)*p5
     &          (2)-c14z(i).e(3)*p5(3)
              cvqd=c14z(i).e(0)*p145(0)-c14z(i).e(1)*p145(1)-c14z(i).e(2
     &          )*p145(2)-c14z(i).e(3)*p145(3)
              cauxa=-c14z(i).ek0*quqd+p5k0*cvqd+p145k0*cvqu
              cauxc=+c14z(i).ek0*p5(2)-p5k0*c14z(i).e(2)
              l5_14fz(i).a(1)=l5_14fz(i).a(1)+z5r*(cauxa+ceps_0)
              l5_14fz(i).a(2)=l5_14fz(i).a(2)+z5l*(cauxa-ceps_0)
              l5_14fz(i).c(1)=l5_14fz(i).c(1)+z5r*(cauxc+ceps_1)
              l5_14fz(i).c(2)=l5_14fz(i).c(2)+z5l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c23f(2) a 5
* quqd -- p=p5,q=p235
            quqd=p5(0)*p235(0)-p5(1)*p235(1)-p5(2)*p235(2)-p5(3)*p235(
     &        3)
            DO i=1,2
* TL0 -- qu=p5,qd=p235,v=c23f(i).e,a=l5_23fz(i).a,c=l5_23fz(i).c,cr=f5r,cl=
* f5l,nsum=0
              ceps_0=-c23f(i).ek0*(p5(2)*p235(3)-p235(2)*p5(3))+p5k0*(c2
     &          3f(i).e(2)*p235(3)-p235(2)*c23f(i).e(3))
     &          -p235k0*(c23f(i).
     &          e(2)*p5(3)-p5(2)*c23f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23f(i).e(3)*p5k0+p5(3)*c23f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c23f(i).e(0)*p5(0)-c23f(i).e(1)*p5(1)-c23f(i).e(2)*p5
     &          (2)-c23f(i).e(3)*p5(3)
              cvqd=c23f(i).e(0)*p235(0)-c23f(i).e(1)*p235(1)-c23f(i).e(2
     &          )*p235(2)-c23f(i).e(3)*p235(3)
              cauxa=-c23f(i).ek0*quqd+p5k0*cvqd+p235k0*cvqu
              cauxc=+c23f(i).ek0*p5(2)-p5k0*c23f(i).e(2)
              l5_23fz(i).a(1)=f5r*(cauxa+ceps_0)
              l5_23fz(i).a(2)=f5l*(cauxa-ceps_0)
              l5_23fz(i).c(1)=f5r*(cauxc+ceps_1)
              l5_23fz(i).c(2)=f5l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c23z(2) a 5
            DO i=1,2
* TL0 -- qu=p5,qd=p235,v=c23z(i).e,a=l5_23fz(i).a,c=l5_23fz(i).c,cr=z5r,cl=
* z5l,nsum=1
              ceps_0=-c23z(i).ek0*(p5(2)*p235(3)-p235(2)*p5(3))+p5k0*(c2
     &          3z(i).e(2)*p235(3)-p235(2)*c23z(i).e(3))
     &          -p235k0*(c23z(i).
     &          e(2)*p5(3)-p5(2)*c23z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23z(i).e(3)*p5k0+p5(3)*c23z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c23z(i).e(0)*p5(0)-c23z(i).e(1)*p5(1)-c23z(i).e(2)*p5
     &          (2)-c23z(i).e(3)*p5(3)
              cvqd=c23z(i).e(0)*p235(0)-c23z(i).e(1)*p235(1)-c23z(i).e(2
     &          )*p235(2)-c23z(i).e(3)*p235(3)
              cauxa=-c23z(i).ek0*quqd+p5k0*cvqd+p235k0*cvqu
              cauxc=+c23z(i).ek0*p5(2)-p5k0*c23z(i).e(2)
              l5_23fz(i).a(1)=l5_23fz(i).a(1)+z5r*(cauxa+ceps_0)
              l5_23fz(i).a(2)=l5_23fz(i).a(2)+z5l*(cauxa-ceps_0)
              l5_23fz(i).c(1)=l5_23fz(i).c(1)+z5r*(cauxc+ceps_1)
              l5_23fz(i).c(2)=l5_23fz(i).c(2)+z5l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c23f(2) a 6
* quqd -- p=p145,q=p6
            quqd=p145(0)*p6(0)-p145(1)*p6(1)-p145(2)*p6(2)-p145(3)*p6(
     &        3)
            DO i=1,2
* TR0 -- qu=p145,qd=p6,v=c23f(i).e,a=r6_23fz(i).a,b=r6_23fz(i).b,cr=f5r,cl=
* f5l,nsum=0
              ceps_0=-c23f(i).ek0*(p145(2)*p6(3)-p6(2)*p145(3))+p145k0*(
     &          c23f(i).e(2)*p6(3)-p6(2)*c23f(i).e(3))-p6k0*(c23f(i).
     &          e(2)
     &          *p145(3)-p145(2)*c23f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23f(i).e(3)*p6k0+p6(3)*c23f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c23f(i).e(0)*p145(0)-c23f(i).e(1)*p145(1)-c23f(i).e(2
     &          )*p145(2)-c23f(i).e(3)*p145(3)
              cvqd=c23f(i).e(0)*p6(0)-c23f(i).e(1)*p6(1)-c23f(i).e(2)*p6
     &          (2)-c23f(i).e(3)*p6(3)
              cauxa=-c23f(i).ek0*quqd+p145k0*cvqd+p6k0*cvqu
              cauxb=-c23f(i).ek0*p6(2)+p6k0*c23f(i).e(2)
              r6_23fz(i).a(1)=f5r*(cauxa+ceps_0)
              r6_23fz(i).a(2)=f5l*(cauxa-ceps_0)
              r6_23fz(i).b(1)=f5l*(cauxb-ceps_2)
              r6_23fz(i).b(2)=f5r*(-cauxb-ceps_2)
            END DO
**** attaccamento di c23z(2) a 6
            DO i=1,2
* TR0 -- qu=p145,qd=p6,v=c23z(i).e,a=r6_23fz(i).a,b=r6_23fz(i).b,cr=z5r,cl=
* z5l,nsum=1
              ceps_0=-c23z(i).ek0*(p145(2)*p6(3)-p6(2)*p145(3))+p145k0*(
     &          c23z(i).e(2)*p6(3)-p6(2)*c23z(i).e(3))-p6k0*(c23z(i).
     &          e(2)
     &          *p145(3)-p145(2)*c23z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23z(i).e(3)*p6k0+p6(3)*c23z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c23z(i).e(0)*p145(0)-c23z(i).e(1)*p145(1)-c23z(i).e(2
     &          )*p145(2)-c23z(i).e(3)*p145(3)
              cvqd=c23z(i).e(0)*p6(0)-c23z(i).e(1)*p6(1)-c23z(i).e(2)*p6
     &          (2)-c23z(i).e(3)*p6(3)
              cauxa=-c23z(i).ek0*quqd+p145k0*cvqd+p6k0*cvqu
              cauxb=-c23z(i).ek0*p6(2)+p6k0*c23z(i).e(2)
              r6_23fz(i).a(1)=r6_23fz(i).a(1)+z5r*(cauxa+ceps_0)
              r6_23fz(i).a(2)=r6_23fz(i).a(2)+z5l*(cauxa-ceps_0)
              r6_23fz(i).b(1)=r6_23fz(i).b(1)+z5l*(cauxb-ceps_2)
              r6_23fz(i).b(2)=r6_23fz(i).b(2)+z5r*(-cauxb-ceps_2)
            END DO
**** attaccamento di c14f(2) a 6
* quqd -- p=p235,q=p6
            quqd=p235(0)*p6(0)-p235(1)*p6(1)-p235(2)*p6(2)-p235(3)*p6(
     &        3)
            DO i=1,2
* TR0 -- qu=p235,qd=p6,v=c14f(i).e,a=r6_14fz(i).a,b=r6_14fz(i).b,cr=f5r,cl=
* f5l,nsum=0
              ceps_0=-c14f(i).ek0*(p235(2)*p6(3)-p6(2)*p235(3))+p235k0*(
     &          c14f(i).e(2)*p6(3)-p6(2)*c14f(i).e(3))-p6k0*(c14f(i).
     &          e(2)
     &          *p235(3)-p235(2)*c14f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c14f(i).e(3)*p6k0+p6(3)*c14f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c14f(i).e(0)*p235(0)-c14f(i).e(1)*p235(1)-c14f(i).e(2
     &          )*p235(2)-c14f(i).e(3)*p235(3)
              cvqd=c14f(i).e(0)*p6(0)-c14f(i).e(1)*p6(1)-c14f(i).e(2)*p6
     &          (2)-c14f(i).e(3)*p6(3)
              cauxa=-c14f(i).ek0*quqd+p235k0*cvqd+p6k0*cvqu
              cauxb=-c14f(i).ek0*p6(2)+p6k0*c14f(i).e(2)
              r6_14fz(i).a(1)=f5r*(cauxa+ceps_0)
              r6_14fz(i).a(2)=f5l*(cauxa-ceps_0)
              r6_14fz(i).b(1)=f5l*(cauxb-ceps_2)
              r6_14fz(i).b(2)=f5r*(-cauxb-ceps_2)
            END DO
**** attaccamento di c14z(2) a 6
            DO i=1,2
* TR0 -- qu=p235,qd=p6,v=c14z(i).e,a=r6_14fz(i).a,b=r6_14fz(i).b,cr=z5r,cl=
* z5l,nsum=1
              ceps_0=-c14z(i).ek0*(p235(2)*p6(3)-p6(2)*p235(3))+p235k0*(
     &          c14z(i).e(2)*p6(3)-p6(2)*c14z(i).e(3))-p6k0*(c14z(i).
     &          e(2)
     &          *p235(3)-p235(2)*c14z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c14z(i).e(3)*p6k0+p6(3)*c14z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c14z(i).e(0)*p235(0)-c14z(i).e(1)*p235(1)-c14z(i).e(2
     &          )*p235(2)-c14z(i).e(3)*p235(3)
              cvqd=c14z(i).e(0)*p6(0)-c14z(i).e(1)*p6(1)-c14z(i).e(2)*p6
     &          (2)-c14z(i).e(3)*p6(3)
              cauxa=-c14z(i).ek0*quqd+p235k0*cvqd+p6k0*cvqu
              cauxb=-c14z(i).ek0*p6(2)+p6k0*c14z(i).e(2)
              r6_14fz(i).a(1)=r6_14fz(i).a(1)+z5r*(cauxa+ceps_0)
              r6_14fz(i).a(2)=r6_14fz(i).a(2)+z5l*(cauxa-ceps_0)
              r6_14fz(i).b(1)=r6_14fz(i).b(1)+z5l*(cauxb-ceps_2)
              r6_14fz(i).b(2)=r6_14fz(i).b(2)+z5r*(-cauxb-ceps_2)
            END DO
**** Diagramma CN11 ****
            DO i2=1,2
              DO i5=1,2
* TLTR0 -- aa=cn11(&,i2,i5).id(ide),a1=l1_56fz(i5).a,c1=l1_56fz(i5).c,a2=r4
* _23fz(i2).a,b2=r4_23fz(i2).b,prq=p156q,den=(p156q*p156k0),nsum=0
                cn11(1,i2,i5).id(ide)=( l1_56fz(i5).a(1)*r4_23fz(i2).
     &            a(1)+
     &            l1_56fz(i5).c(1)*p156q*r4_23fz(i2).b(2) )
     &            /(p156q*p156k0)
                cn11(2,i2,i5).id(ide)=( l1_56fz(i5).c(2)
     &            *p156q*r4_23fz(i2)
     &            .b(1)+l1_56fz(i5).a(2)*r4_23fz(i2).a(2) )
     &            /(p156q*p156k0)
              END DO
            END DO
**** Diagramma CN12 ****
            DO i2=1,2
              DO i5=1,2
* TLTR0 -- aa=cn12(&,i2,i5).id(ide),a1=l1_23fz(i2).a,c1=l1_23fz(i2).c,a2=r4
* _56fz(i5).a,b2=r4_56fz(i5).b,prq=p123q,den=(p123q*p123k0),nsum=0
                cn12(1,i2,i5).id(ide)=( l1_23fz(i2).a(1)*r4_56fz(i5).
     &            a(1)+
     &            l1_23fz(i2).c(1)*p123q*r4_56fz(i5).b(2) )
     &            /(p123q*p123k0)
                cn12(2,i2,i5).id(ide)=( l1_23fz(i2).c(2)
     &            *p123q*r4_56fz(i5)
     &            .b(1)+l1_23fz(i2).a(2)*r4_56fz(i5).a(2) )
     &            /(p123q*p123k0)
              END DO
            END DO
**** Diagramma CN13 ****
            DO i1=1,2
              DO i5=1,2
* TLTR0 -- aa=cn13(i1,&,i5).id(ide),a1=l3_14fz(i1).a,c1=l3_14fz(i1).c,a2=r2
* _56fz(i5).a,b2=r2_56fz(i5).b,prq=p134q,den=(p134q*p134k0),nsum=0
                cn13(i1,1,i5).id(ide)=( l3_14fz(i1).a(1)*r2_56fz(i5).
     &            a(1)+
     &            l3_14fz(i1).c(1)*p134q*r2_56fz(i5).b(2) )
     &            /(p134q*p134k0)
                cn13(i1,2,i5).id(ide)=( l3_14fz(i1).c(2)
     &            *p134q*r2_56fz(i5)
     &            .b(1)+l3_14fz(i1).a(2)*r2_56fz(i5).a(2) )
     &            /(p134q*p134k0)
              END DO
            END DO
**** Diagramma CN14 ****
            DO i1=1,2
              DO i5=1,2
* TLTR0 -- aa=cn14(i1,&,i5).id(ide),a1=l3_56fz(i5).a,c1=l3_56fz(i5).c,a2=r2
* _14fz(i1).a,b2=r2_14fz(i1).b,prq=p356q,den=(p356q*p356k0),nsum=0
                cn14(i1,1,i5).id(ide)=( l3_56fz(i5).a(1)*r2_14fz(i1).
     &            a(1)+
     &            l3_56fz(i5).c(1)*p356q*r2_14fz(i1).b(2) )
     &            /(p356q*p356k0)
                cn14(i1,2,i5).id(ide)=( l3_56fz(i5).c(2)
     &            *p356q*r2_14fz(i1)
     &            .b(1)+l3_56fz(i5).a(2)*r2_14fz(i1).a(2) )
     &            /(p356q*p356k0)
              END DO
            END DO
**** Diagramma CN15 ****
            DO i1=1,2
              DO i2=1,2
* TLTR0 -- aa=cn15(i1,i2,&).id(ide),a1=l5_14fz(i1).a,c1=l5_14fz(i1).c,a2=r6
* _23fz(i2).a,b2=r6_23fz(i2).b,prq=p145q,den=(p145q*p145k0),nsum=0
                cn15(i1,i2,1).id(ide)=( l5_14fz(i1).a(1)*r6_23fz(i2).
     &            a(1)+
     &            l5_14fz(i1).c(1)*p145q*r6_23fz(i2).b(2) )
     &            /(p145q*p145k0)
                cn15(i1,i2,2).id(ide)=( l5_14fz(i1).c(2)
     &            *p145q*r6_23fz(i2)
     &            .b(1)+l5_14fz(i1).a(2)*r6_23fz(i2).a(2) )
     &            /(p145q*p145k0)
              END DO
            END DO
**** Diagramma CN16 ****
            DO i1=1,2
              DO i2=1,2
* TLTR0 -- aa=cn16(i1,i2,&).id(ide),a1=l5_23fz(i2).a,c1=l5_23fz(i2).c,a2=r6
* _14fz(i1).a,b2=r6_14fz(i1).b,prq=p235q,den=(p235q*p235k0),nsum=
                cn16(i1,i2,1).id(ide)=( l5_23fz(i2).a(1)*r6_14fz(i1).
     &            a(1)+
     &            l5_23fz(i2).c(1)*p235q*r6_14fz(i1).b(2) )
     &            /(p235q*p235k0)
                cn16(i1,i2,2).id(ide)=( l5_23fz(i2).c(2)
     &            *p235q*r6_14fz(i1)
     &            .b(1)+l5_23fz(i2).a(2)*r6_14fz(i1).a(2) )
     &            /(p235q*p235k0)
              END DO
            END DO
          ENDIF !i34e
          IF (i56ve.EQ.1) THEN
****          diagrammi per correnti neutre con scambi di w (6)
* quqd -- p=p1,q=p6
            quqd=p1(0)*p6(0)-p1(1)*p6(1)-p1(2)*p6(2)-p1(3)*p6(3)
            ccl=wcl/(2.d0*quqd+rmw2)
* TW10 -- qu=p1,qd=p6,v=0,a=c16w.e(0),cl=ccl,nsum=0
            eps_0=-p1(2)*p6(3)+p6(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p6(0)+p6k0*p1(0)
            c16w.e(0)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p6,v=1,a=c16w.e(1),cl=ccl,nsum=0
            auxa=-quqd+p1k0*p6(1)+p6k0*p1(1)
            c16w.e(1)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p6,v=2,a=c16w.e(2),cl=ccl,nsum=0
            eps_0=-p1k0*p6(3)+p6k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(2)+p6k0*p1(2)
            c16w.e(2)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p6,v=3,a=c16w.e(3),cl=ccl,nsum=0
            eps_0=p1k0*p6(2)-p6k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(3)+p6k0*p1(3)
            c16w.e(3)=ccl*(auxa-ceps_0)
* pk0 -- p=c16w.e
            c16w.ek0=c16w.e(0)-c16w.e(1)
* quqd -- p=p5,q=p2
            quqd=p5(0)*p2(0)-p5(1)*p2(1)-p5(2)*p2(2)-p5(3)*p2(3)
            ccl=wcl/(2.d0*quqd+rmw2)
* TW10 -- qu=p5,qd=p2,v=0,a=c25w.e(0),cl=ccl,nsum=0
            eps_0=-p5(2)*p2(3)+p2(2)*p5(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p5k0*p2(0)+p2k0*p5(0)
            c25w.e(0)=ccl*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p2,v=1,a=c25w.e(1),cl=ccl,nsum=0
            auxa=-quqd+p5k0*p2(1)+p2k0*p5(1)
            c25w.e(1)=ccl*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p2,v=2,a=c25w.e(2),cl=ccl,nsum=0
            eps_0=-p5k0*p2(3)+p2k0*p5(3)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(2)+p2k0*p5(2)
            c25w.e(2)=ccl*(auxa-ceps_0)
* TW10 -- qu=p5,qd=p2,v=3,a=c25w.e(3),cl=ccl,nsum=0
            eps_0=p5k0*p2(2)-p2k0*p5(2)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(3)+p2k0*p5(3)
            c25w.e(3)=ccl*(auxa-ceps_0)
* pk0 -- p=c25w.e
            c25w.ek0=c25w.e(0)-c25w.e(1)
            IF (ianc.EQ.0) THEN
              DO i=1,2
                DO mu=0,3
                  c34fz(i).e(mu)=c34f(i).e(mu)+rcotw*c34z(i).e(mu)
                END DO
              END DO
            ELSE
              DO i=1,2
                DO mu=0,3
                  c34fz(i).e(mu)=c34f(i).e(mu)+(rcotw+delz)*c34z(i).
     &              e(mu)
                END DO
              END DO
            ENDIF
*
* diagramma triplo cn23
*
*** triple vertex -- pfz(mu)=p34(mu),pwm(mu)=p16(mu),pwp(mu)=p25(mu),efz=c3
* 4fz(i),ewm=c16w,ewp=c25w,res=cn23(i?).id(ide)
            DO mu=0,3
              vfz(mu)=p16(mu)-p25(mu)
              vwm(mu)=p25(mu)-p34(mu)
              vwp(mu)=p34(mu)-p16(mu)
            END DO !mu
* vfz.efz
            DO i=1,2
* p.q -- p.q=c34fz(i).v,p=c34fz(i).e,q=vfz
              c34fz(i).v=c34fz(i).e(0)*vfz(0)-c34fz(i).e(1)*vfz(1)-c34fz
     &          (i).e(2)*vfz(2)-c34fz(i).e(3)*vfz(3)
            END DO
* vwm.ewm
* p.q -- p.q=c16w.v,p=c16w.e,q=vwm
            c16w.v=c16w.e(0)*vwm(0)-c16w.e(1)*vwm(1)-c16w.e(2)*vwm(2)-
     &        c16w.e(3)*vwm(3)
* vwp.ewp
* p.q -- p.q=c25w.v,p=c25w.e,q=vwp
            c25w.v=c25w.e(0)*vwp(0)-c25w.e(1)*vwp(1)-c25w.e(2)*vwp(2)-
     &        c25w.e(3)*vwp(3)
* efz.ewm
            DO i=1,2
* p.q -- p.q=caux,p=c34fz(i).e,q=c16w.e
              caux=c34fz(i).e(0)*c16w.e(0)-c34fz(i).e(1)*c16w.e(1)-c34fz
     &          (i).e(2)*c16w.e(2)-c34fz(i).e(3)*c16w.e(3)
              cn23(i).id(ide)=c25w.v*caux
            END DO
* efz.ewp
            DO i=1,2
* p.q -- p.q=caux,p=c34fz(i).e,q=c25w.e
              caux=c34fz(i).e(0)*c25w.e(0)-c34fz(i).e(1)*c25w.e(1)-c34fz
     &          (i).e(2)*c25w.e(2)-c34fz(i).e(3)*c25w.e(3)
              cn23(i).id(ide)=cn23(i).id(ide)+c16w.v*caux
            END DO
* ewm.ewp
* p.q -- p.q=caux,p=c16w.e,q=c25w.e
            caux=c16w.e(0)*c25w.e(0)-c16w.e(1)*c25w.e(1)-c16w.e(2)*c25
     &        w.e(2)-c16w.e(3)*c25w.e(3)
            DO i=1,2
              cn23(i).id(ide)=cn23(i).id(ide)+c34fz(i).v*caux
            END DO
* anomalous couplings
            IF (ianc.NE.0) THEN
* p.q -- p.q=cemp0,p=c16w.e,q=p34
              cemp0=c16w.e(0)*p34(0)-c16w.e(1)*p34(1)-c16w.e(2)*p34(2)-c
     &          16w.e(3)*p34(3)
* p.q -- p.q=cepp0,p=c25w.e,q=p34
              cepp0=c25w.e(0)*p34(0)-c25w.e(1)*p34(1)-c25w.e(2)*p34(2)-c
     &          25w.e(3)*p34(3)

              IF (xf.NE.0.d0.OR.xz.NE.0.d0) THEN
                DO i=1,2
                  DO mu=0,3
                    c34fz(i).e(mu)=xf*c34f(i).e(mu)+xz*c34z(i).e(mu)
                  END DO
                END DO
                DO i=1,2
* p.q -- p.q=ce0em(i),p=c34fz(i).e,q=c16w.e
                  ce0em(i)=c34fz(i).e(0)*c16w.e(0)-c34fz(i).e(1)*c16w.
     &              e(1)-c
     &              34fz(i).e(2)*c16w.e(2)-c34fz(i).e(3)*c16w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0ep(i),p=c34fz(i).e,q=c25w.e
                  ce0ep(i)=c34fz(i).e(0)*c25w.e(0)-c34fz(i).e(1)*c25w.
     &              e(1)-c
     &              34fz(i).e(2)*c25w.e(2)-c34fz(i).e(3)*c25w.e(3)
                END DO
                DO i=1,2
                  cn23(i).id(ide)=cn23(i).id(ide)+ce0em(i)*cepp0-
     &              ce0ep(i)*cemp0
                END DO
              ENDIF

              IF (yf.NE.0.d0.OR.yz.NE.0.d0) THEN
                DO i=1,2
                  DO mu=0,3
                    c34fz(i).e(mu)=yf*c34f(i).e(mu)+yz*c34z(i).e(mu)
                  END DO
                END DO
                DO i=1,2
* p.q -- p.q=ce0em(i),p=c34fz(i).e,q=c16w.e
                  ce0em(i)=c34fz(i).e(0)*c16w.e(0)-c34fz(i).e(1)*c16w.
     &              e(1)-c
     &              34fz(i).e(2)*c16w.e(2)-c34fz(i).e(3)*c16w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0ep(i),p=c34fz(i).e,q=c25w.e
                  ce0ep(i)=c34fz(i).e(0)*c25w.e(0)-c34fz(i).e(1)*c25w.
     &              e(1)-c
     &              34fz(i).e(2)*c25w.e(2)-c34fz(i).e(3)*c25w.e(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0pm(i),p=c34fz(i).e,q=p16
                  ce0pm(i)=c34fz(i).e(0)*p16(0)-c34fz(i).e(1)*p16(1)
     &              -c34fz(i
     &              ).e(2)*p16(2)-c34fz(i).e(3)*p16(3)
                END DO
                DO i=1,2
* p.q -- p.q=ce0pp(i),p=c34fz(i).e,q=p25
                  ce0pp(i)=c34fz(i).e(0)*p25(0)-c34fz(i).e(1)*p25(1)
     &              -c34fz(i
     &              ).e(2)*p25(2)-c34fz(i).e(3)*p25(3)
                END DO
* p.q -- p.q=cemep,p=c16w.e,q=c25w.e
                cemep=c16w.e(0)*c25w.e(0)-c16w.e(1)*c25w.e(1)-c16w.e(2)
     &            *c2
     &            5w.e(2)-c16w.e(3)*c25w.e(3)
* p.q -- p.q=cempp,p=c16w.e,q=p25
                cempp=c16w.e(0)*p25(0)-c16w.e(1)*p25(1)-c16w.e(2)*p25(2)
     &            -c
     &            16w.e(3)*p25(3)
* p.q -- p.q=ceppm,p=c25w.e,q=p16
                ceppm=c25w.e(0)*p16(0)-c25w.e(1)*p16(1)-c25w.e(2)*p16(2)
     &            -c
     &            25w.e(3)*p16(3)
* p.q -- p.q=p0pm,p=p34,q=p16
                p0pm=p34(0)*p16(0)-p34(1)*p16(1)-p34(2)*p16(2)-p34(3)
     &            *p16(
     &            3)
* p.q -- p.q=p0pp,p=p34,q=p25
                p0pp=p34(0)*p25(0)-p34(1)*p25(1)-p34(2)*p25(2)-p34(3)
     &            *p25(
     &            3)
* p.q -- p.q=pmpp,p=p16,q=p25
                pmpp=p16(0)*p25(0)-p16(1)*p25(1)-p16(2)*p25(2)-p16(3)
     &            *p25(
     &            3)
                DO i=1,2
                  cn23(i).id(ide)=cn23(i).id(ide)+ce0pm(i)*cepp0*cempp-
     &              ce0pp(i)*ceppm*cemp0+
     &              p0pp*(ce0em(i)*ceppm-cemep*ce0pm(i))+
     &              p0pm*(cemep*ce0pp(i)-ce0ep(i)*cempp)+
     &              pmpp*(ce0ep(i)*cemp0-ce0em(i)*cepp0)
                END DO

              ENDIF
              IF (zz.NE.0.d0) THEN
                DO m=0,3
                  cpau(m)=cepp0*c16w.e(m)-cemp0*c25w.e(m)
                  pau(m)=p25(m)-p16(m)
                ENDDO
                DO i=1,2
* eps -- eps=cau(i),p=c34z(i).e,q=cpau,r=p34,s=pau
                  cau(i)=c34z(i).e(0)*(cpau(1)*(p34(2)*pau(3)-p34(3)
     &              *pau(2))
     &              +cpau(2)*(p34(3)*pau(1)-p34(1)*pau(3))+cpau(3)
     &              *(p34(1)*pa
     &              u(2)-p34(2)*pau(1)))
                  cau(i)=cau(i)-c34z(i).e(1)*(cpau(2)*(p34(3)*pau(0)
     &              -p34(0)*
     &              pau(3))+cpau(3)*(p34(0)*pau(2)-p34(2)*pau(0))
     &              +cpau(0)*(p3
     &              4(2)*pau(3)-p34(3)*pau(2)))
                  cau(i)=cau(i)+c34z(i).e(2)*(cpau(3)*(p34(0)*pau(1)
     &              -p34(1)*
     &              pau(0))+cpau(0)*(p34(1)*pau(3)-p34(3)*pau(1))
     &              +cpau(1)*(p3
     &              4(3)*pau(0)-p34(0)*pau(3)))
                  cau(i)=cau(i)-c34z(i).e(3)*(cpau(0)*(p34(1)*pau(2)
     &              -p34(2)*
     &              pau(1))+cpau(1)*(p34(2)*pau(0)-p34(0)*pau(2))
     &              +cpau(2)*(p3
     &              4(0)*pau(1)-p34(1)*pau(0)))
                END DO
                DO i=1,2
                  cn23(i).id(ide)=cn23(i).id(ide)+cim*zz*cau(i)
                ENDDO
              ENDIF
            ENDIF
* end anomalous couplings

* quqd -- p=p134,q=p6
            quqd=p134(0)*p6(0)-p134(1)*p6(1)-p134(2)*p6(2)-p134(3)*p6(
     &        3)
* TWR0 -- qu=p134,qd=p6,v=c25w.e,a=r6_25w.a,b=r6_25w.b,cl=wcl,nsum=0
            ceps_0=-c25w.ek0*(p134(2)*p6(3)-p6(2)*p134(3))+p134k0*(c25
     &        w.e(2)*p6(3)-p6(2)*c25w.e(3))-p6k0*(c25w.e(2)*p134(3)-p13
     &        4(2)*c25w.e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c25w.e(3)*p6k0+p6(3)*c25w.ek0
            ceps_2=ceps_2*cim
            cvqu=c25w.e(0)*p134(0)-c25w.e(1)*p134(1)-c25w.e(2)*p134(2)
     &        -c25w.e(3)*p134(3)
            cvqd=c25w.e(0)*p6(0)-c25w.e(1)*p6(1)-c25w.e(2)*p6(2)-c25w.
     &        e(3)*p6(3)
            cauxa=-c25w.ek0*quqd+p134k0*cvqd+p6k0*cvqu
            cauxb=-c25w.ek0*p6(2)+p6k0*c25w.e(2)
            r6_25w.a(2)=wcl*(cauxa-ceps_0)
            r6_25w.b(1)=wcl*(cauxb-ceps_2)
* quqd -- p=p345,q=p2
            quqd=p345(0)*p2(0)-p345(1)*p2(1)-p345(2)*p2(2)-p345(3)*p2(
     &        3)
* TWR0 -- qu=p345,qd=p2,v=c16w.e,a=r2_16w.a,b=r2_16w.b,cl=wcl,nsum=0
            ceps_0=-c16w.ek0*(p345(2)*p2(3)-p2(2)*p345(3))+p345k0*(c16
     &        w.e(2)*p2(3)-p2(2)*c16w.e(3))-p2k0*(c16w.e(2)*p345(3)-p34
     &        5(2)*c16w.e(3))
            ceps_0=ceps_0*cim
            ceps_2=-c16w.e(3)*p2k0+p2(3)*c16w.ek0
            ceps_2=ceps_2*cim
            cvqu=c16w.e(0)*p345(0)-c16w.e(1)*p345(1)-c16w.e(2)*p345(2)
     &        -c16w.e(3)*p345(3)
            cvqd=c16w.e(0)*p2(0)-c16w.e(1)*p2(1)-c16w.e(2)*p2(2)-c16w.
     &        e(3)*p2(3)
            cauxa=-c16w.ek0*quqd+p345k0*cvqd+p2k0*cvqu
            cauxb=-c16w.ek0*p2(2)+p2k0*c16w.e(2)
            r2_16w.a(2)=wcl*(cauxa-ceps_0)
            r2_16w.b(1)=wcl*(cauxb-ceps_2)
*** per diagramma cn28
            IF (f3l.LT.0.d0) THEN
* quqd -- p=p235,q=p4
              quqd=p235(0)*p4(0)-p235(1)*p4(1)-p235(2)*p4(2)-p235(3)*p4(
     &          3)
* TWR0 -- qu=p235,qd=p4,v=c16w.e,a=r4_16w.a,b=r4_16w.b,cl=wcl,nsum=0
              ceps_0=-c16w.ek0*(p235(2)*p4(3)-p4(2)*p235(3))+p235k0*(c16
     &          w.e(2)*p4(3)-p4(2)*c16w.e(3))-p4k0*(c16w.e(2)*p235(3)
     &          -p23
     &          5(2)*c16w.e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c16w.e(3)*p4k0+p4(3)*c16w.ek0
              ceps_2=ceps_2*cim
              cvqu=c16w.e(0)*p235(0)-c16w.e(1)*p235(1)-c16w.e(2)*p235(2)
     &          -c16w.e(3)*p235(3)
              cvqd=c16w.e(0)*p4(0)-c16w.e(1)*p4(1)-c16w.e(2)*p4(2)-c16w.
     &          e(3)*p4(3)
              cauxa=-c16w.ek0*quqd+p235k0*cvqd+p4k0*cvqu
              cauxb=-c16w.ek0*p4(2)+p4k0*c16w.e(2)
              r4_16w.a(2)=wcl*(cauxa-ceps_0)
              r4_16w.b(1)=wcl*(cauxb-ceps_2)
* quqd -- p=p3,q=p235
              quqd=p3(0)*p235(0)-p3(1)*p235(1)-p3(2)*p235(2)-p3(3)*p235(
     &          3)
* TWL0 -- qu=p3,qd=p235,v=c25w.e,a=l3_25w.a,c=l3_25w.c,cl=wcl,nsum=0
              ceps_0=-c25w.ek0*(p3(2)*p235(3)-p235(2)*p3(3))+p3k0*(c25w.
     &          e(2)*p235(3)-p235(2)*c25w.e(3))-p235k0*(c25w.e(2)*p3(3)
     &          -p
     &          3(2)*c25w.e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c25w.e(3)*p3k0+p3(3)*c25w.ek0
              ceps_1=ceps_1*cim
              cvqu=c25w.e(0)*p3(0)-c25w.e(1)*p3(1)-c25w.e(2)*p3(2)-c25w.
     &          e(3)*p3(3)
              cvqd=c25w.e(0)*p235(0)-c25w.e(1)*p235(1)-c25w.e(2)*p235(2)
     &          -c25w.e(3)*p235(3)
              cauxa=-c25w.ek0*quqd+p3k0*cvqd+p235k0*cvqu
              cauxc=+c25w.ek0*p3(2)-p3k0*c25w.e(2)
              l3_25w.a(2)=wcl*(cauxa-ceps_0)
              l3_25w.c(2)=wcl*(-cauxc+ceps_1)
            ELSE

* quqd -- p=p136,q=p4
              quqd=p136(0)*p4(0)-p136(1)*p4(1)-p136(2)*p4(2)-p136(3)*p4(
     &          3)
* TWR0 -- qu=p136,qd=p4,v=c25w.e,a=r4_25w.a,b=r4_25w.b,cl=wcl,nsum=0
              ceps_0=-c25w.ek0*(p136(2)*p4(3)-p4(2)*p136(3))+p136k0*(c25
     &          w.e(2)*p4(3)-p4(2)*c25w.e(3))-p4k0*(c25w.e(2)*p136(3)
     &          -p13
     &          6(2)*c25w.e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c25w.e(3)*p4k0+p4(3)*c25w.ek0
              ceps_2=ceps_2*cim
              cvqu=c25w.e(0)*p136(0)-c25w.e(1)*p136(1)-c25w.e(2)*p136(2)
     &          -c25w.e(3)*p136(3)
              cvqd=c25w.e(0)*p4(0)-c25w.e(1)*p4(1)-c25w.e(2)*p4(2)-c25w.
     &          e(3)*p4(3)
              cauxa=-c25w.ek0*quqd+p136k0*cvqd+p4k0*cvqu
              cauxb=-c25w.ek0*p4(2)+p4k0*c25w.e(2)
              r4_25w.a(2)=wcl*(cauxa-ceps_0)
              r4_25w.b(1)=wcl*(cauxb-ceps_2)
* quqd -- p=p3,q=p136
              quqd=p3(0)*p136(0)-p3(1)*p136(1)-p3(2)*p136(2)-p3(3)*p136(
     &          3)
* TWL0 -- qu=p3,qd=p136,v=c16w.e,a=l3_16w.a,c=l3_16w.c,cl=wcl,nsum=0
              ceps_0=-c16w.ek0*(p3(2)*p136(3)-p136(2)*p3(3))+p3k0*(c16w.
     &          e(2)*p136(3)-p136(2)*c16w.e(3))-p136k0*(c16w.e(2)*p3(3)
     &          -p
     &          3(2)*c16w.e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c16w.e(3)*p3k0+p3(3)*c16w.ek0
              ceps_1=ceps_1*cim
              cvqu=c16w.e(0)*p3(0)-c16w.e(1)*p3(1)-c16w.e(2)*p3(2)-c16w.
     &          e(3)*p3(3)
              cvqd=c16w.e(0)*p136(0)-c16w.e(1)*p136(1)-c16w.e(2)*p136(2)
     &          -c16w.e(3)*p136(3)
              cauxa=-c16w.ek0*quqd+p3k0*cvqd+p136k0*cvqu
              cauxc=+c16w.ek0*p3(2)-p3k0*c16w.e(2)
              l3_16w.a(2)=wcl*(cauxa-ceps_0)
              l3_16w.c(2)=wcl*(-cauxc+ceps_1)
            ENDIF
****
* quqd -- p=p1,q=p125
            quqd=p1(0)*p125(0)-p1(1)*p125(1)-p1(2)*p125(2)-p1(3)*p125(
     &        3)
* TWL0 -- qu=p1,qd=p125,v=c25w.e,a=l1_25w.a,c=l1_25w.c,cl=wcl,nsum=0
            ceps_0=-c25w.ek0*(p1(2)*p125(3)-p125(2)*p1(3))+p1k0*(c25w.
     &        e(2)*p125(3)-p125(2)*c25w.e(3))-p125k0*(c25w.e(2)*p1(3)-p
     &        1(2)*c25w.e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c25w.e(3)*p1k0+p1(3)*c25w.ek0
            ceps_1=ceps_1*cim
            cvqu=c25w.e(0)*p1(0)-c25w.e(1)*p1(1)-c25w.e(2)*p1(2)-c25w.
     &        e(3)*p1(3)
            cvqd=c25w.e(0)*p125(0)-c25w.e(1)*p125(1)-c25w.e(2)*p125(2)
     &        -c25w.e(3)*p125(3)
            cauxa=-c25w.ek0*quqd+p1k0*cvqd+p125k0*cvqu
            cauxc=+c25w.ek0*p1(2)-p1k0*c25w.e(2)
            l1_25w.a(2)=wcl*(cauxa-ceps_0)
            l1_25w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p5,q=p156
            quqd=p5(0)*p156(0)-p5(1)*p156(1)-p5(2)*p156(2)-p5(3)*p156(
     &        3)
* TWL0 -- qu=p5,qd=p156,v=c16w.e,a=l5_16w.a,c=l5_16w.c,cl=wcl,nsum=0
            ceps_0=-c16w.ek0*(p5(2)*p156(3)-p156(2)*p5(3))+p5k0*(c16w.
     &        e(2)*p156(3)-p156(2)*c16w.e(3))-p156k0*(c16w.e(2)*p5(3)-p
     &        5(2)*c16w.e(3))
            ceps_0=ceps_0*cim
            ceps_1=-c16w.e(3)*p5k0+p5(3)*c16w.ek0
            ceps_1=ceps_1*cim
            cvqu=c16w.e(0)*p5(0)-c16w.e(1)*p5(1)-c16w.e(2)*p5(2)-c16w.
     &        e(3)*p5(3)
            cvqd=c16w.e(0)*p156(0)-c16w.e(1)*p156(1)-c16w.e(2)*p156(2)
     &        -c16w.e(3)*p156(3)
            cauxa=-c16w.ek0*quqd+p5k0*cvqd+p156k0*cvqu
            cauxc=+c16w.ek0*p5(2)-p5k0*c16w.e(2)
            l5_16w.a(2)=wcl*(cauxa-ceps_0)
            l5_16w.c(2)=wcl*(-cauxc+ceps_1)
**** diagramma CN24
            DO i3=1,2
* TLTR0_W -- aa=cn24(i3).id(ide),a1=l1_34fz(i3).a,c1=l1_34fz(i3).c,a2=r6_25
* w.a,b2=r6_25w.b,prq=p134q,den=(p134q*p134k0),nsum=0
              cn24(i3).id(ide)=( l1_34fz(i3).c(2)*p134q*r6_25w.b(1)+l1_3
     &          4fz(i3).a(2)*r6_25w.a(2) )/(p134q*p134k0)
            END DO
**** diagramma CN25
            DO i3=1,2
* TLTR0_W -- aa=cn25(i3).id(ide),a1=l5_16w.a,c1=l5_16w.c,a2=r2_34fz(i3).a,b
* 2=r2_34fz(i3).b,prq=p156q,den=(p156q*p156k0),nsum=0
              cn25(i3).id(ide)=( l5_16w.c(2)*p156q*r2_34fz(i3).b(1)+l5_1
     &          6w.a(2)*r2_34fz(i3).a(2) )/(p156q*p156k0)
            END DO
**** diagramma CN26
            DO i3=1,2
* TLTR0_W -- aa=cn26(i3).id(ide),a1=l1_25w.a,c1=l1_25w.c,a2=r6_34fz(i3).a,b
* 2=r6_34fz(i3).b,prq=p125q,den=(p125q*p125k0),nsum=0
              cn26(i3).id(ide)=( l1_25w.c(2)*p125q*r6_34fz(i3).b(1)+l1_2
     &          5w.a(2)*r6_34fz(i3).a(2) )/(p125q*p125k0)
            END DO
**** diagramma CN27
            DO i3=1,2
* TLTR0_W -- aa=cn27(i3).id(ide),a1=l5_34fz(i3).a,c1=l5_34fz(i3).c,a2=r2_16
* w.a,b2=r2_16w.b,prq=p345q,den=(p345q*p345k0),nsum=0
              cn27(i3).id(ide)=( l5_34fz(i3).c(2)*p345q*r2_16w.b(1)+l5_3
     &          4fz(i3).a(2)*r2_16w.a(2) )/(p345q*p345k0)
            END DO
**** diagramma CN28
            IF (f3l.LT.0.d0) THEN
* TLTR0_W -- aa=cn28.id(ide),a1=l3_25w.a,c1=l3_25w.c,a2=r4_16w.a,b2=r4_16w.
* b,prq=p235q,den=((p235q-ibbveve*rmt2)*p235k0),nsum=0
              cn28.id(ide)=( l3_25w.c(2)*p235q*r4_16w.b(1)+l3_25w.a(2)*r
     &          4_16w.a(2) )/((p235q-ibbveve*rmt2)*p235k0)
            ELSE
* TLTR0_W -- aa=cn28.id(ide),a1=l3_16w.a,c1=l3_16w.c,a2=r4_25w.a,b2=r4_25w.
* b,prq=p136q,den=(p136q*p136k0),nsum=0
              cn28.id(ide)=( l3_16w.c(2)*p136q*r4_25w.b(1)+l3_16w.a(2)*r
     &          4_25w.a(2) )/(p136q*p136k0)
            ENDIF


            IF (i56ve.EQ.1.AND.iid.EQ.1) THEN
****          diagrammi per correnti neutre con scambi di w (6)
* quqd -- p=p1,q=p4
              quqd=p1(0)*p4(0)-p1(1)*p4(1)-p1(2)*p4(2)-p1(3)*p4(3)
              ccl=wcl/(2.d0*quqd+rmw2)
* TW10 -- qu=p1,qd=p4,v=0,a=c14w.e(0),cl=ccl,nsum=0
              eps_0=-p1(2)*p4(3)+p4(2)*p1(3)
              ceps_0=eps_0*cim
              auxa=-quqd+p1k0*p4(0)+p4k0*p1(0)
              c14w.e(0)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p4,v=1,a=c14w.e(1),cl=ccl,nsum=0
              auxa=-quqd+p1k0*p4(1)+p4k0*p1(1)
              c14w.e(1)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p4,v=2,a=c14w.e(2),cl=ccl,nsum=0
              eps_0=-p1k0*p4(3)+p4k0*p1(3)
              ceps_0=eps_0*cim
              auxa=p1k0*p4(2)+p4k0*p1(2)
              c14w.e(2)=ccl*(auxa-ceps_0)
* TW10 -- qu=p1,qd=p4,v=3,a=c14w.e(3),cl=ccl,nsum=0
              eps_0=p1k0*p4(2)-p4k0*p1(2)
              ceps_0=eps_0*cim
              auxa=p1k0*p4(3)+p4k0*p1(3)
              c14w.e(3)=ccl*(auxa-ceps_0)
* pk0 -- p=c14w.e
              c14w.ek0=c14w.e(0)-c14w.e(1)
* quqd -- p=p3,q=p2
              quqd=p3(0)*p2(0)-p3(1)*p2(1)-p3(2)*p2(2)-p3(3)*p2(3)
              ccl=wcl/(2.d0*quqd+rmw2)
* TW10 -- qu=p3,qd=p2,v=0,a=c23w.e(0),cl=ccl,nsum=0
              eps_0=-p3(2)*p2(3)+p2(2)*p3(3)
              ceps_0=eps_0*cim
              auxa=-quqd+p3k0*p2(0)+p2k0*p3(0)
              c23w.e(0)=ccl*(auxa-ceps_0)
* TW10 -- qu=p3,qd=p2,v=1,a=c23w.e(1),cl=ccl,nsum=0
              auxa=-quqd+p3k0*p2(1)+p2k0*p3(1)
              c23w.e(1)=ccl*(auxa-ceps_0)
* TW10 -- qu=p3,qd=p2,v=2,a=c23w.e(2),cl=ccl,nsum=0
              eps_0=-p3k0*p2(3)+p2k0*p3(3)
              ceps_0=eps_0*cim
              auxa=p3k0*p2(2)+p2k0*p3(2)
              c23w.e(2)=ccl*(auxa-ceps_0)
* TW10 -- qu=p3,qd=p2,v=3,a=c23w.e(3),cl=ccl,nsum=0
              eps_0=p3k0*p2(2)-p2k0*p3(2)
              ceps_0=eps_0*cim
              auxa=p3k0*p2(3)+p2k0*p3(3)
              c23w.e(3)=ccl*(auxa-ceps_0)
* pk0 -- p=c23w.e
              c23w.ek0=c23w.e(0)-c23w.e(1)
              IF (ianc.EQ.0) THEN
                DO i=1,2
                  DO mu=0,3
                    c56fz(i).e(mu)=c56f(i).e(mu)+rcotw*c56z(i).e(mu)
                  END DO
                END DO
              ELSE
                DO i=1,2
                  DO mu=0,3
                    c56fz(i).e(mu)=c56f(i).e(mu)+(rcotw+delz)*c56z(i).
     &                e(mu)
                  END DO
                END DO
              ENDIF
*
* diagramma triplo cn29
*
*** triple vertex -- pfz(mu)=p56(mu),pwm(mu)=p14(mu),pwp(mu)=p23(mu),efz=c5
* 6fz(i),ewm=c14w,ewp=c23w,res=cn29(i?).id(ide)
              DO mu=0,3
                vfz(mu)=p14(mu)-p23(mu)
                vwm(mu)=p23(mu)-p56(mu)
                vwp(mu)=p56(mu)-p14(mu)
              END DO !mu
* vfz.efz
              DO i=1,2
* p.q -- p.q=c56fz(i).v,p=c56fz(i).e,q=vfz
                c56fz(i).v=c56fz(i).e(0)*vfz(0)-c56fz(i).e(1)*vfz(1)
     &            -c56fz
     &            (i).e(2)*vfz(2)-c56fz(i).e(3)*vfz(3)
              END DO
* vwm.ewm
* p.q -- p.q=c14w.v,p=c14w.e,q=vwm
              c14w.v=c14w.e(0)*vwm(0)-c14w.e(1)*vwm(1)-c14w.e(2)*vwm(2)-
     &          c14w.e(3)*vwm(3)
* vwp.ewp
* p.q -- p.q=c23w.v,p=c23w.e,q=vwp
              c23w.v=c23w.e(0)*vwp(0)-c23w.e(1)*vwp(1)-c23w.e(2)*vwp(2)-
     &          c23w.e(3)*vwp(3)
* efz.ewm
              DO i=1,2
* p.q -- p.q=caux,p=c56fz(i).e,q=c14w.e
                caux=c56fz(i).e(0)*c14w.e(0)-c56fz(i).e(1)*c14w.e(1)
     &            -c56fz
     &            (i).e(2)*c14w.e(2)-c56fz(i).e(3)*c14w.e(3)
                cn29(i).id(ide)=c23w.v*caux
              END DO
* efz.ewp
              DO i=1,2
* p.q -- p.q=caux,p=c56fz(i).e,q=c23w.e
                caux=c56fz(i).e(0)*c23w.e(0)-c56fz(i).e(1)*c23w.e(1)
     &            -c56fz
     &            (i).e(2)*c23w.e(2)-c56fz(i).e(3)*c23w.e(3)
                cn29(i).id(ide)=cn29(i).id(ide)+c14w.v*caux
              END DO
* ewm.ewp
* p.q -- p.q=caux,p=c14w.e,q=c23w.e
              caux=c14w.e(0)*c23w.e(0)-c14w.e(1)*c23w.e(1)-c14w.e(2)*c23
     &          w.e(2)-c14w.e(3)*c23w.e(3)
              DO i=1,2
                cn29(i).id(ide)=cn29(i).id(ide)+c56fz(i).v*caux
              END DO
* anomalous couplings
              IF (ianc.NE.0) THEN
* p.q -- p.q=cemp0,p=c14w.e,q=p56
                cemp0=c14w.e(0)*p56(0)-c14w.e(1)*p56(1)-c14w.e(2)*p56(2)
     &            -c
     &            14w.e(3)*p56(3)
* p.q -- p.q=cepp0,p=c23w.e,q=p56
                cepp0=c23w.e(0)*p56(0)-c23w.e(1)*p56(1)-c23w.e(2)*p56(2)
     &            -c
     &            23w.e(3)*p56(3)

                IF (xf.NE.0.d0.OR.xz.NE.0.d0) THEN
                  DO i=1,2
                    DO mu=0,3
                      c56fz(i).e(mu)=xf*c56f(i).e(mu)+xz*c56z(i).e(mu)
                    END DO
                  END DO
                  DO i=1,2
* p.q -- p.q=ce0em(i),p=c56fz(i).e,q=c14w.e
                    ce0em(i)=c56fz(i).e(0)*c14w.e(0)-c56fz(i).e(1)*c14w.
     &                e(1)-c
     &                56fz(i).e(2)*c14w.e(2)-c56fz(i).e(3)*c14w.e(3)
                  END DO
                  DO i=1,2
* p.q -- p.q=ce0ep(i),p=c56fz(i).e,q=c23w.e
                    ce0ep(i)=c56fz(i).e(0)*c23w.e(0)-c56fz(i).e(1)*c23w.
     &                e(1)-c
     &                56fz(i).e(2)*c23w.e(2)-c56fz(i).e(3)*c23w.e(3)
                  END DO
                  DO i=1,2
                    cn29(i).id(ide)=cn29(i).id(ide)+ce0em(i)*cepp0
     &                -ce0ep(i)*cemp0
                  END DO
                ENDIF

                IF (yf.NE.0.d0.OR.yz.NE.0.d0) THEN
                  DO i=1,2
                    DO mu=0,3
                      c56fz(i).e(mu)=yf*c56f(i).e(mu)+yz*c56z(i).e(mu)
                    END DO
                  END DO
                  DO i=1,2
* p.q -- p.q=ce0em(i),p=c56fz(i).e,q=c14w.e
                    ce0em(i)=c56fz(i).e(0)*c14w.e(0)-c56fz(i).e(1)*c14w.
     &                e(1)-c
     &                56fz(i).e(2)*c14w.e(2)-c56fz(i).e(3)*c14w.e(3)
                  END DO
                  DO i=1,2
* p.q -- p.q=ce0ep(i),p=c56fz(i).e,q=c23w.e
                    ce0ep(i)=c56fz(i).e(0)*c23w.e(0)-c56fz(i).e(1)*c23w.
     &                e(1)-c
     &                56fz(i).e(2)*c23w.e(2)-c56fz(i).e(3)*c23w.e(3)
                  END DO
                  DO i=1,2
* p.q -- p.q=ce0pm(i),p=c56fz(i).e,q=p14
                    ce0pm(i)=c56fz(i).e(0)*p14(0)-c56fz(i).e(1)*p14(1)
     &                -c56fz(i
     &                ).e(2)*p14(2)-c56fz(i).e(3)*p14(3)
                  END DO
                  DO i=1,2
* p.q -- p.q=ce0pp(i),p=c56fz(i).e,q=p23
                    ce0pp(i)=c56fz(i).e(0)*p23(0)-c56fz(i).e(1)*p23(1)
     &                -c56fz(i
     &                ).e(2)*p23(2)-c56fz(i).e(3)*p23(3)
                  END DO
* p.q -- p.q=cemep,p=c14w.e,q=c23w.e
                  cemep=c14w.e(0)*c23w.e(0)-c14w.e(1)*c23w.e(1)-c14w.
     &              e(2)*c2
     &              3w.e(2)-c14w.e(3)*c23w.e(3)
* p.q -- p.q=cempp,p=c14w.e,q=p23
                  cempp=c14w.e(0)*p23(0)-c14w.e(1)*p23(1)-c14w.e(2)
     &              *p23(2)-c
     &              14w.e(3)*p23(3)
* p.q -- p.q=ceppm,p=c23w.e,q=p14
                  ceppm=c23w.e(0)*p14(0)-c23w.e(1)*p14(1)-c23w.e(2)
     &              *p14(2)-c
     &              23w.e(3)*p14(3)
* p.q -- p.q=p0pm,p=p56,q=p14
                  p0pm=p56(0)*p14(0)-p56(1)*p14(1)-p56(2)*p14(2)-p56(3)
     &              *p14(
     &              3)
* p.q -- p.q=p0pp,p=p56,q=p23
                  p0pp=p56(0)*p23(0)-p56(1)*p23(1)-p56(2)*p23(2)-p56(3)
     &              *p23(
     &              3)
* p.q -- p.q=pmpp,p=p14,q=p23
                  pmpp=p14(0)*p23(0)-p14(1)*p23(1)-p14(2)*p23(2)-p14(3)
     &              *p23(
     &              3)
                  DO i=1,2
                    cn29(i).id(ide)=cn29(i).id(ide)+ce0pm(i)
     &                *cepp0*cempp-
     &                ce0pp(i)*ceppm*cemp0+
     &                p0pp*(ce0em(i)*ceppm-cemep*ce0pm(i))+
     &                p0pm*(cemep*ce0pp(i)-ce0ep(i)*cempp)+
     &                pmpp*(ce0ep(i)*cemp0-ce0em(i)*cepp0)
                  END DO

                ENDIF
                IF (zz.NE.0.d0) THEN
                  DO m=0,3
                    cpau(m)=cepp0*c14w.e(m)-cemp0*c23w.e(m)
                    pau(m)=p23(m)-p14(m)
                  ENDDO
                  DO i=1,2
* eps -- eps=cau(i),p=c56z(i).e,q=cpau,r=p56,s=pau
                    cau(i)=c56z(i).e(0)*(cpau(1)*(p56(2)*pau(3)-p56(3)
     &                *pau(2))
     &                +cpau(2)*(p56(3)*pau(1)-p56(1)*pau(3))+cpau(3)
     &                *(p56(1)*pa
     &                u(2)-p56(2)*pau(1)))
                    cau(i)=cau(i)-c56z(i).e(1)*(cpau(2)*(p56(3)*pau(0)
     &                -p56(0)*
     &                pau(3))+cpau(3)*(p56(0)*pau(2)-p56(2)*pau(0))
     &                +cpau(0)*(p5
     &                6(2)*pau(3)-p56(3)*pau(2)))
                    cau(i)=cau(i)+c56z(i).e(2)*(cpau(3)*(p56(0)*pau(1)
     &                -p56(1)*
     &                pau(0))+cpau(0)*(p56(1)*pau(3)-p56(3)*pau(1))
     &                +cpau(1)*(p5
     &                6(3)*pau(0)-p56(0)*pau(3)))
                    cau(i)=cau(i)-c56z(i).e(3)*(cpau(0)*(p56(1)*pau(2)
     &                -p56(2)*
     &                pau(1))+cpau(1)*(p56(2)*pau(0)-p56(0)*pau(2))
     &                +cpau(2)*(p5
     &                6(0)*pau(1)-p56(1)*pau(0)))
                  END DO
                  DO i=1,2
                    cn29(i).id(ide)=cn29(i).id(ide)+cim*zz*cau(i)
                  ENDDO
                ENDIF
              ENDIF
* end anomalous couplings

* quqd -- p=p156,q=p4
              quqd=p156(0)*p4(0)-p156(1)*p4(1)-p156(2)*p4(2)-p156(3)*p4(
     &          3)
* TWR0 -- qu=p156,qd=p4,v=c23w.e,a=r4_23w.a,b=r4_23w.b,cl=wcl,nsum=0
              ceps_0=-c23w.ek0*(p156(2)*p4(3)-p4(2)*p156(3))+p156k0*(c23
     &          w.e(2)*p4(3)-p4(2)*c23w.e(3))-p4k0*(c23w.e(2)*p156(3)
     &          -p15
     &          6(2)*c23w.e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c23w.e(3)*p4k0+p4(3)*c23w.ek0
              ceps_2=ceps_2*cim
              cvqu=c23w.e(0)*p156(0)-c23w.e(1)*p156(1)-c23w.e(2)*p156(2)
     &          -c23w.e(3)*p156(3)
              cvqd=c23w.e(0)*p4(0)-c23w.e(1)*p4(1)-c23w.e(2)*p4(2)-c23w.
     &          e(3)*p4(3)
              cauxa=-c23w.ek0*quqd+p156k0*cvqd+p4k0*cvqu
              cauxb=-c23w.ek0*p4(2)+p4k0*c23w.e(2)
              r4_23w.a(2)=wcl*(cauxa-ceps_0)
              r4_23w.b(1)=wcl*(cauxb-ceps_2)
* quqd -- p=p356,q=p2
              quqd=p356(0)*p2(0)-p356(1)*p2(1)-p356(2)*p2(2)-p356(3)*p2(
     &          3)
* TWR0 -- qu=p356,qd=p2,v=c14w.e,a=r2_14w.a,b=r2_14w.b,cl=wcl,nsum=0
              ceps_0=-c14w.ek0*(p356(2)*p2(3)-p2(2)*p356(3))+p356k0*(c14
     &          w.e(2)*p2(3)-p2(2)*c14w.e(3))-p2k0*(c14w.e(2)*p356(3)
     &          -p35
     &          6(2)*c14w.e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c14w.e(3)*p2k0+p2(3)*c14w.ek0
              ceps_2=ceps_2*cim
              cvqu=c14w.e(0)*p356(0)-c14w.e(1)*p356(1)-c14w.e(2)*p356(2)
     &          -c14w.e(3)*p356(3)
              cvqd=c14w.e(0)*p2(0)-c14w.e(1)*p2(1)-c14w.e(2)*p2(2)-c14w.
     &          e(3)*p2(3)
              cauxa=-c14w.ek0*quqd+p356k0*cvqd+p2k0*cvqu
              cauxb=-c14w.ek0*p2(2)+p2k0*c14w.e(2)
              r2_14w.a(2)=wcl*(cauxa-ceps_0)
              r2_14w.b(1)=wcl*(cauxb-ceps_2)
*** per diagramma cn34
              IF (f5l.LT.0.d0) THEN
* quqd -- p=p235,q=p6
                quqd=p235(0)*p6(0)-p235(1)*p6(1)-p235(2)*p6(2)-p235(3)
     &            *p6(
     &            3)
* TWR0 -- qu=p235,qd=p6,v=c14w.e,a=r6_14w.a,b=r6_14w.b,cl=wcl,nsum=0
                ceps_0=-c14w.ek0*(p235(2)*p6(3)-p6(2)*p235(3))
     &            +p235k0*(c14
     &            w.e(2)*p6(3)-p6(2)*c14w.e(3))-p6k0*(c14w.e(2)*p235(3)
     &            -p23
     &            5(2)*c14w.e(3))
                ceps_0=ceps_0*cim
                ceps_2=-c14w.e(3)*p6k0+p6(3)*c14w.ek0
                ceps_2=ceps_2*cim
                cvqu=c14w.e(0)*p235(0)-c14w.e(1)*p235(1)-c14w.e(2)
     &            *p235(2)
     &            -c14w.e(3)*p235(3)
                cvqd=c14w.e(0)*p6(0)-c14w.e(1)*p6(1)-c14w.e(2)*p6(2)
     &            -c14w.
     &            e(3)*p6(3)
                cauxa=-c14w.ek0*quqd+p235k0*cvqd+p6k0*cvqu
                cauxb=-c14w.ek0*p6(2)+p6k0*c14w.e(2)
                r6_14w.a(2)=wcl*(cauxa-ceps_0)
                r6_14w.b(1)=wcl*(cauxb-ceps_2)
* quqd -- p=p5,q=p235
                quqd=p5(0)*p235(0)-p5(1)*p235(1)-p5(2)*p235(2)-p5(3)
     &            *p235(
     &            3)
* TWL0 -- qu=p5,qd=p235,v=c23w.e,a=l5_23w.a,c=l5_23w.c,cl=wcl,nsum=0
                ceps_0=-c23w.ek0*(p5(2)*p235(3)-p235(2)*p5(3))
     &            +p5k0*(c23w.
     &            e(2)*p235(3)-p235(2)*c23w.e(3))-p235k0*(c23w.e(2)
     &            *p5(3)-p
     &            5(2)*c23w.e(3))
                ceps_0=ceps_0*cim
                ceps_1=-c23w.e(3)*p5k0+p5(3)*c23w.ek0
                ceps_1=ceps_1*cim
                cvqu=c23w.e(0)*p5(0)-c23w.e(1)*p5(1)-c23w.e(2)*p5(2)
     &            -c23w.
     &            e(3)*p5(3)
                cvqd=c23w.e(0)*p235(0)-c23w.e(1)*p235(1)-c23w.e(2)
     &            *p235(2)
     &            -c23w.e(3)*p235(3)
                cauxa=-c23w.ek0*quqd+p5k0*cvqd+p235k0*cvqu
                cauxc=+c23w.ek0*p5(2)-p5k0*c23w.e(2)
                l5_23w.a(2)=wcl*(cauxa-ceps_0)
                l5_23w.c(2)=wcl*(-cauxc+ceps_1)
              ELSE

* quqd -- p=p145,q=p6
                quqd=p145(0)*p6(0)-p145(1)*p6(1)-p145(2)*p6(2)-p145(3)
     &            *p6(
     &            3)
* TWR0 -- qu=p145,qd=p6,v=c23w.e,a=r6_23w.a,b=r6_23w.b,cl=wcl,nsum=0
                ceps_0=-c23w.ek0*(p145(2)*p6(3)-p6(2)*p145(3))
     &            +p145k0*(c23
     &            w.e(2)*p6(3)-p6(2)*c23w.e(3))-p6k0*(c23w.e(2)*p145(3)
     &            -p14
     &            5(2)*c23w.e(3))
                ceps_0=ceps_0*cim
                ceps_2=-c23w.e(3)*p6k0+p6(3)*c23w.ek0
                ceps_2=ceps_2*cim
                cvqu=c23w.e(0)*p145(0)-c23w.e(1)*p145(1)-c23w.e(2)
     &            *p145(2)
     &            -c23w.e(3)*p145(3)
                cvqd=c23w.e(0)*p6(0)-c23w.e(1)*p6(1)-c23w.e(2)*p6(2)
     &            -c23w.
     &            e(3)*p6(3)
                cauxa=-c23w.ek0*quqd+p145k0*cvqd+p6k0*cvqu
                cauxb=-c23w.ek0*p6(2)+p6k0*c23w.e(2)
                r6_23w.a(2)=wcl*(cauxa-ceps_0)
                r6_23w.b(1)=wcl*(cauxb-ceps_2)
* quqd -- p=p5,q=p145
                quqd=p5(0)*p145(0)-p5(1)*p145(1)-p5(2)*p145(2)-p5(3)
     &            *p145(
     &            3)
* TWL0 -- qu=p5,qd=p145,v=c14w.e,a=l5_14w.a,c=l5_14w.c,cl=wcl,nsum=0
                ceps_0=-c14w.ek0*(p5(2)*p145(3)-p145(2)*p5(3))
     &            +p5k0*(c14w.
     &            e(2)*p145(3)-p145(2)*c14w.e(3))-p145k0*(c14w.e(2)
     &            *p5(3)-p
     &            5(2)*c14w.e(3))
                ceps_0=ceps_0*cim
                ceps_1=-c14w.e(3)*p5k0+p5(3)*c14w.ek0
                ceps_1=ceps_1*cim
                cvqu=c14w.e(0)*p5(0)-c14w.e(1)*p5(1)-c14w.e(2)*p5(2)
     &            -c14w.
     &            e(3)*p5(3)
                cvqd=c14w.e(0)*p145(0)-c14w.e(1)*p145(1)-c14w.e(2)
     &            *p145(2)
     &            -c14w.e(3)*p145(3)
                cauxa=-c14w.ek0*quqd+p5k0*cvqd+p145k0*cvqu
                cauxc=+c14w.ek0*p5(2)-p5k0*c14w.e(2)
                l5_14w.a(2)=wcl*(cauxa-ceps_0)
                l5_14w.c(2)=wcl*(-cauxc+ceps_1)
              ENDIF
****
* quqd -- p=p1,q=p123
              quqd=p1(0)*p123(0)-p1(1)*p123(1)-p1(2)*p123(2)-p1(3)*p123(
     &          3)
* TWL0 -- qu=p1,qd=p123,v=c23w.e,a=l1_23w.a,c=l1_23w.c,cl=wcl,nsum=0
              ceps_0=-c23w.ek0*(p1(2)*p123(3)-p123(2)*p1(3))+p1k0*(c23w.
     &          e(2)*p123(3)-p123(2)*c23w.e(3))-p123k0*(c23w.e(2)*p1(3)
     &          -p
     &          1(2)*c23w.e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c23w.e(3)*p1k0+p1(3)*c23w.ek0
              ceps_1=ceps_1*cim
              cvqu=c23w.e(0)*p1(0)-c23w.e(1)*p1(1)-c23w.e(2)*p1(2)-c23w.
     &          e(3)*p1(3)
              cvqd=c23w.e(0)*p123(0)-c23w.e(1)*p123(1)-c23w.e(2)*p123(2)
     &          -c23w.e(3)*p123(3)
              cauxa=-c23w.ek0*quqd+p1k0*cvqd+p123k0*cvqu
              cauxc=+c23w.ek0*p1(2)-p1k0*c23w.e(2)
              l1_23w.a(2)=wcl*(cauxa-ceps_0)
              l1_23w.c(2)=wcl*(-cauxc+ceps_1)
* quqd -- p=p3,q=p134
              quqd=p3(0)*p134(0)-p3(1)*p134(1)-p3(2)*p134(2)-p3(3)*p134(
     &          3)
* TWL0 -- qu=p3,qd=p134,v=c14w.e,a=l3_14w.a,c=l3_14w.c,cl=wcl,nsum=0
              ceps_0=-c14w.ek0*(p3(2)*p134(3)-p134(2)*p3(3))+p3k0*(c14w.
     &          e(2)*p134(3)-p134(2)*c14w.e(3))-p134k0*(c14w.e(2)*p3(3)
     &          -p
     &          3(2)*c14w.e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c14w.e(3)*p3k0+p3(3)*c14w.ek0
              ceps_1=ceps_1*cim
              cvqu=c14w.e(0)*p3(0)-c14w.e(1)*p3(1)-c14w.e(2)*p3(2)-c14w.
     &          e(3)*p3(3)
              cvqd=c14w.e(0)*p134(0)-c14w.e(1)*p134(1)-c14w.e(2)*p134(2)
     &          -c14w.e(3)*p134(3)
              cauxa=-c14w.ek0*quqd+p3k0*cvqd+p134k0*cvqu
              cauxc=+c14w.ek0*p3(2)-p3k0*c14w.e(2)
              l3_14w.a(2)=wcl*(cauxa-ceps_0)
              l3_14w.c(2)=wcl*(-cauxc+ceps_1)
**** diagramma CN30
              DO i5=1,2
* TLTR0_W -- aa=cn30(i5).id(ide),a1=l1_56fz(i5).a,c1=l1_56fz(i5).c,a2=r4_23
* w.a,b2=r4_23w.b,prq=p156q,den=(p156q*p156k0),nsum=0
                cn30(i5).id(ide)=( l1_56fz(i5).c(2)*p156q*r4_23w.b(1)
     &            +l1_5
     &            6fz(i5).a(2)*r4_23w.a(2) )/(p156q*p156k0)
              END DO
**** diagramma CN31
              DO i5=1,2
* TLTR0_W -- aa=cn31(i5).id(ide),a1=l3_14w.a,c1=l3_14w.c,a2=r2_56fz(i5).a,b
* 2=r2_56fz(i5).b,prq=p134q,den=(p134q*p134k0),nsum=0
                cn31(i5).id(ide)=( l3_14w.c(2)*p134q*r2_56fz(i5).b(1)
     &            +l3_1
     &            4w.a(2)*r2_56fz(i5).a(2) )/(p134q*p134k0)
              END DO
**** diagramma CN32
              DO i5=1,2
* TLTR0_W -- aa=cn32(i5).id(ide),a1=l1_23w.a,c1=l1_23w.c,a2=r4_56fz(i5).a,b
* 2=r4_56fz(i5).b,prq=p123q,den=(p123q*p123k0),nsum=0
                cn32(i5).id(ide)=( l1_23w.c(2)*p123q*r4_56fz(i5).b(1)
     &            +l1_2
     &            3w.a(2)*r4_56fz(i5).a(2) )/(p123q*p123k0)
              END DO
**** diagramma CN33
              DO i5=1,2
* TLTR0_W -- aa=cn33(i5).id(ide),a1=l3_56fz(i5).a,c1=l3_56fz(i5).c,a2=r2_14
* w.a,b2=r2_14w.b,prq=p356q,den=(p356q*p356k0),nsum=0
                cn33(i5).id(ide)=( l3_56fz(i5).c(2)*p356q*r2_14w.b(1)
     &            +l3_5
     &            6fz(i5).a(2)*r2_14w.a(2) )/(p356q*p356k0)
              END DO
**** diagramma CN34
              IF (f5l.LT.0.d0) THEN
* TLTR0_W -- aa=cn34.id(ide),a1=l5_23w.a,c1=l5_23w.c,a2=r6_14w.a,b2=r6_14w.
* b,prq=p235q,den=((p235q-ibbveve*rmt2)*p235k0),nsum=0
                cn34.id(ide)=( l5_23w.c(2)*p235q*r6_14w.b(1)+l5_23w.a(2)
     &            *r
     &            6_14w.a(2) )/((p235q-ibbveve*rmt2)*p235k0)
              ELSE
* TLTR0_W -- aa=cn34.id(ide),a1=l5_14w.a,c1=l5_14w.c,a2=r6_23w.a,b2=r6_23w.
* b,prq=p145q,den=(p145q*p145k0),nsum=0
                cn34.id(ide)=( l5_14w.c(2)*p145q*r6_23w.b(1)+l5_14w.a(2)
     &            *r
     &            6_23w.a(2) )/(p145q*p145k0)
              ENDIF
            ENDIF  !i56ve.and.iid
          ENDIF  !i56ve
          IF (iid.EQ.1.AND.i34e.EQ.1) THEN !anche 56 sono elettroni
****          24 con coppia 56 elet., come a i34.eq.1 con scambio
****          coppie 35<->56, dove programma entro prossimo dotab e' lo stesso

* quqd -- p=p5,q=p2
            quqd=p5(0)*p2(0)-p5(1)*p2(1)-p5(2)*p2(2)-p5(3)*p2(3)
            df=2.d0*quqd
            dz=2.d0*quqd+rmz2
            rcr=fer/df
            rcl=fel/df
* T10 -- qu=p5,qd=p2,v=0,a=c25f(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p5(2)*p2(3)+p2(2)*p5(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p5k0*p2(0)+p2k0*p5(0)
            c25f(1).e(0)=rcr*(auxa+ceps_0)
            c25f(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p2,v=1,a=c25f(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p5k0*p2(1)+p2k0*p5(1)
            c25f(1).e(1)=rcr*(auxa+ceps_0)
            c25f(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p2,v=2,a=c25f(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p5k0*p2(3)+p2k0*p5(3)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(2)+p2k0*p5(2)
            c25f(1).e(2)=rcr*(auxa+ceps_0)
            c25f(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p2,v=3,a=c25f(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p5k0*p2(2)-p2k0*p5(2)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(3)+p2k0*p5(3)
            c25f(1).e(3)=rcr*(auxa+ceps_0)
            c25f(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c25f(i).e
              c25f(i).ek0=c25f(i).e(0)-c25f(i).e(1)
            END DO
            rcr=zer/dz
            rcl=zel/dz
* T10 -- qu=p5,qd=p2,v=0,a=c25z(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p5(2)*p2(3)+p2(2)*p5(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p5k0*p2(0)+p2k0*p5(0)
            c25z(1).e(0)=rcr*(auxa+ceps_0)
            c25z(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p2,v=1,a=c25z(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p5k0*p2(1)+p2k0*p5(1)
            c25z(1).e(1)=rcr*(auxa+ceps_0)
            c25z(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p2,v=2,a=c25z(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p5k0*p2(3)+p2k0*p5(3)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(2)+p2k0*p5(2)
            c25z(1).e(2)=rcr*(auxa+ceps_0)
            c25z(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p5,qd=p2,v=3,a=c25z(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p5k0*p2(2)-p2k0*p5(2)
            ceps_0=eps_0*cim
            auxa=p5k0*p2(3)+p2k0*p5(3)
            c25z(1).e(3)=rcr*(auxa+ceps_0)
            c25z(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c25z(i).e
              c25z(i).ek0=c25z(i).e(0)-c25z(i).e(1)
            END DO
* quqd -- p=p1,q=p6
            quqd=p1(0)*p6(0)-p1(1)*p6(1)-p1(2)*p6(2)-p1(3)*p6(3)
            df=2.d0*quqd
            dz=2.d0*quqd+rmz2
            rcr=fer/df
            rcl=fel/df
* T10 -- qu=p1,qd=p6,v=0,a=c16f(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1(2)*p6(3)+p6(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p6(0)+p6k0*p1(0)
            c16f(1).e(0)=rcr*(auxa+ceps_0)
            c16f(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p6,v=1,a=c16f(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p1k0*p6(1)+p6k0*p1(1)
            c16f(1).e(1)=rcr*(auxa+ceps_0)
            c16f(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p6,v=2,a=c16f(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1k0*p6(3)+p6k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(2)+p6k0*p1(2)
            c16f(1).e(2)=rcr*(auxa+ceps_0)
            c16f(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p6,v=3,a=c16f(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p1k0*p6(2)-p6k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(3)+p6k0*p1(3)
            c16f(1).e(3)=rcr*(auxa+ceps_0)
            c16f(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c16f(i).e
              c16f(i).ek0=c16f(i).e(0)-c16f(i).e(1)
            END DO
            rcr=zer/dz
            rcl=zel/dz
* T10 -- qu=p1,qd=p6,v=0,a=c16z(&).e(0),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1(2)*p6(3)+p6(2)*p1(3)
            ceps_0=eps_0*cim
            auxa=-quqd+p1k0*p6(0)+p6k0*p1(0)
            c16z(1).e(0)=rcr*(auxa+ceps_0)
            c16z(2).e(0)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p6,v=1,a=c16z(&).e(1),cr=rcr,cl=rcl,nsum=0
            auxa=-quqd+p1k0*p6(1)+p6k0*p1(1)
            c16z(1).e(1)=rcr*(auxa+ceps_0)
            c16z(2).e(1)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p6,v=2,a=c16z(&).e(2),cr=rcr,cl=rcl,nsum=0
            eps_0=-p1k0*p6(3)+p6k0*p1(3)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(2)+p6k0*p1(2)
            c16z(1).e(2)=rcr*(auxa+ceps_0)
            c16z(2).e(2)=rcl*(auxa-ceps_0)
* T10 -- qu=p1,qd=p6,v=3,a=c16z(&).e(3),cr=rcr,cl=rcl,nsum=0
            eps_0=p1k0*p6(2)-p6k0*p1(2)
            ceps_0=eps_0*cim
            auxa=p1k0*p6(3)+p6k0*p1(3)
            c16z(1).e(3)=rcr*(auxa+ceps_0)
            c16z(2).e(3)=rcl*(auxa-ceps_0)
            DO i=1,2
* pk0 -- p=c16z(i).e
              c16z(i).ek0=c16z(i).e(0)-c16z(i).e(1)
            END DO
**** attaccamento di c25f(2) a 6
* quqd -- p=p134,q=p6
            quqd=p134(0)*p6(0)-p134(1)*p6(1)-p134(2)*p6(2)-p134(3)*p6(
     &        3)
            DO i=1,2
* TR0 -- qu=p134,qd=p6,v=c25f(i).e,a=r6_25fz(i).a,b=r6_25fz(i).b,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c25f(i).ek0*(p134(2)*p6(3)-p6(2)*p134(3))+p134k0*(
     &          c25f(i).e(2)*p6(3)-p6(2)*c25f(i).e(3))-p6k0*(c25f(i).
     &          e(2)
     &          *p134(3)-p134(2)*c25f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c25f(i).e(3)*p6k0+p6(3)*c25f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c25f(i).e(0)*p134(0)-c25f(i).e(1)*p134(1)-c25f(i).e(2
     &          )*p134(2)-c25f(i).e(3)*p134(3)
              cvqd=c25f(i).e(0)*p6(0)-c25f(i).e(1)*p6(1)-c25f(i).e(2)*p6
     &          (2)-c25f(i).e(3)*p6(3)
              cauxa=-c25f(i).ek0*quqd+p134k0*cvqd+p6k0*cvqu
              cauxb=-c25f(i).ek0*p6(2)+p6k0*c25f(i).e(2)
              r6_25fz(i).a(1)=fer*(cauxa+ceps_0)
              r6_25fz(i).a(2)=fel*(cauxa-ceps_0)
              r6_25fz(i).b(1)=fel*(cauxb-ceps_2)
              r6_25fz(i).b(2)=fer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c25z(2) a 6
            DO i=1,2
* TR0 -- qu=p134,qd=p6,v=c25z(i).e,a=r6_25fz(i).a,b=r6_25fz(i).b,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c25z(i).ek0*(p134(2)*p6(3)-p6(2)*p134(3))+p134k0*(
     &          c25z(i).e(2)*p6(3)-p6(2)*c25z(i).e(3))-p6k0*(c25z(i).
     &          e(2)
     &          *p134(3)-p134(2)*c25z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c25z(i).e(3)*p6k0+p6(3)*c25z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c25z(i).e(0)*p134(0)-c25z(i).e(1)*p134(1)-c25z(i).e(2
     &          )*p134(2)-c25z(i).e(3)*p134(3)
              cvqd=c25z(i).e(0)*p6(0)-c25z(i).e(1)*p6(1)-c25z(i).e(2)*p6
     &          (2)-c25z(i).e(3)*p6(3)
              cauxa=-c25z(i).ek0*quqd+p134k0*cvqd+p6k0*cvqu
              cauxb=-c25z(i).ek0*p6(2)+p6k0*c25z(i).e(2)
              r6_25fz(i).a(1)=r6_25fz(i).a(1)+zer*(cauxa+ceps_0)
              r6_25fz(i).a(2)=r6_25fz(i).a(2)+zel*(cauxa-ceps_0)
              r6_25fz(i).b(1)=r6_25fz(i).b(1)+zel*(cauxb-ceps_2)
              r6_25fz(i).b(2)=r6_25fz(i).b(2)+zer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c16f(2) a 2
* quqd -- p=p345,q=p2
            quqd=p345(0)*p2(0)-p345(1)*p2(1)-p345(2)*p2(2)-p345(3)*p2(
     &        3)
            DO i=1,2
* TR0 -- qu=p345,qd=p2,v=c16f(i).e,a=r2_16fz(i).a,b=r2_16fz(i).b,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c16f(i).ek0*(p345(2)*p2(3)-p2(2)*p345(3))+p345k0*(
     &          c16f(i).e(2)*p2(3)-p2(2)*c16f(i).e(3))-p2k0*(c16f(i).
     &          e(2)
     &          *p345(3)-p345(2)*c16f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c16f(i).e(3)*p2k0+p2(3)*c16f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c16f(i).e(0)*p345(0)-c16f(i).e(1)*p345(1)-c16f(i).e(2
     &          )*p345(2)-c16f(i).e(3)*p345(3)
              cvqd=c16f(i).e(0)*p2(0)-c16f(i).e(1)*p2(1)-c16f(i).e(2)*p2
     &          (2)-c16f(i).e(3)*p2(3)
              cauxa=-c16f(i).ek0*quqd+p345k0*cvqd+p2k0*cvqu
              cauxb=-c16f(i).ek0*p2(2)+p2k0*c16f(i).e(2)
              r2_16fz(i).a(1)=fer*(cauxa+ceps_0)
              r2_16fz(i).a(2)=fel*(cauxa-ceps_0)
              r2_16fz(i).b(1)=fel*(cauxb-ceps_2)
              r2_16fz(i).b(2)=fer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c16z(2) a 2
            DO i=1,2
* TR0 -- qu=p345,qd=p2,v=c16z(i).e,a=r2_16fz(i).a,b=r2_16fz(i).b,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c16z(i).ek0*(p345(2)*p2(3)-p2(2)*p345(3))+p345k0*(
     &          c16z(i).e(2)*p2(3)-p2(2)*c16z(i).e(3))-p2k0*(c16z(i).
     &          e(2)
     &          *p345(3)-p345(2)*c16z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c16z(i).e(3)*p2k0+p2(3)*c16z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c16z(i).e(0)*p345(0)-c16z(i).e(1)*p345(1)-c16z(i).e(2
     &          )*p345(2)-c16z(i).e(3)*p345(3)
              cvqd=c16z(i).e(0)*p2(0)-c16z(i).e(1)*p2(1)-c16z(i).e(2)*p2
     &          (2)-c16z(i).e(3)*p2(3)
              cauxa=-c16z(i).ek0*quqd+p345k0*cvqd+p2k0*cvqu
              cauxb=-c16z(i).ek0*p2(2)+p2k0*c16z(i).e(2)
              r2_16fz(i).a(1)=r2_16fz(i).a(1)+zer*(cauxa+ceps_0)
              r2_16fz(i).a(2)=r2_16fz(i).a(2)+zel*(cauxa-ceps_0)
              r2_16fz(i).b(1)=r2_16fz(i).b(1)+zel*(cauxb-ceps_2)
              r2_16fz(i).b(2)=r2_16fz(i).b(2)+zer*(-cauxb-ceps_2)
            END DO
**** attaccamento di c25f(2) a 1
* quqd -- p=p1,q=p125
            quqd=p1(0)*p125(0)-p1(1)*p125(1)-p1(2)*p125(2)-p1(3)*p125(
     &        3)
            DO i=1,2
* TL0 -- qu=p1,qd=p125,v=c25f(i).e,a=l1_25fz(i).a,c=l1_25fz(i).c,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c25f(i).ek0*(p1(2)*p125(3)-p125(2)*p1(3))+p1k0*(c2
     &          5f(i).e(2)*p125(3)-p125(2)*c25f(i).e(3))
     &          -p125k0*(c25f(i).
     &          e(2)*p1(3)-p1(2)*c25f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c25f(i).e(3)*p1k0+p1(3)*c25f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c25f(i).e(0)*p1(0)-c25f(i).e(1)*p1(1)-c25f(i).e(2)*p1
     &          (2)-c25f(i).e(3)*p1(3)
              cvqd=c25f(i).e(0)*p125(0)-c25f(i).e(1)*p125(1)-c25f(i).e(2
     &          )*p125(2)-c25f(i).e(3)*p125(3)
              cauxa=-c25f(i).ek0*quqd+p1k0*cvqd+p125k0*cvqu
              cauxc=+c25f(i).ek0*p1(2)-p1k0*c25f(i).e(2)
              l1_25fz(i).a(1)=fer*(cauxa+ceps_0)
              l1_25fz(i).a(2)=fel*(cauxa-ceps_0)
              l1_25fz(i).c(1)=fer*(cauxc+ceps_1)
              l1_25fz(i).c(2)=fel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c25z(2) a 1
            DO i=1,2
* TL0 -- qu=p1,qd=p125,v=c25z(i).e,a=l1_25fz(i).a,c=l1_25fz(i).c,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c25z(i).ek0*(p1(2)*p125(3)-p125(2)*p1(3))+p1k0*(c2
     &          5z(i).e(2)*p125(3)-p125(2)*c25z(i).e(3))
     &          -p125k0*(c25z(i).
     &          e(2)*p1(3)-p1(2)*c25z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c25z(i).e(3)*p1k0+p1(3)*c25z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c25z(i).e(0)*p1(0)-c25z(i).e(1)*p1(1)-c25z(i).e(2)*p1
     &          (2)-c25z(i).e(3)*p1(3)
              cvqd=c25z(i).e(0)*p125(0)-c25z(i).e(1)*p125(1)-c25z(i).e(2
     &          )*p125(2)-c25z(i).e(3)*p125(3)
              cauxa=-c25z(i).ek0*quqd+p1k0*cvqd+p125k0*cvqu
              cauxc=+c25z(i).ek0*p1(2)-p1k0*c25z(i).e(2)
              l1_25fz(i).a(1)=l1_25fz(i).a(1)+zer*(cauxa+ceps_0)
              l1_25fz(i).a(2)=l1_25fz(i).a(2)+zel*(cauxa-ceps_0)
              l1_25fz(i).c(1)=l1_25fz(i).c(1)+zer*(cauxc+ceps_1)
              l1_25fz(i).c(2)=l1_25fz(i).c(2)+zel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c16f(2) a 5
* quqd -- p=p5,q=p156
            quqd=p5(0)*p156(0)-p5(1)*p156(1)-p5(2)*p156(2)-p5(3)*p156(
     &        3)
            DO i=1,2
* TL0 -- qu=p5,qd=p156,v=c16f(i).e,a=l5_16fz(i).a,c=l5_16fz(i).c,cr=fer,cl=
* fel,nsum=0
              ceps_0=-c16f(i).ek0*(p5(2)*p156(3)-p156(2)*p5(3))+p5k0*(c1
     &          6f(i).e(2)*p156(3)-p156(2)*c16f(i).e(3))
     &          -p156k0*(c16f(i).
     &          e(2)*p5(3)-p5(2)*c16f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c16f(i).e(3)*p5k0+p5(3)*c16f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c16f(i).e(0)*p5(0)-c16f(i).e(1)*p5(1)-c16f(i).e(2)*p5
     &          (2)-c16f(i).e(3)*p5(3)
              cvqd=c16f(i).e(0)*p156(0)-c16f(i).e(1)*p156(1)-c16f(i).e(2
     &          )*p156(2)-c16f(i).e(3)*p156(3)
              cauxa=-c16f(i).ek0*quqd+p5k0*cvqd+p156k0*cvqu
              cauxc=+c16f(i).ek0*p5(2)-p5k0*c16f(i).e(2)
              l5_16fz(i).a(1)=fer*(cauxa+ceps_0)
              l5_16fz(i).a(2)=fel*(cauxa-ceps_0)
              l5_16fz(i).c(1)=fer*(cauxc+ceps_1)
              l5_16fz(i).c(2)=fel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c16z(2) a 5
            DO i=1,2
* TL0 -- qu=p5,qd=p156,v=c16z(i).e,a=l5_16fz(i).a,c=l5_16fz(i).c,cr=zer,cl=
* zel,nsum=1
              ceps_0=-c16z(i).ek0*(p5(2)*p156(3)-p156(2)*p5(3))+p5k0*(c1
     &          6z(i).e(2)*p156(3)-p156(2)*c16z(i).e(3))
     &          -p156k0*(c16z(i).
     &          e(2)*p5(3)-p5(2)*c16z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c16z(i).e(3)*p5k0+p5(3)*c16z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c16z(i).e(0)*p5(0)-c16z(i).e(1)*p5(1)-c16z(i).e(2)*p5
     &          (2)-c16z(i).e(3)*p5(3)
              cvqd=c16z(i).e(0)*p156(0)-c16z(i).e(1)*p156(1)-c16z(i).e(2
     &          )*p156(2)-c16z(i).e(3)*p156(3)
              cauxa=-c16z(i).ek0*quqd+p5k0*cvqd+p156k0*cvqu
              cauxc=+c16z(i).ek0*p5(2)-p5k0*c16z(i).e(2)
              l5_16fz(i).a(1)=l5_16fz(i).a(1)+zer*(cauxa+ceps_0)
              l5_16fz(i).a(2)=l5_16fz(i).a(2)+zel*(cauxa-ceps_0)
              l5_16fz(i).c(1)=l5_16fz(i).c(1)+zer*(cauxc+ceps_1)
              l5_16fz(i).c(2)=l5_16fz(i).c(2)+zel*(-cauxc+ceps_1)
            END DO
**** attaccamento di c16f(2) a 3
* quqd -- p=p3,q=p136
            quqd=p3(0)*p136(0)-p3(1)*p136(1)-p3(2)*p136(2)-p3(3)*p136(
     &        3)
            DO i=1,2
* TL0 -- qu=p3,qd=p136,v=c16f(i).e,a=l3_16fz(i).a,c=l3_16fz(i).c,cr=f3r,cl=
* f3l,nsum=0
              ceps_0=-c16f(i).ek0*(p3(2)*p136(3)-p136(2)*p3(3))+p3k0*(c1
     &          6f(i).e(2)*p136(3)-p136(2)*c16f(i).e(3))
     &          -p136k0*(c16f(i).
     &          e(2)*p3(3)-p3(2)*c16f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c16f(i).e(3)*p3k0+p3(3)*c16f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c16f(i).e(0)*p3(0)-c16f(i).e(1)*p3(1)-c16f(i).e(2)*p3
     &          (2)-c16f(i).e(3)*p3(3)
              cvqd=c16f(i).e(0)*p136(0)-c16f(i).e(1)*p136(1)-c16f(i).e(2
     &          )*p136(2)-c16f(i).e(3)*p136(3)
              cauxa=-c16f(i).ek0*quqd+p3k0*cvqd+p136k0*cvqu
              cauxc=+c16f(i).ek0*p3(2)-p3k0*c16f(i).e(2)
              l3_16fz(i).a(1)=f3r*(cauxa+ceps_0)
              l3_16fz(i).a(2)=f3l*(cauxa-ceps_0)
              l3_16fz(i).c(1)=f3r*(cauxc+ceps_1)
              l3_16fz(i).c(2)=f3l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c16z(2) a 3
            DO i=1,2
* TL0 -- qu=p3,qd=p136,v=c16z(i).e,a=l3_16fz(i).a,c=l3_16fz(i).c,cr=z3r,cl=
* z3l,nsum=1
              ceps_0=-c16z(i).ek0*(p3(2)*p136(3)-p136(2)*p3(3))+p3k0*(c1
     &          6z(i).e(2)*p136(3)-p136(2)*c16z(i).e(3))
     &          -p136k0*(c16z(i).
     &          e(2)*p3(3)-p3(2)*c16z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c16z(i).e(3)*p3k0+p3(3)*c16z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c16z(i).e(0)*p3(0)-c16z(i).e(1)*p3(1)-c16z(i).e(2)*p3
     &          (2)-c16z(i).e(3)*p3(3)
              cvqd=c16z(i).e(0)*p136(0)-c16z(i).e(1)*p136(1)-c16z(i).e(2
     &          )*p136(2)-c16z(i).e(3)*p136(3)
              cauxa=-c16z(i).ek0*quqd+p3k0*cvqd+p136k0*cvqu
              cauxc=+c16z(i).ek0*p3(2)-p3k0*c16z(i).e(2)
              l3_16fz(i).a(1)=l3_16fz(i).a(1)+z3r*(cauxa+ceps_0)
              l3_16fz(i).a(2)=l3_16fz(i).a(2)+z3l*(cauxa-ceps_0)
              l3_16fz(i).c(1)=l3_16fz(i).c(1)+z3r*(cauxc+ceps_1)
              l3_16fz(i).c(2)=l3_16fz(i).c(2)+z3l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c25f(2) a 3
* quqd -- p=p3,q=p235
            quqd=p3(0)*p235(0)-p3(1)*p235(1)-p3(2)*p235(2)-p3(3)*p235(
     &        3)
            DO i=1,2
* TL0 -- qu=p3,qd=p235,v=c25f(i).e,a=l3_25fz(i).a,c=l3_25fz(i).c,cr=f3r,cl=
* f3l,nsum=0
              ceps_0=-c25f(i).ek0*(p3(2)*p235(3)-p235(2)*p3(3))+p3k0*(c2
     &          5f(i).e(2)*p235(3)-p235(2)*c25f(i).e(3))
     &          -p235k0*(c25f(i).
     &          e(2)*p3(3)-p3(2)*c25f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c25f(i).e(3)*p3k0+p3(3)*c25f(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c25f(i).e(0)*p3(0)-c25f(i).e(1)*p3(1)-c25f(i).e(2)*p3
     &          (2)-c25f(i).e(3)*p3(3)
              cvqd=c25f(i).e(0)*p235(0)-c25f(i).e(1)*p235(1)-c25f(i).e(2
     &          )*p235(2)-c25f(i).e(3)*p235(3)
              cauxa=-c25f(i).ek0*quqd+p3k0*cvqd+p235k0*cvqu
              cauxc=+c25f(i).ek0*p3(2)-p3k0*c25f(i).e(2)
              l3_25fz(i).a(1)=f3r*(cauxa+ceps_0)
              l3_25fz(i).a(2)=f3l*(cauxa-ceps_0)
              l3_25fz(i).c(1)=f3r*(cauxc+ceps_1)
              l3_25fz(i).c(2)=f3l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c25z(2) a 3
            DO i=1,2
* TL0 -- qu=p3,qd=p235,v=c25z(i).e,a=l3_25fz(i).a,c=l3_25fz(i).c,cr=z3r,cl=
* z3l,nsum=1
              ceps_0=-c25z(i).ek0*(p3(2)*p235(3)-p235(2)*p3(3))+p3k0*(c2
     &          5z(i).e(2)*p235(3)-p235(2)*c25z(i).e(3))
     &          -p235k0*(c25z(i).
     &          e(2)*p3(3)-p3(2)*c25z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_1=-c25z(i).e(3)*p3k0+p3(3)*c25z(i).ek0
              ceps_1=ceps_1*cim
              cvqu=c25z(i).e(0)*p3(0)-c25z(i).e(1)*p3(1)-c25z(i).e(2)*p3
     &          (2)-c25z(i).e(3)*p3(3)
              cvqd=c25z(i).e(0)*p235(0)-c25z(i).e(1)*p235(1)-c25z(i).e(2
     &          )*p235(2)-c25z(i).e(3)*p235(3)
              cauxa=-c25z(i).ek0*quqd+p3k0*cvqd+p235k0*cvqu
              cauxc=+c25z(i).ek0*p3(2)-p3k0*c25z(i).e(2)
              l3_25fz(i).a(1)=l3_25fz(i).a(1)+z3r*(cauxa+ceps_0)
              l3_25fz(i).a(2)=l3_25fz(i).a(2)+z3l*(cauxa-ceps_0)
              l3_25fz(i).c(1)=l3_25fz(i).c(1)+z3r*(cauxc+ceps_1)
              l3_25fz(i).c(2)=l3_25fz(i).c(2)+z3l*(-cauxc+ceps_1)
            END DO
**** attaccamento di c25f(2) a 4
* quqd -- p=p136,q=p4
            quqd=p136(0)*p4(0)-p136(1)*p4(1)-p136(2)*p4(2)-p136(3)*p4(
     &        3)
            DO i=1,2
* TR0 -- qu=p136,qd=p4,v=c25f(i).e,a=r4_25fz(i).a,b=r4_25fz(i).b,cr=f3r,cl=
* f3l,nsum=0
              ceps_0=-c25f(i).ek0*(p136(2)*p4(3)-p4(2)*p136(3))+p136k0*(
     &          c25f(i).e(2)*p4(3)-p4(2)*c25f(i).e(3))-p4k0*(c25f(i).
     &          e(2)
     &          *p136(3)-p136(2)*c25f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c25f(i).e(3)*p4k0+p4(3)*c25f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c25f(i).e(0)*p136(0)-c25f(i).e(1)*p136(1)-c25f(i).e(2
     &          )*p136(2)-c25f(i).e(3)*p136(3)
              cvqd=c25f(i).e(0)*p4(0)-c25f(i).e(1)*p4(1)-c25f(i).e(2)*p4
     &          (2)-c25f(i).e(3)*p4(3)
              cauxa=-c25f(i).ek0*quqd+p136k0*cvqd+p4k0*cvqu
              cauxb=-c25f(i).ek0*p4(2)+p4k0*c25f(i).e(2)
              r4_25fz(i).a(1)=f3r*(cauxa+ceps_0)
              r4_25fz(i).a(2)=f3l*(cauxa-ceps_0)
              r4_25fz(i).b(1)=f3l*(cauxb-ceps_2)
              r4_25fz(i).b(2)=f3r*(-cauxb-ceps_2)
            END DO
**** attaccamento di c25z(2) a 4
            DO i=1,2
* TR0 -- qu=p136,qd=p4,v=c25z(i).e,a=r4_25fz(i).a,b=r4_25fz(i).b,cr=z3r,cl=
* z3l,nsum=1
              ceps_0=-c25z(i).ek0*(p136(2)*p4(3)-p4(2)*p136(3))+p136k0*(
     &          c25z(i).e(2)*p4(3)-p4(2)*c25z(i).e(3))-p4k0*(c25z(i).
     &          e(2)
     &          *p136(3)-p136(2)*c25z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c25z(i).e(3)*p4k0+p4(3)*c25z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c25z(i).e(0)*p136(0)-c25z(i).e(1)*p136(1)-c25z(i).e(2
     &          )*p136(2)-c25z(i).e(3)*p136(3)
              cvqd=c25z(i).e(0)*p4(0)-c25z(i).e(1)*p4(1)-c25z(i).e(2)*p4
     &          (2)-c25z(i).e(3)*p4(3)
              cauxa=-c25z(i).ek0*quqd+p136k0*cvqd+p4k0*cvqu
              cauxb=-c25z(i).ek0*p4(2)+p4k0*c25z(i).e(2)
              r4_25fz(i).a(1)=r4_25fz(i).a(1)+z3r*(cauxa+ceps_0)
              r4_25fz(i).a(2)=r4_25fz(i).a(2)+z3l*(cauxa-ceps_0)
              r4_25fz(i).b(1)=r4_25fz(i).b(1)+z3l*(cauxb-ceps_2)
              r4_25fz(i).b(2)=r4_25fz(i).b(2)+z3r*(-cauxb-ceps_2)
            END DO
**** attaccamento di c16f(2) a 4
* quqd -- p=p235,q=p4
            quqd=p235(0)*p4(0)-p235(1)*p4(1)-p235(2)*p4(2)-p235(3)*p4(
     &        3)
            DO i=1,2
* TR0 -- qu=p235,qd=p4,v=c16f(i).e,a=r4_16fz(i).a,b=r4_16fz(i).b,cr=f3r,cl=
* f3l,nsum=0
              ceps_0=-c16f(i).ek0*(p235(2)*p4(3)-p4(2)*p235(3))+p235k0*(
     &          c16f(i).e(2)*p4(3)-p4(2)*c16f(i).e(3))-p4k0*(c16f(i).
     &          e(2)
     &          *p235(3)-p235(2)*c16f(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c16f(i).e(3)*p4k0+p4(3)*c16f(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c16f(i).e(0)*p235(0)-c16f(i).e(1)*p235(1)-c16f(i).e(2
     &          )*p235(2)-c16f(i).e(3)*p235(3)
              cvqd=c16f(i).e(0)*p4(0)-c16f(i).e(1)*p4(1)-c16f(i).e(2)*p4
     &          (2)-c16f(i).e(3)*p4(3)
              cauxa=-c16f(i).ek0*quqd+p235k0*cvqd+p4k0*cvqu
              cauxb=-c16f(i).ek0*p4(2)+p4k0*c16f(i).e(2)
              r4_16fz(i).a(1)=f3r*(cauxa+ceps_0)
              r4_16fz(i).a(2)=f3l*(cauxa-ceps_0)
              r4_16fz(i).b(1)=f3l*(cauxb-ceps_2)
              r4_16fz(i).b(2)=f3r*(-cauxb-ceps_2)
            END DO
**** attaccamento di c16z(2) a 4
            DO i=1,2
* TR0 -- qu=p235,qd=p4,v=c16z(i).e,a=r4_16fz(i).a,b=r4_16fz(i).b,cr=z3r,cl=
* z3l,nsum=1
              ceps_0=-c16z(i).ek0*(p235(2)*p4(3)-p4(2)*p235(3))+p235k0*(
     &          c16z(i).e(2)*p4(3)-p4(2)*c16z(i).e(3))-p4k0*(c16z(i).
     &          e(2)
     &          *p235(3)-p235(2)*c16z(i).e(3))
              ceps_0=ceps_0*cim
              ceps_2=-c16z(i).e(3)*p4k0+p4(3)*c16z(i).ek0
              ceps_2=ceps_2*cim
              cvqu=c16z(i).e(0)*p235(0)-c16z(i).e(1)*p235(1)-c16z(i).e(2
     &          )*p235(2)-c16z(i).e(3)*p235(3)
              cvqd=c16z(i).e(0)*p4(0)-c16z(i).e(1)*p4(1)-c16z(i).e(2)*p4
     &          (2)-c16z(i).e(3)*p4(3)
              cauxa=-c16z(i).ek0*quqd+p235k0*cvqd+p4k0*cvqu
              cauxb=-c16z(i).ek0*p4(2)+p4k0*c16z(i).e(2)
              r4_16fz(i).a(1)=r4_16fz(i).a(1)+z3r*(cauxa+ceps_0)
              r4_16fz(i).a(2)=r4_16fz(i).a(2)+z3l*(cauxa-ceps_0)
              r4_16fz(i).b(1)=r4_16fz(i).b(1)+z3l*(cauxb-ceps_2)
              r4_16fz(i).b(2)=r4_16fz(i).b(2)+z3r*(-cauxb-ceps_2)
            END DO
**** Diagramma CN17 ****
            DO i2=1,2
              DO i5=1,2
* TLTR0 -- aa=cn17(&,i2,i5).id(ide),a1=l1_34fz(i5).a,c1=l1_34fz(i5).c,a2=r6
* _25fz(i2).a,b2=r6_25fz(i2).b,prq=p134q,den=(p134q*p134k0),nsum=0
                cn17(1,i2,i5).id(ide)=( l1_34fz(i5).a(1)*r6_25fz(i2).
     &            a(1)+
     &            l1_34fz(i5).c(1)*p134q*r6_25fz(i2).b(2) )
     &            /(p134q*p134k0)
                cn17(2,i2,i5).id(ide)=( l1_34fz(i5).c(2)
     &            *p134q*r6_25fz(i2)
     &            .b(1)+l1_34fz(i5).a(2)*r6_25fz(i2).a(2) )
     &            /(p134q*p134k0)
              END DO
            END DO
**** Diagramma CN18 ****
            DO i2=1,2
              DO i5=1,2
* TLTR0 -- aa=cn18(&,i2,i5).id(ide),a1=l1_25fz(i2).a,c1=l1_25fz(i2).c,a2=r6
* _34fz(i5).a,b2=r6_34fz(i5).b,prq=p125q,den=(p125q*p125k0),nsum=0
                cn18(1,i2,i5).id(ide)=( l1_25fz(i2).a(1)*r6_34fz(i5).
     &            a(1)+
     &            l1_25fz(i2).c(1)*p125q*r6_34fz(i5).b(2) )
     &            /(p125q*p125k0)
                cn18(2,i2,i5).id(ide)=( l1_25fz(i2).c(2)
     &            *p125q*r6_34fz(i5)
     &            .b(1)+l1_25fz(i2).a(2)*r6_34fz(i5).a(2) )
     &            /(p125q*p125k0)
              END DO
            END DO
**** Diagramma CN19 ****
            DO i1=1,2
              DO i5=1,2
* TLTR0 -- aa=cn19(i1,&,i5).id(ide),a1=l5_16fz(i1).a,c1=l5_16fz(i1).c,a2=r2
* _34fz(i5).a,b2=r2_34fz(i5).b,prq=p156q,den=(p156q*p156k0),nsum=0
                cn19(i1,1,i5).id(ide)=( l5_16fz(i1).a(1)*r2_34fz(i5).
     &            a(1)+
     &            l5_16fz(i1).c(1)*p156q*r2_34fz(i5).b(2) )
     &            /(p156q*p156k0)
                cn19(i1,2,i5).id(ide)=( l5_16fz(i1).c(2)
     &            *p156q*r2_34fz(i5)
     &            .b(1)+l5_16fz(i1).a(2)*r2_34fz(i5).a(2) )
     &            /(p156q*p156k0)
              END DO
            END DO
**** Diagramma CN20 ****
            DO i1=1,2
              DO i5=1,2
* TLTR0 -- aa=cn20(i1,&,i5).id(ide),a1=l5_34fz(i5).a,c1=l5_34fz(i5).c,a2=r2
* _16fz(i1).a,b2=r2_16fz(i1).b,prq=p345q,den=(p345q*p345k0),nsum=0
                cn20(i1,1,i5).id(ide)=( l5_34fz(i5).a(1)*r2_16fz(i1).
     &            a(1)+
     &            l5_34fz(i5).c(1)*p345q*r2_16fz(i1).b(2) )
     &            /(p345q*p345k0)
                cn20(i1,2,i5).id(ide)=( l5_34fz(i5).c(2)
     &            *p345q*r2_16fz(i1)
     &            .b(1)+l5_34fz(i5).a(2)*r2_16fz(i1).a(2) )
     &            /(p345q*p345k0)
              END DO
            END DO
**** Diagramma CN21 ****
            DO i1=1,2
              DO i2=1,2
* TLTR0 -- aa=cn21(i1,i2,&).id(ide),a1=l3_16fz(i1).a,c1=l3_16fz(i1).c,a2=r4
* _25fz(i2).a,b2=r4_25fz(i2).b,prq=p136q,den=(p136q*p136k0),nsum=0
                cn21(i1,i2,1).id(ide)=( l3_16fz(i1).a(1)*r4_25fz(i2).
     &            a(1)+
     &            l3_16fz(i1).c(1)*p136q*r4_25fz(i2).b(2) )
     &            /(p136q*p136k0)
                cn21(i1,i2,2).id(ide)=( l3_16fz(i1).c(2)
     &            *p136q*r4_25fz(i2)
     &            .b(1)+l3_16fz(i1).a(2)*r4_25fz(i2).a(2) )
     &            /(p136q*p136k0)
              END DO
            END DO
**** Diagramma CN22 ****
            DO i1=1,2
              DO i2=1,2
* TLTR0 -- aa=cn22(i1,i2,&).id(ide),a1=l3_25fz(i2).a,c1=l3_25fz(i2).c,a2=r4
* _16fz(i1).a,b2=r4_16fz(i1).b,prq=p235q,den=(p235q*p235k0),nsum=
                cn22(i1,i2,1).id(ide)=( l3_25fz(i2).a(1)*r4_16fz(i1).
     &            a(1)+
     &            l3_25fz(i2).c(1)*p235q*r4_16fz(i1).b(2) )
     &            /(p235q*p235k0)
                cn22(i1,i2,2).id(ide)=( l3_25fz(i2).c(2)
     &            *p235q*r4_16fz(i1)
     &            .b(1)+l3_25fz(i2).a(2)*r4_16fz(i1).a(2) )
     &            /(p235q*p235k0)
              END DO
            END DO

          ENDIF  !iid.eq.1.and.i34e.eq.1

        END DO !fine del do che prende tutte nc per particelle identiche
**** fine NC
      ENDIF

******************qui mettere le somme dei diagrammi********************

      IF(icoul.EQ.1.AND.(imix.EQ.1.OR.imix.EQ.2)) THEN
        app=(s-(sqrt(s36)-sqrt(s54))**2)*(s-(sqrt(s36)+sqrt(s54))**2)
        IF (app.LE.0.d0) THEN
          ee_4f=0.d0
          RETURN
        ENDIF
        betac=sqrt(app)/s
        delta=abs(s36-s54)/s
        app=(1.d0-4.d0*rmw2/s)**2+16.d0*rmw2*gamw**2/(s**2)
        IF (app.LT.0.d0) THEN
          ee_4f=0.d0
          RETURN
        ENDIF
        rk2=1.d0-4.d0*rmw2/s+sqrt(app)
        IF (rk2.LE.0.d0) THEN
          ee_4f=0.d0
          RETURN
        ENDIF
        rk2=sqrt(rmw2*rk2/2.d0)
        rk1=-1.d0+4.d0*rmw2/s+sqrt(app)
        IF (rk1.LE.0.d0) THEN
          ee_4f=0.d0
          RETURN
        ENDIF
        rk1=sqrt(rmw2*rk1/2.d0)
        cbetam=(rk2+cim*rk1)/sqrt(rmw2)
        fcoul=((cbetam+delta)*conjg(cbetam+delta)-betac**2)/
     &        (2.d0*betac*rk1/sqrt(rmw2))
        fcoul=(pi-2.d0*atan(fcoul))/(2.d0*betac*128.07d0)
      ENDIF

      IF (istrcor.EQ.1) THEN
        IF(i3q.EQ.1.AND.i5q.EQ.1)THEN
          fatcor_cc=(1.d0+2.d0*qcdcor_cc)/(1.d0+2.d0*qcdcor_nc)
          fatcor_nc=1.d0/(1.d0+2.d0*qcdcor_nc)
          fatcor_ccnc=(1.d0+qcdcor_cc+qcdcor_nc)/(1.d0+2.d0*qcdcor_nc)
        ELSE IF((i3q.EQ.1.AND.i5q.EQ.0).OR.(i3q.EQ.0.AND.i5q.EQ.1))THEN
          fatcor_cc=(1.d0+qcdcor_cc)/(1.d0+qcdcor_nc)
          fatcor_nc=1.d0/(1.d0+qcdcor_nc)
          fatcor_ccnc=(1.d0+0.5d0*(qcdcor_cc+qcdcor_nc))
     &                 /(1.d0+qcdcor_nc)
        ELSE
          fatcor_cc=1.d0
          fatcor_nc=1.d0
          fatcor_ccnc=1.d0
        ENDIF
      ELSE
        fatcor_cc=1.d0
        fatcor_nc=1.d0
        fatcor_ccnc=1.d0
      ENDIF

      res=0.d0

      DO i1=1,2
        IF (i3e.EQ.1.AND.(icc.EQ.1.OR.icc.EQ.-1)) then
          cc_3e(i1)=-cc7(i1)-cc8(i1)-cc9(i1)-cc10(i1)
     &              -cc11(i1)-cc12(i1)
        ENDIF
        IF (i4e.EQ.1.AND.(icc.EQ.1.OR.icc.EQ.-1)) then
          cc_4e(i1)=-cc13(i1)-cc14(i1)-cc15(i1)-cc16(i1)
     &              -cc17(i1)-cc18(i1)
        ENDIF
        IF (icc.EQ.0.OR.icc.EQ.-1) then
          DO i3=1,2
            DO i5=1,2
              DO ide=0,iid
                cn_4f(i1,i3,i5).id(ide)=cn1(i1,i3,i5).id(ide)
     &              +cn2(i1,i3,i5).id(ide)
     &              +cn3(i1,i3,i5).id(ide)+cn4(i1,i3,i5).id(ide)
     &              +cn5(i1,i3,i5).id(ide)+cn6(i1,i3,i5).id(ide)
                IF (i34e.EQ.1) THEN
                  cn_34e(i1,i3,i5).id(ide)=cn11(i1,i3,i5).id(ide)
     &                +cn12(i1,i3,i5).id(ide)
     &                +cn13(i1,i3,i5).id(ide)+cn14(i1,i3,i5).id(ide)
     &                +cn15(i1,i3,i5).id(ide)+cn16(i1,i3,i5).id(ide)
                  IF (iid.EQ.1) THEN
                    cn_56e(i1,i3,i5).id(ide)=cn17(i1,i5,i3).id(ide)
     &                  +cn18(i1,i5,i3).id(ide)+cn19(i1,i5,i3).id(ide)
     &                  +cn20(i1,i5,i3).id(ide)+cn21(i1,i5,i3).id(ide)
     &                  +cn22(i1,i5,i3).id(ide)
                  ENDIF
                ENDIF
                IF (i56ve.EQ.1.AND.i1.EQ.2.AND.i5.EQ.2) THEN
                  cn_56v(i3).id(ide)=cn23(i3).id(ide)+cn24(i3).id(ide)
     &                +cn25(i3).id(ide)+cn26(i3).id(ide)
     &                +cn27(i3).id(ide)
                  IF (i3.EQ.2) THEN
                    cn_56v(i3).id(ide)=cn_56v(i3).id(ide)+cn28.id(ide)
                  ENDIF
                  IF (iid.EQ.1) THEN
                    cn_34v(i3).id(ide)=cn29(i3).id(ide)
     &                  +cn30(i3).id(ide)+cn31(i3).id(ide)
     &                  +cn32(i3).id(ide)+cn33(i3).id(ide)
                    IF (i3.EQ.2) THEN
                      cn_34v(i3).id(ide)=cn_34v(i3).id(ide)
     &                                    +cn34.id(ide)
                    ENDIF
                  ENDIF !i56ve e iid
                ENDIF !i56ve
                IF (iqu.EQ.1) THEN
                  cn_qcd(i1,i3,i5).id(ide)=cn7(i1,i3,i5).id(ide)
     &                +cn8(i1,i3,i5).id(ide)+cn9(i1,i3,i5).id(ide)
     &                +cn10(i1,i3,i5).id(ide)
                ENDIF
              ENDDO !ide
            ENDDO !i5
          ENDDO !i3
        ENDIF
      ENDDO !i1

      DO i1=1,2
        DO i3=1,2
          DO i5=1,2
            IF ((icc.EQ.1.OR.icc.EQ.-1).and.(i3.eq.2.and.i5.eq.2)) then
              cres=cc1(i1)
              IF (i1.EQ.2) THEN
                cres=cres+cc2(2)
              ENDIF
              IF (icoul.EQ.1.AND.(imix.EQ.1.OR.imix.EQ.2)) THEN
                res=res+fcoul*(dreal(cres)**2+dimag(cres)**2)*fatcor_cc
              ENDIF
              IF (icc3.EQ.0) THEN
                cres=cres+cc3(i1)+cc4(i1)+cc5(i1)+cc6(i1)
              ENDIF
              IF (i3e.EQ.1.AND.i1.EQ.2) THEN
                cres=cres+cc_3e(2)
              ENDIF
              IF (i4e.EQ.1.AND.i1.EQ.2) THEN
                cres=cres+cc_4e(2)
              ENDIF
              IF (imix.EQ.1.OR.imix.EQ.2) THEN
                res=res+(dreal(cres)**2+dimag(cres)**2)*fatcor_cc
                IF (i1.EQ.1.AND.i3e.EQ.1) THEN
                  res=res+cc_3e(1)*conjg(cc_3e(1))*fatcor_cc
                ENDIF
                IF (i1.EQ.1.AND.i4e.EQ.1) THEN
                  res=res+cc_4e(1)*conjg(cc_4e(1))*fatcor_cc
                ENDIF
              ENDIF !imix=1-2
            ENDIF !( solo CC )
            IF (icc.EQ.0.OR.icc.EQ.-1) then
              cres1=-cn_4f(i1,i3,i5).id(0)
              IF (i34e.EQ.1.AND.i1.EQ.i3) THEN
                cres1=cres1+cn_34e(i1,i3,i5).id(0)
              ENDIF
              IF (i56ve.EQ.1.AND.i1.EQ.2.AND.i5.EQ.2) THEN
                IF ((icc.EQ.0).OR.(icc.EQ.-1.and.i3.eq.2)) then
                  cres1=cres1+cn_56v(i3).id(0)
                  IF (iid.EQ.1) THEN
                    cres1=cres1+cn_34v(i3).id(0)
                  ENDIF
                ENDIF
              ENDIF !i56ve
              IF (i34e.EQ.1.AND.iid.EQ.1.AND.i1.EQ.i5) THEN
                cres1=cres1+cn_56e(i1,i3,i5).id(0)
              ENDIF
              IF (imix.EQ.-1.and.iid.eq.1)then
                res=res+2.d0*dreal(cres1)**2+2.d0*dimag(cres1)**2
              ELSE IF (imix.EQ.-2.or.imix.eq.-1) then
                res=res+dreal(cres1)**2+dimag(cres1)**2
              ENDIF
              IF (iqu.EQ.1) THEN
                rc=2.d0/9.d0
                IF (iid.EQ.1.AND.imix.EQ.-1) then
                  res=res+2.d0*rc*(qcdcoupl**2)*cn_qcd(i1,i3,i5).id(0)
     &                   *conjg(cn_qcd(i1,i3,i5).id(0))*fatcor_nc
                ELSE IF (imix.EQ.-2.or.imix.eq.-1) then
                  res=res+rc*(qcdcoupl**2)*cn_qcd(i1,i3,i5).id(0)
     &                   *conjg(cn_qcd(i1,i3,i5).id(0))*fatcor_nc
                ENDIF
              ENDIF
              IF (i34e.EQ.1.AND.i1.NE.i3) THEN
                IF (iid.EQ.1.AND.imix.EQ.-1) then
                  res=res+2.d0*cn_34e(i1,i3,i5).id(0)
     &                   *conjg(cn_34e(i1,i3,i5).id(0))
                ELSE IF (imix.EQ.-2.or.imix.eq.-1) then
                  res=res+cn_34e(i1,i3,i5).id(0)
     &                   *conjg(cn_34e(i1,i3,i5).id(0))
                ENDIF
              ENDIF
              IF (icc.EQ.0.AND.iid.EQ.1.AND.i34e.EQ.1.AND.i1.NE.i5) THEN
                res=res+2.d0*cn_56e(i1,i3,i5).id(0)
     &                 *conjg(cn_56e(i1,i3,i5).id(0))
              ENDIF
              IF (icc.EQ.-1) then
                IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
                  rc=1.d0/3.d0
                ELSE
                  rc=1.d0
                ENDIF
                IF (i56ve.EQ.1.AND.i1.EQ.2.AND.i3.EQ.1.AND.i5.EQ.2) THEN
                  IF (iid.EQ.1.AND.imix.EQ.-1) then
                    res=res-2.d0*(cn_4f(i1,i3,i5).id(0)
     &                     *conjg(cn_56v(i3).id(0))+cn_56v(i3).id(0)
     &                     *conjg(cn_4f(i1,i3,i5).id(0))
     &                     -cn_56v(i3).id(0)*conjg(cn_56v(i3).id(0)))
                  ELSE IF (imix.EQ.-2.or.imix.eq.-1) then
                    res=res-cn_4f(i1,i3,i5).id(0)*conjg(cn_56v(i3).
     &                id(0))
     &                -cn_56v(i3).id(0)*conjg(cn_4f(i1,i3,i5).id(0))
     &                +cn_56v(i3).id(0)*conjg(cn_56v(i3).id(0))
                  ENDIF
                ENDIF
              ENDIF !( fine NC )
              IF (imix.EQ.2.OR.imix.EQ.0.OR.imix.EQ.-2) then
                IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
                  rc=1.d0/3.d0
                ELSE
                  rc=1.d0
                ENDIF
                IF (i3.EQ.2.AND.i5.EQ.2) THEN
                  res=res+rc*(cres*conjg(cres1)+cres1*conjg(cres))
     &                   *fatcor_ccnc
                ENDIF
                IF (iqu.EQ.1.AND.i3.EQ.2.AND.i5.EQ.2) THEN
                  rc1=4.d0/9.d0
                  res=res-rc1*qcdcoupl*(cres*conjg(cn_qcd(i1,i3,i5).
     &              id(0))+cn_qcd(i1,i3,i5).id(0)*conjg(cres))*fatcor_nc
                ENDIF
                IF (i1.EQ.2.AND.i3.EQ.1.AND.i5.EQ.2.
     &              AND.i3e.EQ.1.AND.i34e.EQ.1) THEN
                  res=res+(cn_34e(i1,i3,i5).id(0)*conjg(cc_3e(i3))
     &                   +cc_3e(i3)*conjg(cn_34e(i1,i3,i5).id(0)))*
     &                   *fatcor_ccnc
                ENDIF
                IF (i1.EQ.1.AND.i3.EQ.2.AND.i5.EQ.2.
     &              AND.i34e.EQ.1.AND.i4e.EQ.1) THEN
                  res=res+(cn_34e(i1,i3,i5).id(0)*conjg(cc_4e(i1))
     &                   +cc_4e(i1)*conjg(cn_34e(i1,i3,i5).id(0)))*
     &                   fatcor_ccnc
                ENDIF
              ENDIF ! fine interferenze NC+CC

              IF (icc.EQ.0.AND.iid.EQ.1) THEN
                IF (i3.EQ.i5) THEN
                  IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
                    rc=1.d0/3.d0
                  ELSE
                    rc=1.d0
                  ENDIF
                  res=res-rc*(cn_4f(i1,i3,i5).id(0)
     &                   *conjg(cn_4f(i1,i3,i5).id(1))+cn_4f(i1,i3,i5).
     &                   id(1)*conjg(cn_4f(i1,i3,i5).id(0)))
                  IF (iqu.EQ.1) THEN
                    rc1=2.d0/27.d0
                    rc2=4.d0/9.d0
                    res=res+(qcdcoupl**2)*rc1*(cn_qcd(i1,i3,i5).id(0)
     &                 *conjg(cn_qcd(i1,i3,i5).id(1))+cn_qcd(i1,i3,i5).
     &                 id(1)*conjg(cn_qcd(i1,i3,i5).id(0)))-rc2*qcdcoupl
     &                 *(cn_qcd(i1,i3,i5).id(0)*conjg(cn_4f(i1,i3,i5).
     &                 id(1))+cn_4f(i1,i3,i5).id(1)
     &                 *conjg(cn_qcd(i1,i3,i5).id(0)))*fatcor_nc
                  ENDIF
                  IF (i34e.EQ.1) THEN
                    res=res-cn_34e(i1,i3,i5).id(0)*
     &                  conjg(cn_34e(i1,i3,i5).id(1))-cn_34e(i1,i3,i5).
     &                  id(1)*conjg(cn_34e(i1,i3,i5).id(0))
     &                  -cn_56e(i1,i3,i5).id(0)*conjg(cn_56e(i1,i3,i5).
     &                  id(1))-cn_56e(i1,i3,i5).id(1)*
     &                  conjg(cn_56e(i1,i3,i5).id(0))
                  ENDIF
                ENDIF
                IF (i34e.EQ.1.AND.i1.EQ.i5) THEN
                  res=res-2.d0*cn_34e(i1,i3,i5).id(0)
     &                   *conjg(cn_56e(i1,i5,i3).id(1))-2.d0*cn_56e
     &                   (i1,i5,i3).id(1)*conjg(cn_34e(i1,i3,i5).id(0))
                ENDIF
                IF (i34e.EQ.1.AND.i1.EQ.i3.AND.i1.EQ.i5) THEN
                  res=res+2.d0*cn_4f(i1,i3,i5).id(0)
     &                   *conjg(cn_34e(i1,i3,i5).id(1))
     &                   +2.d0*cn_34e(i1,i3,i5).id(1)
     &                   *conjg(cn_4f(i1,i3,i5).id(0))
     &                   +2.d0*cn_4f(i1,i3,i5).id(0)
     &                   *conjg(cn_56e(i1,i3,i5).id(1))
     &                   +2.d0*cn_56e(i1,i3,i5).id(1)
     &                   *conjg(cn_4f(i1,i3,i5).id(0))
                ENDIF
                IF (i56ve.EQ.1.AND.i1.EQ.2.AND.i3.EQ.2.AND.i5.EQ.2) THEN
                  res=res-cn_56v(2).id(1)*conjg(cn_56v(2).id(0))
     &                   -cn_56v(2).id(0)*conjg(cn_56v(2).id(1))
     &                   -cn_34v(2).id(1)*conjg(cn_34v(2).id(0))
     &                   -cn_34v(2).id(0)*conjg(cn_34v(2).id(1))
     &                   -2.d0*cn_56v(2).id(0)*conjg(cn_34v(2).id(1))
     &                   -2.d0*cn_34v(2).id(1)*conjg(cn_56v(2).id(0))
     &                   +2.d0*cn_4f(2,2,2).id(0)*conjg(cn_56v(2).id(1))
     &                   +2.d0*cn_4f(2,2,2).id(0)*conjg(cn_34v(2).id(1))
     &                   +2.d0*cn_56v(2).id(1)*conjg(cn_4f(2,2,2).id(0))
     &                   +2.d0*cn_34v(2).id(1)*conjg(cn_4f(2,2,2).id(0))
                ENDIF !i56ve
              ENDIF !iid=1
            ENDIF ! fine CC + NC
          ENDDO !i5
        ENDDO !i3
      ENDDO !i1

      IF (iid.EQ.1) THEN
        rden=16.d0
      ELSE
        rden=4.d0
      ENDIF
      IF (i3q.EQ.0.AND.i5q.EQ.0) THEN
        rc=1.d0
      ELSE IF ((i3q.EQ.1.AND.i5q.EQ.0).OR.
     &        (i3q.EQ.0.AND.i5q.EQ.1)) THEN
        rc=3.d0
      ELSE IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
        rc=9.d0
      ENDIF

      ee_4f=rc*res/p1k0/p2k0/p3k0/p4k0/p5k0/p6k0/rden

      IF (istrcor.EQ.1) THEN
        IF ((i3q.EQ.1.AND.i5q.EQ.0).OR.(i3q.EQ.0.AND.i5q.EQ.1)) THEN
          ee_4f=ee_4f*(1.d0+qcdcor_nc)
        ELSE IF (i3q.EQ.1.AND.i5q.EQ.1) THEN
          ee_4f=ee_4f*(1.d0+2.d0*qcdcor_nc)
        ENDIF
      ENDIF

      RETURN
      END
